#ifndef _PROTO_POSTMASTER_H_
#define _PROTO_POSTMASTER_H_
#include <stdio.h>
#include <stdlib.h>
#include <config.h>
#ifdef HAVE_STDARG_H
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <pm.h>
#ifdef HAVE_STDARG_H
extern void *pm ( int operation, ... );
#else
#ifdef __GNUC__
extern void *pm (int __builtin_va_alist,...);
#else
extern void *pm();
#endif
#endif
extern int valid_op (int operation);
extern void pm_set_error (int error_code, char *called_by);
extern int pm_get_error (int op, char *addr);
extern int pm_access (int operation, char *label, va_list *pargptr, int *pdata_type);
extern int i_list_rw (int operation, int **varb_ptr, int *list_dim, va_list *argptr, int *pdata_type);
extern int d_list_rw (int operation, double **varb_ptr, int *list_dim, va_list *argptr, int *pdata_type);
extern int i_rw (int operation, int *value, va_list *argptr, int *pdata_type);
extern int d_rw (int operation, double *value, va_list *argptr, int *pdata_type);
extern int c_list_rw (int operation, char ***varb_ptr, int *list_dim, int *item_length, va_list *argptr, int *pdata_type);
extern int mem_ptr_rw (int operation, void **varb_ptr, va_list *argptr, int *pdata_type);
extern int addr_rw (int operation, void **varb_ptr, va_list *argptr, int *pdata_type);
extern int c_rw (int operation, char **varb_ptr, int *item_length, va_list *argptr, int *pdata_type);
extern int imax_nonneg (int arg1, int arg2);
extern int pm_savable_rw (int operation, int *value_ptr, va_list *argptr);
extern int pm_exists_entry (char *label);
extern int pm_entry_exists (char *label);
extern int pm_add_object (char *name);
extern int pm_delete_object (char *name); 
extern int pm_add_element (char *name, int type);
extern int pm_rm_element (char *name);
extern int pm_dealloc_elem (char *name);
extern int pm_fnct_exec (char *name);
extern int pm_valid_obj_name (char *name);
extern int pm_valid_elmt_name (char *name);
extern int pm_split_name (char *name, char *obj_name, char *elemt_name);
extern int pm_name_components (char *name, char *name_copy, char **cmpt_endpt, int *num_cmpt_p);
extern int pm_name_separators (char *name, char **cmpt_endpt, int *num_cmpt_p);
extern int pm_init (void); 
extern struct pm_list *pm_hash_lookup (char *label); 
extern struct pm_list *pm_hash_add (char *label); 
extern int pm_hash_rm (char *label); 
extern unsigned int pm_get_hash (char *label); 
extern void pm_hash_dump (void); 
extern void pm_dump (void); 
extern int pm_type (char *element, int *n, int *len);
extern int *i_varb_ptr; 
extern double *d_varb_ptr; 
extern char *c_varb_ptr;  
extern void *addr_ptr;  
#endif
