/*  -------------------------------------------------------------------

This program is the property of:

                             Cornell University 
                        Center for Applied Mathematics 
                              Ithaca, NY 14853

and may be used, modified and distributed freely, subject to the 
following restrictions:

       Any product which incorporates source code from the dstool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.

DsTool is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of FITNESS 
FOR A PARTICULAR PURPOSE.  The software is provided as is without 
any obligation on the part of Cornell faculty, staff or students to 
assist in its use, correction, modification or enhancement.

  -----------------------------------------------------------------  */
#ifndef	autoif_HEADER
#define	autoif_HEADER

extern Attr_attribute	INSTANCE;

typedef struct {
	Xv_opaque	coautord;
	Xv_opaque	coautocntl;
	Xv_opaque	coarinfo;
	Xv_opaque	coaradd;
	Xv_opaque	coargo;
	Xv_opaque	coartype;
	Xv_opaque	coarmode;
	Xv_opaque	coarcurblk;
	Xv_opaque	coaritp;
	Xv_opaque	coarsh;
	Xv_opaque	coaraatm;
	Xv_opaque	coaribr;
	Xv_opaque	coarntpl;
	Xv_opaque	coarntot;
	Xv_opaque	coarnar;
	Xv_opaque	coarlab;
	Xv_opaque	coarntst;
	Xv_opaque	coarnfpar;
	Xv_opaque	coarncol;
	Xv_opaque	coarisw;
	Xv_opaque	coarnpar;
	Xv_opaque	coartblks;
	Xv_opaque	coardir;
	Xv_opaque	coarfile;
	Xv_opaque	coarftype;
} autoif_coautord_objects;

extern void autoif_open (int use_default, int left, int top, int width, int height);
extern void autoif_close (void);
extern int autoif_field_manager (void);
extern int autoif_init (void);
extern void autoif_panel_refresh (void);
extern void autoif_data_refresh (void);
extern void autoif_rd_curblk (void);
extern Menu_item autoif_handler (Menu_item item, Menu_generate op);
extern int open_auto_file (void);
extern int close_auto_file (void);
extern int auto_rdblock_id (int block_number);
extern int auto_rdblock (void);
extern int autoif_mem_manage (int operation);
extern void autoif_dump_blk (void);
extern void autoif_init_mem (void);
extern int autoif_add_pt (void);
extern void coarinfo_notify (Panel_item item, Event *event);
extern void coaradd_notify (Panel_item item, Event *event);
extern void coargo_notify (Panel_item item, Event *event);
extern void autoif_coautord_coartype_notify_callback (Panel_item item, unsigned int value, Event *event);
extern void autoif_coautord_coarmode_notify_callback (Panel_item item, int value, Event *event);
extern Panel_setting coarrw (Panel_item item, Event *event);
extern void autoif_coautord_coarsh_notify_callback (Panel_item item, int value, Event *event);
extern void autoif_coautord_coarftype_notify_callback (Panel_item item, int value, Event *event);
extern void autoif_coautord_coaraatm_notify_callback (Panel_item item, int value, Event *event);
extern void autoif_done_proc (Frame frame);

extern autoif_coautord_objects *autoif_coautord_objects_initialize (autoif_coautord_objects *ip, Xv_opaque owner);

extern Xv_opaque autoif_coautord_coautord_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coautocntl_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coarinfo_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coaradd_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coargo_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coartype_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coarmode_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coarsh_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coaraatm_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_coarftype_create (autoif_coautord_objects *ip, Xv_opaque owner);
extern Xv_opaque autoif_coautord_wr_create (autoif_coautord_objects *ip, Xv_opaque owner, char *label, int x, int y, int length, int show_line, int access_mode);

#endif
