/* decomp.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void decomp_(shortint *ndim, shortint *n, doublereal *a, doublereal *cond, shortint *ipvt, doublereal *work)
{
    /* System generated locals */
    int s__1, s__2, s__3;
    integer a_dim1, a_offset;
    doublereal d__1, d__2;

    /* Local variables */
    int i, j, k, m;
    doublereal t, anorm;
    doublereal ynorm, znorm;
    int kb;
    doublereal ek;
    int km1, nm1, kp1;

/*     3.05.90. */
/*     POPAMMA BCET PAOEHE BEECTBEHHO */
/*     MATP OCPECTBOM ACCOBA CKEH */
/*     OEHBAET OCOBEHHOCT MATP. */

/*     (POPAMMA OCAHA B KHE: */
/*           .OPCAT, M.MAKOM, K.MOEP */
/*          "MAHHE METO MATEMATECKX BCEH". */
/*           M.:MP,1980) */

/*     OHA COETC  BCEH PEEH HEHX */
/*     CCTEM. */

/*     BXOHA HOPMA... */

/*       NDIM=ABEHHA CTPOHA PAMEPHOCT MACCBA, */
/*       COEPAEO A. */

/*       N=OPOK MATP. */

/*       A=MATPA, KOTOP HHO PAOT. */

/*     BXOHA HOPMA... */

/*       A COEPT BEPXH TPEOH MATP U */
/*          TBA EPECTAHOBK BEPC */
/*         HHE TPEOHO MATP 1-L, TAKE, */
/*         TO (MATPA EPECTAHOBOK) *A=L*U */

/*     COND=OEHKA OCOBEHHOCT A. */
/*         HEHO CCTEM A*X=B MEHEH */
/*        B A  B MOT BBAT MEHEH B X, OE */
/*        B COND PA. EC COND+1.0 .EQ. COND, TO A */
/*        B PEEAX MAHHO TOHOCT BETC */
/*        BPOEHHO MATPE. COND OAAETC */
/*        PABHM 1.0E+32, EC OHAPEHA TOHA */
/*        BPOEHHOCT. */

/*     IPVT=BEKTOP BEX EMEHTOB. */
/*        IPVT(K)=HEKC K-BEE CTPOK */
/*        IPVT(N)=(-1)**(CO EPECTAHOBOK) */

/*     PAOEE OE..BEKTOP WORK OEH T OCAH */
/*              BKEH B BB. EO BXOHOE COEP- */
/*             AHE OHO HE AET BAHO HOP- */
/*             MA. */

/*     OPEETE MATP A MOET T OEH */
/*     HA BXOE O OPME */
/*        DET(A)=IPVT(N)*A(1,1)*A(2,2)*...*A(N,N). */




    /* Parameter adjustments */
    --work;
    --ipvt;
    a_dim1 = *ndim;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    ipvt[*n] = 1;
    if (*n == 1) {
	goto L80;
    }
    nm1 = *n - 1;

/*     BCT 1-HOPM MATP A. */

    anorm = 0.;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	t = 0.;
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    t += (d__1 = a[i + j * a_dim1], fabs(d__1));
/* L5: */
	}
	if (t > anorm) {
	    anorm = t;
	}
/* L10: */
    }

/*     ACCOBO CKEHE C ACTHM BOPOM BE- */
/*     EO EMEHTA. */

    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;

/*     HAT BE EMEHT. */

	m = k;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    if ((d__1 = a[i + k * a_dim1], fabs(d__1)) > (d__2 = a[m + k * 
		    a_dim1], fabs(d__2))) {
		m = i;
	    }
/* L15: */
	}
	ipvt[k] = m;
	if (m != k) {
	    ipvt[*n] = -ipvt[*n];
	}
	t = a[m + k * a_dim1];
	a[m + k * a_dim1] = a[k + k * a_dim1];
	a[k + k * a_dim1] = t;

/*     POCTT TOT A, EC BE EMEHT */
/*     PABEH H. */

	if (t == 0.) {
	    goto L35;
	}

/*     BCT MHOTE. */

	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    a[i + k * a_dim1] = -a[i + k * a_dim1] / t;
/* L20: */
	}

/*     EPECTABT  CKAT O CTOAM. */

	s__2 = *n;
	for (j = kp1; j <= s__2; ++j) {
	    t = a[m + j * a_dim1];
	    a[m + j * a_dim1] = a[k + j * a_dim1];
	    a[k + j * a_dim1] = t;
	    if (t == 0.) {
		goto L30;
	    }
	    s__3 = *n;
	    for (i = kp1; i <= s__3; ++i) {
		a[i + j * a_dim1] += a[i + k * a_dim1] * t;
/* L25: */
	    }
L30:
	    ;
	}
L35:
	;
    }

/*     COND=(1-HOPMA MATP A)*(OEHKA  1-HOPM */
/*           MATP, OPATHO K A) */
/*     OEHKA OAETC OCPECTBOM OHOO AA ME- */
/*     TOA OPATHX TEPA  HAMEHEO CH- */
/*     PHOO BEKTOPA. TO TPEET PEEH BX */
/*     CCTEM PABHEH, (TPAHCOHPOBAHHA  A)*Y=E */
/*     I A*Z=Y, E E-BEKTOP  +1  -1, BPAHH TAK, */
/*     TO MAKCMPOBAT BEH Y. */
/*     ESTIMATE=(1-HOPMA Z)/(1-HOPMA Y) */

/*     PET CCTEM (TPAHCOHPOBAHHA  A)*Y=E */

    s__1 = *n;
    for (k = 1; k <= s__1; ++k) {
	t = 0.;
	if (k == 1) {
	    goto L45;
	}
	km1 = k - 1;
	s__2 = km1;
	for (i = 1; i <= s__2; ++i) {
	    t += a[i + k * a_dim1] * work[i];
/* L40: */
	}
L45:
	ek = 1.;
	if (t < 0.) {
	    ek = -1.;
	}
	if (a[k + k * a_dim1] == 0.) {
	    goto L90;
	}
	work[k] = -(ek + t) / a[k + k * a_dim1];
/* L50: */
    }
    s__1 = nm1;
    for (kb = 1; kb <= s__1; ++kb) {
	k = *n - kb;
	t = 0.;
	kp1 = k + 1;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    t += a[i + k * a_dim1] * work[k];
/* L55: */
	}
	work[k] = t;
	m = ipvt[k];
	if (m == k) {
	    goto L60;
	}
	t = work[m];
	work[m] = work[k];
	work[k] = t;
L60:
	;
    }

    ynorm = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	ynorm += (d__1 = work[i], fabs(d__1));
/* L65: */
    }

/*     PET CCTEM A*Z=Y */

    solve_(ndim, n, &a[a_offset], &work[1], &ipvt[1]);

    znorm = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	znorm += (d__1 = work[i], fabs(d__1));
/* L70: */
    }

/*     OEHT OCOBEHHOCT */

    *cond = anorm * znorm / ynorm;
    if (*cond < 1.) {
	*cond = 1.;
    }
    return;

/*     CA MATP 1:1. */

L80:
    *cond = 1.;
    if (a[a_dim1 + 1] != 0.) {
	return;
    }

/*     TOHA BPOEHHOCT. */

L90:
    *cond = 1e64;
    return;
} /* decomp_ */

