/* detbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void detbf_(doublereal *a, shortint *n, doublereal *d)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    doublereal d__1;

    /* Local variables */
    doublereal biga, hold;
    shortint i, j, k, l, m;
    doublereal r;
    shortint ij, ki, ji, kk;
    doublereal ds;
    shortint jk, nk, jp, ik, kj, iz;


/*   COMPUTE DETERMINANT BY GAUSSIAN METHOD  WITH ELIMINATION */
/*     OVER ALL MATRIX. THE DETERMINANT IS LOGARITHMICALLY */
/*     SCALED TO AVOID OVERFLOWS AND ABNORMALLY BIG VALUES. */
/*     LET DET IS A DETERMINANT, THEN RESULTING VALUE D EQUALS */
/*       D={ DET, IF FABS(DET)<=1, */
/*         { SIGN(DET)*(1+LOG(FABS(DET))), OTHERWISE. */

/*            VERSION  24.04.1990 */
/*                     17.11.92 */

/*   THIS IS ADAPTATION OF SUBROUTINE DMINV FROM SSP LIBRARY */

/*   FORMAL PARAMETERS: */
/*     A    - N*N MATRIX */
/*     N    - THE ORDER OF MATRIX A */
/*     D    - OUTPUT VALUE OF SCALED DETERMINANT */

    /* Parameter adjustments */
    --a;

    /* Function Body */
    r = 0.;
    *d = 1.;
    ds = 1.;
    nk = -(*n);
    s__1 = *n;
    for (k = 1; k <= s__1; ++k) {
	nk += *n;
	l = k;
	m = k;
	kk = nk + k;
	biga = a[kk];
	s__2 = *n;
	for (j = k; j <= s__2; ++j) {
	    iz = *n * (j - 1);
	    s__3 = *n;
	    for (i = k; i <= s__3; ++i) {
		ij = iz + i;
/* L10: */
		if (fabs(biga) - (d__1 = a[ij], fabs(d__1)) >= 0.) {
		    goto L20;
		} else {
		    goto L15;
		}
L15:
		biga = a[ij];
		l = i;
		m = j;
L20:
		;
	    }
	}
	j = l;
	if (j - k <= 0) {
	    goto L35;
	} else {
	    goto L25;
	}
L25:
	ki = k - *n;
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    ki += *n;
	    hold = -a[ki];
	    ji = ki - k + j;
	    a[ki] = a[ji];
/* L30: */
	    a[ji] = hold;
	}
L35:
	i = m;
	if (i - k <= 0) {
	    goto L45;
	} else {
	    goto L38;
	}
L38:
	jp = *n * (i - 1);
	s__3 = *n;
	for (j = 1; j <= s__3; ++j) {
	    jk = nk + j;
	    ji = jp + j;
	    hold = -a[jk];
	    a[jk] = a[ji];
/* L40: */
	    a[ji] = hold;
	}
L45:
	if (biga != 0.) {
	    goto L48;
	} else {
	    goto L46;
	}
L46:
	*d = 0.;
	return;
L48:
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    if (i - k != 0) {
		goto L50;
	    } else {
		goto L55;
	    }
L50:
	    ik = nk + i;
	    a[ik] /= -biga;
L55:
	    ;
	}
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    ik = nk + i;
	    hold = a[ik];
	    ij = i - *n;
	    s__2 = *n;
	    for (j = 1; j <= s__2; ++j) {
		ij += *n;
		if (i - k != 0) {
		    goto L60;
		} else {
		    goto L65;
		}
L60:
		if (j - k != 0) {
		    goto L62;
		} else {
		    goto L65;
		}
L62:
		kj = ij - i + k;
		a[ij] = hold * a[kj] + a[ij];
L65:
		;
	    }
	}
	kj = k - *n;
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
	    kj += *n;
	    if (j - k != 0) {
		goto L70;
	    } else {
		goto L75;
	    }
L70:
	    a[kj] /= biga;
L75:
	    ;
	}
/*      IF (DFABS(D).GE.1.D10) THEN */
/* 	 D=1.D10 */
/* 	 RETURN */
/*      ENDIF */
	*d *= fabs(biga);
/*      R=R+DLOG(DFABS(BIGA)) */
	if (biga < 0.) {
	    ds = -ds;
	}
/* L80: */
	a[kk] = 1. / biga;
    }
/*      IF (R.LE.0.) D=DEXP(R) */
/*      IF (R.GT.0.) D=R+1.D0 */
/*      WRITE (*,*) '  D=',D */
    *d *= ds;
/* L150: */
    return;
} /* detbf_ */

