/* dhqr.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dhqr_(shortint *nm, shortint *n, shortint *low, shortint *igh, doublereal *h, doublereal *wr, doublereal *wi, shortint *ierr)
{
    /* System generated locals */
    int s__1, s__2;
    integer h_dim1, h_offset, i__1, i__2;
    doublereal d__1, d__2, d__3;


    /* Local variables */
    int i, j, k, l, m;
    doublereal p, q, r, s, t, w, x, y, anorm;
    int na, en, ll, mm;
    doublereal machep, zz;
    logical notlas;
    int mp2, its, enm2;


/*     this subroutine is a translation of the algol procedure hqr, */
/*     num. math. 14, 219-231(1970) by martin, peters, and wilkinson. */
/*     handbook for auto. comp., vol.ii-linear algebra, 359-371(1971). */

/*     this subroutine finds the eigenvalues of a real */
/*     upper hessenberg matrix by the qr method. */

/*     on input */

/*        nm must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        n is the order of the matrix. */

/*        low and igh are integers determined by the balancing */
/*          subroutine  balanc.  if  balanc  has not been used, */
/*          set low=1, igh=n. */

/*        h contains the upper hessenberg matrix.  information about */
/*          the transformations used in the reduction to hessenberg */
/*          form by  elmhes  or  orthes, if performed, is stored */
/*          in the remaining triangle under the hessenberg matrix. */

/*     on output */

/*        h has been destroyed.  therefore, it must be saved */
/*          before calling  hqr  if subsequent calculation and */
/*          back transformation of eigenvectors is to be performed. */

/*        wr and wi contain the real and imaginary parts, */
/*          respectively, of the eigenvalues.  the eigenvalues */
/*          are unordered except that complex conjugate pairs */
/*          of values appear consecutively with the eigenvalue */
/*          having the positive imaginary part first.  if an */
/*          error exit is made, the eigenvalues should be correct */
/*          for indices ierr+1,...,n. */

/*        ierr is set to */
/*          zero       for normal return, */
/*          j          if the limit of 30*n iterations is exhausted */
/*                     while the j-th eigenvalue is being sought. */

/*     questions and comments should be directed to burton s. garbow, */
/*     mathematics and computer science div, argonne national laboratory 
*/

/*     this version dated august 1983. */

/*     ------------------------------------------------------------------ 
*/

/*     adaptation to double precision at Inst.Appl. Math., USSR Acad. Sci.
 */
/*     ------------------------------------------------------------------ 
*/

/*     **********MACHEP - machine-dependent constant******** */

    /* Parameter adjustments */
    --wi;
    --wr;
    h_dim1 = *nm;
    h_offset = h_dim1 + 1;
    h -= h_offset;

    /* Function Body */
    machep = 1.1102230246251565e-16;

    *ierr = 0;
    anorm = 0.;
    k = 1;
/*     .......... store roots isolated by balanc */
/*                and compute matrix norm .......... */
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {

	s__2 = *n;
	for (j = k; j <= s__2; ++j) {
/* L40: */
	    anorm += (d__1 = h[i + j * h_dim1], fabs(d__1));
	}

	k = i;
	if (i >= *low && i <= *igh) {
	    goto L50;
	}
	wr[i] = h[i + i * h_dim1];
	wi[i] = 0.;
L50:
	;
    }

    en = *igh;
    t = 0.;
/*     .......... search for next eigenvalues .......... */
L60:
    if (en < *low) {
	goto L1001;
    }
    its = 0;
    na = en - 1;
    enm2 = na - 1;
/*     .......... look for single small sub-diagonal element */
/*                for l=en step -1 until low do -- .......... */
L70:
    s__1 = en;
    for (ll = *low; ll <= s__1; ++ll) {
	l = en + *low - ll;
	if (l == *low) {
	    goto L100;
	}
	s = (d__1 = h[l - 1 + (l - 1) * h_dim1], fabs(d__1)) + (d__2 = h[l + l 
		* h_dim1], fabs(d__2));
	if (s == 0.) {
	    s = anorm;
	}
	if ((d__1 = h[l + (l - 1) * h_dim1], fabs(d__1)) <= machep * s) {
	    goto L100;
	}
/* L80: */
    }
/*     .......... form shift .......... */
L100:
    x = h[en + en * h_dim1];
    if (l == en) {
	goto L270;
    }
    y = h[na + na * h_dim1];
    w = h[en + na * h_dim1] * h[na + en * h_dim1];
    if (l == na) {
	goto L280;
    }
    if (its == 30) {
	goto L1000;
    }
    if (its != 10 && its != 20) {
	goto L130;
    }
/*     .......... form exceptional shift .......... */
    t += x;

    s__1 = en;
    for (i = *low; i <= s__1; ++i) {
/* L120: */
	h[i + i * h_dim1] -= x;
    }

    s = (d__1 = h[en + na * h_dim1], fabs(d__1)) + (d__2 = h[na + enm2 * 
	    h_dim1], fabs(d__2));
    x = s * .75;
    y = x;
    w = s * -.4375 * s;
L130:
    ++its;
/*     .......... look for two consecutive small */
/*                sub-diagonal elements. */
/*                for m=en-2 step -1 until l do -- .......... */
    s__1 = enm2;
    for (mm = l; mm <= s__1; ++mm) {
	m = enm2 + l - mm;
	zz = h[m + m * h_dim1];
	r = x - zz;
	s = y - zz;
	p = (r * s - w) / h[m + 1 + m * h_dim1] + h[m + (m + 1) * h_dim1];
	q = h[m + 1 + (m + 1) * h_dim1] - zz - r - s;
	r = h[m + 2 + (m + 1) * h_dim1];
	s = fabs(p) + fabs(q) + fabs(r);
	p /= s;
	q /= s;
	r /= s;
	if (m == l) {
	    goto L150;
	}
	if ((d__1 = h[m + (m - 1) * h_dim1], fabs(d__1)) * (fabs(q) + fabs(r)) <=
		 machep * fabs(p) * ((d__2 = h[m - 1 + (m - 1) * h_dim1], fabs(
		d__2)) + fabs(zz) + (d__3 = h[m + 1 + (m + 1) * h_dim1], fabs(
		d__3)))) {
	    goto L150;
	}
/* L140: */
    }

L150:
    mp2 = m + 2;

    s__1 = en;
    for (i = mp2; i <= s__1; ++i) {
	h[i + (i - 2) * h_dim1] = 0.;
	if (i == mp2) {
	    goto L160;
	}
	h[i + (i - 3) * h_dim1] = 0.;
L160:
	;
    }
/*     .......... double qr step involving rows l to en and */
/*                columns m to en .......... */
    s__1 = na;
    for (k = m; k <= s__1; ++k) {
	notlas = k != na;
	if (k == m) {
	    goto L170;
	}
	p = h[k + (k - 1) * h_dim1];
	q = h[k + 1 + (k - 1) * h_dim1];
	r = 0.;
	if (notlas) {
	    r = h[k + 2 + (k - 1) * h_dim1];
	}
	x = fabs(p) + fabs(q) + fabs(r);
	if (x == 0.) {
	    goto L260;
	}
	p /= x;
	q /= x;
	r /= x;
L170:
	d__1 = sqrt(p * p + q * q + r * r);
	s = (p>=0.0?fabs(d__1):-fabs(d__1));
	if (k == m) {
	    goto L180;
	}
	h[k + (k - 1) * h_dim1] = -s * x;
	goto L190;
L180:
	if (l != m) {
	    h[k + (k - 1) * h_dim1] = -h[k + (k - 1) * h_dim1];
	}
L190:
	p += s;
	x = p / s;
	y = q / s;
	zz = r / s;
	q /= p;
	r /= p;
/*     .......... row modification .......... */
	s__2 = en;
	for (j = k; j <= s__2; ++j) {
	    p = h[k + j * h_dim1] + q * h[k + 1 + j * h_dim1];
	    if (! notlas) {
		goto L200;
	    }
	    p += r * h[k + 2 + j * h_dim1];
	    h[k + 2 + j * h_dim1] -= p * zz;
L200:
	    h[k + 1 + j * h_dim1] -= p * y;
	    h[k + j * h_dim1] -= p * x;
/* L210: */
	}

/* Computing MIN */
	i__1 = en, i__2 = k + 3;
	if( i__1 < i__2 )
	  j = i__1;
	else
	  j = i__2;
/*     .......... column modification .......... */
	s__2 = j;
	for (i = l; i <= s__2; ++i) {
	    p = x * h[i + k * h_dim1] + y * h[i + (k + 1) * h_dim1];
	    if (! notlas) {
		goto L220;
	    }
	    p += zz * h[i + (k + 2) * h_dim1];
	    h[i + (k + 2) * h_dim1] -= p * r;
L220:
	    h[i + (k + 1) * h_dim1] -= p * q;
	    h[i + k * h_dim1] -= p;
/* L230: */
	}

L260:
	;
    }

    goto L70;
/*     .......... one root found .......... */
L270:
    wr[en] = x + t;
    wi[en] = 0.;
    en = na;
    goto L60;
/*     .......... two roots found .......... */
L280:
    p = (y - x) / 2.;
    q = p * p + w;
    zz = sqrt((fabs(q)));
    x += t;
    if (q < 0.) {
	goto L320;
    }
/*     .......... real pair .......... */
    zz = p + (p>=0.0?fabs(zz):-fabs(zz));
    wr[na] = x + zz;
    wr[en] = wr[na];
    if (zz != 0.) {
	wr[en] = x - w / zz;
    }
    wi[na] = 0.;
    wi[en] = 0.;
    goto L330;
/*     .......... complex pair .......... */
L320:
    wr[na] = x + p;
    wr[en] = x + p;
    wi[na] = zz;
    wi[en] = -zz;
L330:
    en = enm2;
    goto L60;
/*     .......... set error -- all eigenvalues have not */
/*                converged after 30*n iterations .......... */
L1000:
    *ierr = en;
L1001:
#if 0
    {
      FILE *fp=fopen("eigenwerte.aus","a");
      fprintf( fp, "-------------------------------------\n" );
      fprintf( fp, "ierr=%d\n", *ierr );
      for( i=1; i<=*n; i++ )
	fprintf( fp, "%g %g\n", (double)(wr[i]), (double)(wi[i]) );
      fclose( fp );
    }
#endif
    return;
} /* dhqr_ */

