/* dmfgr.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dmfgr_(doublereal *a, shortint *m, shortint *n, doublereal *eps, shortint *irank, shortint *irow, shortint *icol)
{
    /* System generated locals */
    int s__1, s__2, s__3, s__4;
    integer i__1;
    doublereal r__1;
    doublereal d__1;

    /* Local variables */
    doublereal hold;
    int ncol;
    doublereal save;
    int i, j, l, ic, ii, jj, kk, ll, mm, ir, nm;
    doublereal piv;
    doublereal tol;

    /* Parameter adjustments */
    --icol;
    --irow;
    --a;

    /* Function Body */
    if (*m <= 0) {
	goto L2;
    } else {
	goto L1;
    }
L1:
    if (*n <= 0) {
	goto L2;
    } else {
	goto L4;
    }
L2:
    *irank = -1;
L3:
    return;
L4:
    *irank = 0;
    piv = 0.;
    jj = 0;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	icol[j] = j;
	s__2 = *m;
	for (i = 1; i <= s__2; ++i) {
	    ++jj;
	    hold = a[jj];
	    if (fabs(piv) - fabs(hold) >= 0.) {
		goto L6;
	    } else {
		goto L5;
	    }
L5:
	    piv = hold;
	    ir = i;
	    ic = j;
L6:
	    ;
	}
    }
    s__2 = *m;
    for (i = 1; i <= s__2; ++i) {
/* L7: */
	irow[i] = i;
    }
/*      TOL=FABS(EPS*SNGL(PIV)) */
    tol = fabs(*eps);
    nm = *n * *m;
    s__2 = nm;
    s__1 = *m;
    for (ncol = *m; s__1 < 0 ? ncol >= s__2 : ncol <= s__2; ncol += s__1) {
/* L8: */
	if ((r__1 = piv, fabs(r__1)) - tol <= (float)0.) {
	    goto L20;
	} else {
	    goto L9;
	}
L9:
	++(*irank);
	jj = ir - *irank;
	if (jj <= 0) {
	    goto L12;
	} else {
	    goto L10;
	}
L10:
	s__3 = nm;
	s__4 = *m;
	for (j = *irank; s__4 < 0 ? j >= s__3 : j <= s__3; j += s__4) {
	    i = j + jj;
	    save = a[j];
	    a[j] = a[i];
/* L11: */
	    a[i] = save;
	}
	jj = irow[ir];
	irow[ir] = irow[*irank];
	irow[*irank] = jj;
L12:
	jj = (ic - *irank) * *m;
	if (jj <= 0) {
	    goto L15;
	} else {
	    goto L13;
	}
L13:
	kk = ncol;
	s__4 = *m;
	for (j = 1; j <= s__4; ++j) {
	    i = kk + jj;
	    save = a[kk];
	    a[kk] = a[i];
	    --kk;
/* L14: */
	    a[i] = save;
	}
	jj = icol[ic];
	icol[ic] = icol[*irank];
	icol[*irank] = jj;
L15:
	kk = *irank + 1;
	mm = *irank - *m;
	ll = ncol + mm;
	if (mm >= 0) {
	    goto L25;
	} else {
	    goto L16;
	}
L16:
	jj = ll;
	save = piv;
	piv = 0.;
	s__4 = *m;
	for (j = kk; j <= s__4; ++j) {
	    ++jj;
	    hold = a[jj] / save;
	    a[jj] = hold;
	    l = j - *irank;
	    if (*irank - *n >= 0) {
		goto L119;
	    } else {
		goto L17;
	    }
L17:
	    ii = jj;
	    s__3 = *n;
	    for (i = kk; i <= s__3; ++i) {
		ii += *m;
		mm = ii - l;
		a[ii] -= hold * a[mm];
		if ((d__1 = a[ii], fabs(d__1)) - fabs(piv) <= 0.) {
		    goto L19;
		} else {
		    goto L18;
		}
L18:
		piv = a[ii];
		ir = j;
		ic = i;
L19:
		;
	    }
L119:
	    ;
	}
/* L219: */
    }
L20:
    if ((i__1 = *irank - 1) < 0) {
	goto L3;
    } else if (i__1 == 0) {
	goto L25;
    } else {
	goto L21;
    }
L21:
    ir = ll;
    s__1 = *irank;
    for (j = 2; j <= s__1; ++j) {
	ii = j - 1;
	ir -= *m;
	jj = ll;
	s__2 = *m;
	for (i = kk; i <= s__2; ++i) {
	    hold = 0.;
	    ++jj;
	    mm = jj;
	    ic = ir;
	    s__4 = ii;
	    for (l = 1; l <= s__4; ++l) {
		hold += a[mm] * a[ic];
		--ic;
/* L22: */
		mm -= *m;
	    }
/* L23: */
	    a[mm] -= hold;
	}
/* L24: */
    }
L25:
    if (*n - *irank <= 0) {
	goto L3;
    } else {
	goto L26;
    }
L26:
    ir = ll;
    kk = ll + *m;
    s__1 = *irank;
    for (j = 1; j <= s__1; ++j) {
	s__2 = nm;
	s__4 = *m;
	for (i = kk; s__4 < 0 ? i >= s__2 : i <= s__2; i += s__4) {
	    jj = ir;
	    ll = i;
	    hold = 0.;
	    ii = j;
L27:
	    --ii;
	    if (ii <= 0) {
		goto L29;
	    } else {
		goto L28;
	    }
L28:
	    hold -= a[jj] * a[ll];
	    jj -= *m;
	    --ll;
	    goto L27;
L29:
	    a[ll] = (hold - a[ll]) / a[jj];
	}
/* L30: */
	--ir;
    }
    return;
} /* dmfgr_ */

