/* dminv.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dminv_(doublereal *a, shortint *n, doublereal *d, shortint *l, shortint *m)
{
    /* System generated locals */
    int s__1, s__2, s__3;
    doublereal d__1;

    /* Local variables */
    doublereal biga, hold;
    int i, j, k, ij, ki, ji, kk, jk, ik, nk, jp, kj, jq, jr, iz;

    /* Parameter adjustments */
    --m;
    --l;
    --a;

    /* Function Body */
    *d = 1.;
    nk = -(*n);
    s__1 = *n;
    for (k = 1; k <= s__1; ++k) {
	nk += *n;
	l[k] = k;
	m[k] = k;
	kk = nk + k;
	biga = a[kk];
	s__2 = *n;
	for (j = k; j <= s__2; ++j) {
	    iz = *n * (j - 1);
	    s__3 = *n;
	    for (i = k; i <= s__3; ++i) {
		ij = iz + i;
/* L10: */
		if (fabs(biga) - (d__1 = a[ij], fabs(d__1)) >= 0.) {
		    goto L20;
		} else {
		    goto L15;
		}
L15:
		biga = a[ij];
		l[k] = i;
		m[k] = j;
L20:
		;
	    }
	}
	j = l[k];
	if (j - k <= 0) {
	    goto L35;
	} else {
	    goto L25;
	}
L25:
	ki = k - *n;
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    ki += *n;
	    hold = -a[ki];
	    ji = ki - k + j;
	    a[ki] = a[ji];
/* L30: */
	    a[ji] = hold;
	}
L35:
	i = m[k];
	if (i - k <= 0) {
	    goto L45;
	} else {
	    goto L38;
	}
L38:
	jp = *n * (i - 1);
	s__3 = *n;
	for (j = 1; j <= s__3; ++j) {
	    jk = nk + j;
	    ji = jp + j;
	    hold = -a[jk];
	    a[jk] = a[ji];
/* L40: */
	    a[ji] = hold;
	}
L45:
	if (biga != 0.) {
	    goto L48;
	} else {
	    goto L46;
	}
L46:
	*d = 0.;
	return;
L48:
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    if (i - k != 0) {
		goto L50;
	    } else {
		goto L55;
	    }
L50:
	    ik = nk + i;
	    a[ik] /= -biga;
L55:
	    ;
	}
	s__3 = *n;
	for (i = 1; i <= s__3; ++i) {
	    ik = nk + i;
	    hold = a[ik];
	    ij = i - *n;
	    s__2 = *n;
	    for (j = 1; j <= s__2; ++j) {
		ij += *n;
		if (i - k != 0) {
		    goto L60;
		} else {
		    goto L65;
		}
L60:
		if (j - k != 0) {
		    goto L62;
		} else {
		    goto L65;
		}
L62:
		kj = ij - i + k;
		a[ij] = hold * a[kj] + a[ij];
L65:
		;
	    }
	}
	kj = k - *n;
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
	    kj += *n;
	    if (j - k != 0) {
		goto L70;
	    } else {
		goto L75;
	    }
L70:
	    a[kj] /= biga;
L75:
	    ;
	}
	*d *= biga;
/* L80: */
	a[kk] = 1. / biga;
    }
    k = *n;
L100:
    --k;
    if (k <= 0) {
	goto L150;
    } else {
	goto L105;
    }
L105:
    i = l[k];
    if (i - k <= 0) {
	goto L120;
    } else {
	goto L108;
    }
L108:
    jq = *n * (k - 1);
    jr = *n * (i - 1);
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	jk = jq + j;
	hold = a[jk];
	ji = jr + j;
	a[jk] = -a[ji];
/* L110: */
	a[ji] = hold;
    }
L120:
    j = m[k];
    if (j - k <= 0) {
	goto L100;
    } else {
	goto L125;
    }
L125:
    ki = k - *n;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	ki += *n;
	hold = a[ki];
	ji = ki - k + j;
	a[ki] = -a[ji];
/* L130: */
	a[ji] = hold;
    }
    goto L100;
L150:
    return;
} /* dminv_ */

