/* dvgaus.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dvgaus_(shortint *n, shortint *na, doublereal *a, doublereal *x, doublereal *eps, shortint *irang)
{
    /* System generated locals */
    int s__1, s__2;
    integer a_dim1, a_offset;
    doublereal d__1;

    /* Local variables */
    doublereal amax;
    int i, j, k, l, m;
    doublereal r, s;
    int j1, l1, n1, n2;
    doublereal am;
    shortint ik[NFMAX*NFMAX], is;
    doublereal am1;
    int ik1, ikl;

/* ********************************************************************** 
*/
/*     POPAMMA DVGAUS */
/* ********************************************************************** 
*/
/*     14.11.92 */
/* -----------------------------------------------------------------------
 */

/*     POPAMMA DVGAUS PEHAHAEHA  PEEH OHOPOHO */
/*     CCTEM liHEjHyX uPABHEHij   A*X=0 , gdE A- MATPicA N*N */
/*     PAHg KOTOPOj PABEH N-1. */
/*     PE{EHiE OCu}ECTBlqETCq METOdOM gAuCCA C BybOPOM glABHOgO */
/*     |lEMEHTA pO BCEj MATPicE. */

/*       OpiCAHiE pAPAMETPOB */

/*       N - PAzMEPHOCTx MATPicy */
/*      NA - CTPO~HAq PAzMEPHOCTx dBuMEPHOgO MACCiBA A, COdEPvA}EgO */
/*           MATPicu N*N, OpiCAHHAq B ByzyBA`}Ej pPOgPAMME. */
/*       A - dBuMEPHyj MACCiB, COdEPvA}ij MATPicu N*N. */
/*       X - MACCiB PAzMEPA N, COdEPvA}ij iCKOMOE PE{EHiE OdHOPOdHOj */
/*           CiCTEMy (OdHA iz KOOPdiHAT BEKTOPA X PABHA 1). */
/*     EPS - BXOdHOj pAPAMETP dlq pPOBEPKi HA HOlx glABHyX |lEMEHTOB */
/*           MATPicy.  PEKOMEHduETCq EPS=1.D-3 */
/*   IRANG - ByXOdHOj pAPAMETP, COdEPvA}ij PAHg MATPicy A. */
/*           ECli IRANG # N-1 , TO |TO OzHA~AET ABAPijHOE zABEP{EHiE */
/*           PAbOTy pPOgPAMMy. BEKTOP X pPi |TOM HE OpPEdElqETCq. */

    /* Parameter adjustments */
    --x;
    a_dim1 = *na;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    n1 = *n - 1;
    n2 = *n + 1;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L13: */
	ik[i - 1] = i;
    }
    *irang = 0;
    l = 1;
L11:

/*       i}EM BEdu}ij |lEMEHT pO BCEj MATPicE */
/*     K-HOMEP CTPOKi, IKL-HOMEP CTOlbcA BEdu}EgO |lEMEHTA */

    am = 0.;
    amax = 0.;
    s__1 = *n;
    for (i = l; i <= s__1; ++i) {
	s__2 = *n;
	for (j = l; j <= s__2; ++j) {
	    am1 = a[i + j * a_dim1];
	    if (am >= fabs(am1)) {
		goto L2;
	    }
	    am = fabs(am1);
	    amax = am1;
	    k = i;
	    ikl = j;
L2:
/* L1: */
	    ;
	}
    }
    if (am > *eps) {
	goto L4;
    }
    return;
L4:
    if (l == k) {
	goto L5;
    }

/*   MEHqEM MECTAMi L-u` i K-u` CTPOKi */

    s__2 = *n;
    for (j = l; j <= s__2; ++j) {
	r = a[k + j * a_dim1];
	a[k + j * a_dim1] = a[l + j * a_dim1];
/* L6: */
	a[l + j * a_dim1] = r;
    }
L5:
    if (ikl == l) {
	goto L7;
    }

/*   MEHqEM MECTAMi L-yj i K-yj CTOlbEc */

    ik1 = ik[l - 1];
    ik[l - 1] = ik[ikl - 1];
    ik[ikl - 1] = ik1;
    s__2 = *n;
    for (j = 1; j <= s__2; ++j) {
	r = a[j + l * a_dim1];
	a[j + l * a_dim1] = a[j + ikl * a_dim1];
/* L8: */
	a[j + ikl * a_dim1] = r;
    }
L7:

/*   dEliM L-u` CTPOKu HA BEdu}ij |lEMEHT i By~iTAEM iz dPugiX CTPOK */

    l1 = l + 1;
    s__2 = *n;
    for (j = l1; j <= s__2; ++j) {
	r = a[j + l * a_dim1] / amax;
	s__1 = *n;
	for (is = l1; is <= s__1; ++is) {
/* L10: */
	    a[j + is * a_dim1] -= a[l + is * a_dim1] * r;
	}
/* L9: */
    }
    l = l1;
    ++(*irang);
    if (l < *n) {
	goto L11;
    }
    if ((d__1 = a[*n + *n * a_dim1], fabs(d__1)) <= *eps) {
	goto L12;
    }
    ++(*irang);
    return;
L12:

/*   HAXOdiM BEKTOP OdHOPOdHyX PE{EHij */

    x[ik[*n - 1]] = 1.;
    s__2 = n1;
    for (i = 1; i <= s__2; ++i) {
	m = *n - i;
	s = 0.;
	s__1 = i;
	for (j = 1; j <= s__1; ++j) {
	    j1 = n2 - j;
/* L15: */
	    s += a[m + j1 * a_dim1] * x[ik[j1 - 1]];
	}
	x[ik[m - 1]] = -s / a[m + (*n - i) * a_dim1];
/* L14: */
    }
    return;
} /* dvgaus_ */

