/* koeev1.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void koeev1_(doublereal *a, shortint *n, shortint *na, doublereal *p, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2, s__3, s__4;
    integer a_dim1, a_offset;
    doublereal d__1, d__2, d__3;

    /* Local variables */
    shortint i, j, k, l;
    doublereal r, s, y[2*NFMAX], r1, s1, sc, str;

    static struct { doublereal b[2*NFMAX][2*NFMAX]; } work1_;
#define work1_1 work1_



/*   Compute coefficients of the characteristic polynomial */

/*   Rev. 2.08.92 */
/*        17.11.92 */

    /* Parameter adjustments */
    --p;
    a_dim1 = *na;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    if (*n > 0 && *n <= NFMAX) {
	goto L11;
    }
    *ier = 1;
    return;
L11:
    *ier = 0;
    s = 0.;
    str = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s += a[i + i * a_dim1];
	str += (d__1 = a[i + i * a_dim1], fabs(d__1));
/* L99: */
    }
/*     STR=DSQRT(STR) */
/*      WRITE (*,*) '  STR=',STR */
    p[1] = -s;
    if (*n == 1) {
	return;
    }
/* --- */
    sc = 1.;
    sc = *n / (str + .01);
    p[1] *= sc;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
	    a[i + j * a_dim1] = sc * a[i + j * a_dim1];
/* L60: */
	}
/* L61: */
    }
/* --- */
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
	    s1 = 0.;
	    s__3 = *n;
	    for (k = 1; k <= s__3; ++k) {
		if (k == j) {
		    goto L3;
		}
		s1 += a[i + k * a_dim1] * a[k + j * a_dim1];
		goto L2;
L3:
		s1 += a[i + k * a_dim1] * (a[k + k * a_dim1] + p[1]);
L2:
		;
	    }
/* L1: */
	    work1_1.b[i-1][j-1] = s1;
	}
    }
    s = 0.;
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L4: */
	s += work1_1.b[i-1][i-1];
    }
    p[2] = -s / 2.;
    if (*n == 2) {
	return;
    }
    s__2 = *n;
    for (l = 3; l <= s__2; ++l) {
	s__1 = *n;
	for (j = 1; j <= s__1; ++j) {
	    s__3 = *n;
	    for (i = 1; i <= s__3; ++i) {
		s = (float)0.;
		s__4 = *n;
		for (k = 1; k <= s__4; ++k) {
		    if (k == j) {
			goto L8;
		    }
		    s += a[i + k * a_dim1] * work1_1.b[k-1][j-1];
		    goto L7;
L8:
		    s += a[i + k * a_dim1] * (work1_1.b[j-1][j-1] + 
			    p[l - 1]);
L7:
		    ;
		}
/* L6: */
		y[i - 1] = s;
	    }
	    s__3 = *n;
	    for (i = 1; i <= s__3; ++i) {
/* L10: */
		work1_1.b[i-1][j-1] = y[i - 1];
	    }
/* L5: */
	}
	s = 0.;
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
/* L12: */
	    s += work1_1.b[i-1][i-1];
	}
	p[l] = -s / l;
/* L9: */
    }
/*          PRINT 902,(P(I),I=1,6) */
/* 902      FORMAT (/2X,'P=',/(2X,6G13.6)) */

    return;

    d__2 = (d__1 = p[*n], fabs(d__1));
    d__3 = 1. / *n;
    r = pow(d__2, d__3);
    r = 1. / (r + 1.);
    r1 = 1.;
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
	r1 *= r;
	p[i] *= r1;
/* L35: */
    }
    return;
} /* koeev1_ */

