/* detjac.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void detjac_(shortint *nk, doublereal *x, doublereal *djac, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    shortint i, j, l;
    doublereal r1, r2, r3, r4, r5, r6, sc, str;


/*   DETYAC COMPUTE DETERMINANT OF THE JACOBY MATRIX */
/*        24.04.1990 */
/*        17.11.92 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    DYAC   - COMPUTED VALUE OF DETERMINANT */
/*    IER    - ERROR CONDITION */
/*               0 - NORMAL VALUE */

/*   VARIABLES IN COMMON BLOCKS: */
/*    NF     - PHASE DIMENSION OF THE PROBLEM */
/*    DHF    - STEPSIZE TO COMPUTE JACOBIAN NUMERICALLY */

/*   WORKING SPACE: */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF CONTAINING JACOBIAN */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funs_, ier);
    if (*ier != 0) {
	return;
    }
    switch ((int)linbf_1.nf) {
	case 1:  goto L20;
	case 2:  goto L30;
	case 3:  goto L40;
    }
    goto L50;

/*   CASE: PHASE DIMENSION NF = 1 */

L20:
    *djac = linbf2_1.d[0];
    return;

/*   CASE: PHASE DIMENSION NF = 2 */

L30:
    *djac = linbf2_1.d[0] * linbf2_1.d[3] - linbf2_1.d[1] * linbf2_1.d[2];
    return;

/*   CASE: PHASE DIMENSION NF = 3 */

L40:
    r1 = linbf2_1.d[0] * linbf2_1.d[4] * linbf2_1.d[8];
    r2 = linbf2_1.d[3] * linbf2_1.d[7] * linbf2_1.d[2];
    r3 = linbf2_1.d[1] * linbf2_1.d[5] * linbf2_1.d[6];
    r4 = linbf2_1.d[6] * linbf2_1.d[4] * linbf2_1.d[2];
    r5 = linbf2_1.d[7] * linbf2_1.d[5] * linbf2_1.d[0];
    r6 = linbf2_1.d[3] * linbf2_1.d[1] * linbf2_1.d[8];
    *djac = r1 + r2 + r3 - r4 - r5 - r6;
    return;

/*   CASE: PHASE DIMENSION NF > 3 */

L50:
/* --- */
    str = 0.;
    l = 1;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = linbf2_1.d[l - 1];
	str += d__1 * d__1;
	l = l + linbf_1.nf + 1;
/* L60: */
    }
    str = sqrt(str);
    sc = 1.;
    sc = linbf_1.nf / (str + .01);
    l = 0;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	s__2 = linbf_1.nf;
	for (j = 1; j <= s__2; ++j) {
	    ++l;
	    linbf2_1.d[l - 1] = sc * linbf2_1.d[l - 1];
/* L70: */
	}
/* L71: */
    }
/* --- */
    detbf_(linbf2_1.d, &linbf_1.nf, djac);

/*      WRITE (*,*) '  DETJAC: STR=',STR,'  DJAC=',DJAC */

    return;
} /* detjac_ */

