/* detrg.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void detrg_(shortint *nk, doublereal *x, doublereal *drg, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    doublereal dyak;
    doublereal c[NFMAX];
    shortint i, j, k, l, m;
    doublereal r1, r2, r3, r4, r5, r6;
    doublereal sc, ds[NDS];
    shortint ms;
    doublereal sc3, str;


/*   DETRG COMPUTE BIFURCATION FUNCTION FOR NEUTRAL EIGENVALUES CASE */
/*     (THE FUNCTION IS ADAPTATION OF DETERMINANT OF HURWITZ MATRIX) */
/*        24.04.1990 */
/*        17.11.92 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    DRG    - COMPUTED VALUE OF DETERMINANT */
/*    IER    - ERROR CONDITION */
/*               0 - NORMAL VALUE */

/*   VARIABLES IN COMMON BLOCKS: */
/*    NF     - PHASE DIMENSION OF THE PROBLEM */
/*    DHF    - STEPSIZE TO COMPUTE JACOBIAN NUMERICALLY */

/*   WORKING SPACE: */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF CONTAINING JACOBIAN */
/*    C      - REAL ARRAY OF THE LENGTH NF CONTAINING COEFFICIENTS OF */
/*               THE CHARACTERISTIC POLINOMIAL */



    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;

/*   CASE: PHASE DIMENSION NF = 1 */

    if (linbf_1.nf > 1) {
	goto L10;
    }
    *ier = 1;
    *drg = (float)1.;
    return;

/*   CASE: PHASE DIMENSION NF > 1 */

L10:
    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funs_, ier);
    if (*ier != 0) {
	return;
    }
    if (linbf_1.nf == 2) {
	goto L70;
    }
    if (linbf_1.nf == 3) {
	goto L60;
    }

/*   CASE: PHASE DIMENSION NF > 3 */

/*    COMPUTE COEFFICIENTS OF THE CHARACTERISTIC POLINOMIAL */

/*          PRINT 901,(D(I),I=1,36) */
/* 901      FORMAT (/2X,'D=',/(2X,6G13.6)) */
    koeev1_(linbf2_1.d, &linbf_1.nf, &linbf_1.nf, c, ier);
/*          PRINT 902,(C(I),I=1,6) */
/* 902      FORMAT (/2X,'C=',/(2X,6G13.6)) */
    if (*ier == 0) {
	goto L20;
    }
    return;

L20:
    m = linbf_1.nf - 1;
    k = 0;
    s__1 = m;
    for (i = 1; i <= s__1; ++i) {
	s__2 = m;
	for (j = 1; j <= s__2; ++j) {
	    l = (i << 1) - j;
	    ++k;
	    if (l > linbf_1.nf || l < 1) {
		goto L30;
	    }
	    linbf2_1.d[k - 1] = c[l - 1];
	    goto L40;
L30:
	    linbf2_1.d[k - 1] = 0.;
	    if (l == 0) {
		linbf2_1.d[k - 1] = 1.;
	    }
L40:
	    ;
	}
/* L50: */
    }

    ms = m - 2;
    l = m;
    k = 0;
    s__1 = ms;
    for (i = 1; i <= s__1; ++i) {
	l += 2;
	s__2 = ms;
	for (j = 1; j <= s__2; ++j) {
	    ++l;
	    ++k;
	    ds[k - 1] = linbf2_1.d[l - 1];
/* L54: */
	}
/* L55: */
    }

    detbf_(linbf2_1.d, &m, drg);

/* ---      CALL DETBF(DS,MS,DRGDS) */

/* ---      DRG=DRG/(1.D-10 + DABS(DRGDS)) */
    return;

/*   CASE: PHASE DIMENSION NF = 3 */

L60:
    r1 = linbf2_1.d[0] * linbf2_1.d[4] * linbf2_1.d[8];
    r2 = linbf2_1.d[3] * linbf2_1.d[7] * linbf2_1.d[2];
    r3 = linbf2_1.d[1] * linbf2_1.d[5] * linbf2_1.d[6];
    r4 = linbf2_1.d[6] * linbf2_1.d[4] * linbf2_1.d[2];
    r5 = linbf2_1.d[7] * linbf2_1.d[5] * linbf2_1.d[0];
    r6 = linbf2_1.d[3] * linbf2_1.d[1] * linbf2_1.d[8];
    dyak = r1 + r2 + r3 - r4 - r5 - r6;
    r1 = linbf2_1.d[4] * linbf2_1.d[8] - linbf2_1.d[5] * linbf2_1.d[7];
    r2 = linbf2_1.d[0] * linbf2_1.d[4] - linbf2_1.d[1] * linbf2_1.d[3];
    r3 = linbf2_1.d[0] * linbf2_1.d[8] - linbf2_1.d[2] * linbf2_1.d[6];
    *drg = (linbf2_1.d[0] + linbf2_1.d[4] + linbf2_1.d[8]) * (r1 + r2 + r3) - 
	    dyak;

/*      SC=3.D0/(1.D0+DABS(D(1)+D(5)+D(9))) */
    str = linbf2_1.d[0] * linbf2_1.d[0] + linbf2_1.d[4] * linbf2_1.d[4] + 
	    linbf2_1.d[8] * linbf2_1.d[8];
    str = sqrt(str);
    sc = 3. / (str + .01);
    sc3 = sc * sc * sc;
    *drg = sc3 * *drg;

    return;

/*   CASE: PHASE DIMENSION NF = 2 */

L70:
    *drg = linbf2_1.d[0] + linbf2_1.d[3];
    return;
} /* detrg_ */

