/* dxp1nt.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dxp1nt_(shortint *nfp, shortint *nfp2, doublereal *dh, doublereal *x, doublereal *dxp, void (*funs) (doublereal*, doublereal*), shortint *ier)
                     
                         
/* Subroutine */                
              
{
    /* Initialized data */

    static doublereal eps0 = 1e-10;

    /* System generated locals */
    shortint s__1, s__2;
    integer dxp_dim1, dxp_offset;
    doublereal d__1;

    /* Local variables */
    static doublereal f[NFMAX+1];
    static shortint i, j, k;
    static doublereal r;
    static shortint jj;
    static doublereal fp[NFMAX+1];
    static shortint nk;
    static doublereal dhx;


/*   COMPUTING DERIVATIVES FOR NONTRANSVERSALITY CONDITION */
/*          ON THE HOPF CURVE */
/*      The number of singular parameter is IPSNG1 */
/*                  20.05.1990 */
/*                  14.02.1991 */
/*                  15.11.92 */

    /* Parameter adjustments */
    dxp_dim1 = *nfp;
    dxp_offset = dxp_dim1 + 1;
    dxp -= dxp_offset;
    --x;

    /* Function Body */
    *ier = 0;
    nk = linbf_1.nf + linbf_1.nap;

    (*funs)(&x[1], f);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    detrg_(&nk, &x[1], &f[linbf_1.nf], ier);
    if (*ier != 0) {
	return;
    }
    s__1 = *nfp;
    for (j = 1; j <= s__1; ++j) {
	jj = j;
	if (j == linbf_1.nf + 1) {
	    jj = linbf_1.nf + ipsng_1.ipsng1;
	}
/*        IF (J.LE.NF) GO TO 15 */
/*          DO 10 I=1,NAP */
/*            JJ=NF+I */
/*            IF (IP(I).EQ.IPSNG1) GO TO 15 */
/* 10       CONTINUE */
/*          IER=-1 */
/*          RETURN */

/* L15: */
	dhx = *dh * ((d__1 = x[jj], fabs(d__1)) + 1.);
	r = x[jj];
	x[jj] = r + dhx;
	s__2 = linbf_1.nap;
	for (i = 1; i <= s__2; ++i) {
	    k = ippar_1.ip[i - 1];
	    ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L20: */
	}
	(*funs)(&x[1], fp);
	x[jj] = r;
	*ier = ierfs_1.ierfs;
	if (*ier != 0) {
	    return;
	}
	x[jj] = r + dhx;
	detrg_(&nk, &x[1], &fp[linbf_1.nf], ier);
	x[jj] = r;
	if (*ier != 0) {
	    return;
	}
	s__2 = *nfp;
	for (i = 1; i <= s__2; ++i) {
	    dxp[i + j * dxp_dim1] = (fp[i - 1] - f[i - 1]) / dhx;
	    if ((d__1 = dxp[i + j * dxp_dim1], fabs(d__1)) <= eps0) {
		dxp[i + j * dxp_dim1] = (float)0.;
	    }
/* L30: */
	}
/* L40: */
    }
    return;
} /* dxp1nt_ */

