/* epcodebf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epcodebf_(shortint *iptype, doublereal *bifval)
{
    static shortint i, ipt1, ipt2, ipt3, ipt4;


/*   In this subprogram we produce special code */
/*      IPTYPE for every point on a curve */
/*          29.05.1989 */
/*          15.11.92 */
/*          10.07.94 */

/* ---- */
/* ---- */
    /* Parameter adjustments */
    --bifval;

    /* Function Body */
    ipt1 = linbfq_1.ipt[0];
    ipt2 = linbfq_1.ipt[1];
    ipt3 = linbfq_1.ipt[2];
    ipt4 = linbfq_1.ipt[3];
    for (i = 1; i <= NBFVL; ++i) {
	bifval[i] = linbfr_1.valpt[i - 1];
/* L1: */
    }
    switch ((int)ipt2) {
	case 1:  goto L1000;
	case 2:  goto L2000;
	case 3:  goto L3000;
	case 4:  goto L4000;
    }

/* =================================================================== */
L1000:
/*   Regular point */
    *iptype = 100;
    if (ipt1 != 2) {
	goto L1100;
    }
/* 			    Hopf line */
    if (ipt3 == 1) {
	*iptype = 101;
    }
/* 				 focus case, L1=BV(1) */
    if (ipt3 == 2) {
	*iptype = 102;
    }
/* 				 focus case, L1=? */
    if (ipt3 == -1) {
	*iptype = 103;
    }
/* 				 saddle case */
L1100:
    if (ipt1 != 1 || ipt1 != 11) {
	return;
    }
/* 			    Mult2 or Bogdanov */
    if (linbfq_1.ival[0] == 0) {
	*iptype = 101;
    }
/* 				 a=BV(1) */
    if (linbfq_1.ival[0] != 0) {
	*iptype = 102;
    }
/* 				 a=? */
    return;

/* =================================================================== */
L2000:
/*   Selfcrossing */
    if (linbfq_1.inder == 0) {
	*iptype = 201;
    }
/* 			    O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 211;
    }
/* 			    Warning */
    return;

/* =================================================================== */
L3000:
/*   Singular point */
    *iptype = 300;
    if (ipt1 == 0) {
	goto L3001;
    }
    if (ipt1 == 1) {
	goto L3011;
    }
    if (ipt1 == 2) {
	goto L3021;
    }
    if (ipt1 == 3) {
	goto L3031;
    }
    if (ipt1 == 4) {
	goto L3041;
    }
    if (ipt1 == 11) {
	goto L3111;
    }
    if (ipt1 == 12) {
	goto L3121;
    }
    if (ipt1 == 13) {
	goto L3131;
    }
    if (ipt1 == 14) {
	goto L3141;
    }
    if (ipt1 == 15) {
	goto L3151;
    }
    if (ipt1 == 16) {
	goto L3161;
    }
    if (ipt1 == 17) {
	goto L3171;
    }
    if (ipt1 == 21) {
	goto L3211;
    }
    if (ipt1 == 22) {
	goto L3221;
    }
    if (ipt1 == 23) {
	goto L3231;
    }
    if (ipt1 == 24) {
	goto L3241;
    }
    return;

L3001:
/* ---   Equilibrium   --------------------------------- */
    if (ipt3 != 1) {
	goto L3002;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3002:
    if (ipt3 != 2) {
	goto L3005;
    }
/* 		    Nutrality condition */
    if (ipt4 == 1 && linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   focus case, L1=BV(1) */
    if (ipt4 == 1 && linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   warning, focus case, L1=BV(1) */
    if (ipt4 == 2 && linbfq_1.inder == 0) {
	*iptype = 323;
    }
/* 				   focus case, L1=? */
    if (ipt4 == 2 && linbfq_1.inder != 0) {
	*iptype = 324;
    }
/* 				   warning, focus case, L1=? */
    if (ipt4 == -1 && linbfq_1.inder == 0) {
	*iptype = 325;
    }
/* 				   saddle case */
    if (ipt4 == -1 && linbfq_1.inder != 0) {
	*iptype = 326;
    }
/* 				   warning, saddle case */
    return;

L3005:
    if (ipt3 != 3) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3011:
/* ---   Mult 2    ------------------------------------ */
    if (ipt3 != 1) {
	goto L3012;
    }
/* 		    Nutrality condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3012:
    if (ipt3 != 2) {
	goto L3013;
    }
/* 		    Mult 3 */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
L3013:
    if (ipt3 != 3) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 333;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 334;
    }
/*                                Warning, a=? */
    return;
/* ---------------------------------------------------- */
L3021:
/* ---   Hopf   --------------------------------------- */
    if (ipt3 != 1) {
	goto L3022;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3022:
    if (ipt3 != 2) {
	goto L3023;
    }
/* 		    L1=0 */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
L3023:
    if (ipt3 != 3) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3031:
/* ---   L1=0   --------------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Nutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3041:
/* ---   Multiple eigenvalues	----------------------- */
    if (ipt3 != 1) {
	goto L3042;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3042:
    if (ipt3 != 2) {
	return;
    }
/* 		    Nutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3111:
/* ---   Bogdanov	  ----------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Mult 3 */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3121:
/* ---   Mult2 + Hopf  -------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Mult 3 */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3131:
/* ---   Hopf 2	------------------------------------- */
    return;
/* ---------------------------------------------------- */
L3141:
/* ---   Mult 3	------------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Nutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3151:
/* ---   Hopf + L1=0   -------------------------------- */
    return;
/* ---------------------------------------------------- */
L3161:
/* ---Mult 2 + Degeneracy */
    if (ipt3 != 1) {
	return;
    }
/* 		    Nutrality condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
/* ---------------------------------------------------- */
L3171:
/* ---   Hopf + Degeneracy   -------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
/* ---------------------------------------------------- */
L3211:
/* ---   Bogdanov + Mult 3   -------------------------- */
    return;
/* ---------------------------------------------------- */
L3221:
/* ---   Hopf + Mult 3	----------------------------- */
    return;
/* ---------------------------------------------------- */
L3231:
/* ---   Bogdanov + Extr   ---------------------------- */
    return;
/* ---------------------------------------------------- */
L3241:
/* ---   Hopf + Mult 2 +Extr   ------------------------ */
    return;
/* =================================================================== */
L4000:
/*   Extremum */
/* 	      Parameter's number - BV(1),  Extremal value - BV(2) */
    if (ipt3 > 0 && linbfq_1.inder == 0) {
	*iptype = 401;
    }
/* 			   Maximum */
    if (ipt3 < 0 && linbfq_1.inder == 0) {
	*iptype = 402;
    }
/* 			   Minimum */
    if (ipt3 > 0 && linbfq_1.inder != 0) {
	*iptype = 411;
    }
/* 			   Maximum , warning */
    if (ipt3 < 0 && linbfq_1.inder != 0) {
	*iptype = 412;
    }
/* 			   Minimum , warning */
    return;
} /* epcodebf_ */

