/* epdetev.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epdetev_(shortint *nk, doublereal *x, doublereal *dev, shortint *ier)
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    static doublereal a[NFMAX1], b[NFMAX], c[NFMAX];
    static shortint i, m;
    static doublereal drg;


/*   DETEV COMPUTE BIFURCATION FUNCTION FOR MULTIPLE EIGENVALUES CASE */
/*        24.04.1990 */
/*        15.11.92 */
/*        10.07.94 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    DEV    - COMPUTED VALUE OF BIFURCATION FUNCTION */
/*    IER    - ERROR CONDITION */
/*               0 - NORMAL VALUE */

/*   VARIABLES IN COMMON BLOCKS: */
/*    NF     - PHASE DIMENSION OF THE PROBLEM */
/*    DHF    - STEPSIZE TO COMPUTE JACOBIAN NUMERICALLY */

/*   WORKING SPACE: */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF CONTAINING JACOBIAN */
/*    C      - REAL ARRAY OF THE LENGTH NF CONTAINING COEFFICIENTS OF */
/*               THE CHARACTERISTIC POLINOMIAL */
/*    A      - REAL ARRAY OF THE LENGTH NF+1 */
/*    B      - REAL ARRAY OF THE LENGTH NF */
/*    U      - REAL ARRAY OF THE LENGTH (2*NF-1)*(2*NF-1) */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;

    if (linbf_1.nf > 1) {
	goto L10;
    }

/*   PROVIDE NONZERO ERROR CODE FOR THE CASE NF=1 */

    *ier = 1;
    drg = (float)1.;
    return;

/*   CALCULATE JACOBY MATRIX */

L10:
    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funs_, ier);
    if (*ier != 0) {
	return;
    }
    if (linbf_1.nf == 2) {
	goto L50;
    }

/*   CASE: PHASE DIMENSION NF > 2 */

/*    COMPUTE COEFFICIENTS OF THE CHARACTERISTIC POLINOMIAL */

    koeev1_(linbf2_1.d, &linbf_1.nf, &linbf_1.nf, c, ier);
    if (*ier == 0) {
	goto L20;
    }
    return;

L20:
    m = linbf_1.nf - 1;
    a[0] = (float)1.;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
/* L30: */
	a[i] = c[i - 1];
    }
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
/* L40: */
	b[i - 1] = (linbf_1.nf - i + 1) * a[i - 1];
    }

/*   COMPUTE REZULTANT (IN LOGARITHMIC SCALE) */

    rzltnt_(&linbf_1.nf, &m, a, b, work5_1.u, dev);
    return;

/*   CASE: PHASE DIMENSION NF > 2 */

L50:
/* Computing 2nd power */
    d__1 = linbf2_1.d[0] + linbf2_1.d[3];
    *dev = d__1 * d__1 - (linbf2_1.d[0] * linbf2_1.d[3] - linbf2_1.d[1] * 
	    linbf2_1.d[2]) * (float)4.;
    return;
} /* epdetev_ */

