/* epfunbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epfunbf_(doublereal *x, doublereal *f, shortint *ier, shortint *istop)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    doublereal djac, dkrv;
    doublereal dntv, dvpr;
    shortint i, k;
    shortint nk;
    doublereal vl;
    doublereal drg, dev, qdr;
    shortint ier1, iln1;


/*   COMPUTING DETERMINING FUNCTIONS FOR LOCAL BIFURCATION CURVES */

/*          18.05.1990 */
/*          08.08.1991 */
/*          15.11.92 */
/*          06.09.93 */
/*          10.07.94 */

    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    *ier = 0;
    *istop = 0;
    nk = linbf_1.nf + linbf_1.nap;
    linbfe_1.ipr = 1;
    for( i = 1; i <= linbf_1.nap; i++ ) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L1: */
    }
    if( linbfo_1.indfun != 0 )
      goto L3;
    funs_(&x[1], &f[1]);
    *ier = ierfs_1.ierfs;
    if( ierfs_1.ierfs != 0 )
      goto L1000;
L3:
    switch( linbf_1.nap ) {
    case 1:  goto L1000;
    case 2:  goto L5;
    case 3:  goto L100;
    case 4:  goto L200;
    }
L5:
    switch( linbf_1.iln ) {
    case 1:  goto L10;
    case 2:  goto L20;
    case 3:  goto L30;
    case 4:  goto L40;
    }

/*   Fold curve */
L10:
    detjac_(&nk, &x[1], &djac, ier);
    f[linbf_1.nf + 1] = djac;
    goto L1000;

/*   Hopf curve */
L20:
    detrg_(&nk, &x[1], &drg, ier);
    f[linbf_1.nf + 1] = drg;
    goto L1000;

/*   L1=0 curve */
L30:
    vlp_(&nk, &x[1], &vl, ier);
    f[linbf_1.nf + 1] = vl;
    if (*ier != 0) {
	goto L1000;
    }
    eiglbf_(&nk, &x[1], &ier1);
    goto L1000;

/*   Double eigenvalue curve */
L40:
    detev_(&nk, &x[1], &dev, ier);
    f[linbf_1.nf + 1] = dev;
    goto L1000;

L100:
    iln1 = linbf_1.iln - 10;
    switch ((int)iln1) {
	case 1:  goto L110;
	case 2:  goto L110;
	case 3:  goto L130;
	case 4:  goto L140;
	case 5:  goto L150;
	case 6:  goto L160;
	case 7:  goto L170;
    }

/*   Double zero curve and Fold+Hopf curve  (ILN=11,12) */
L110:
    detjac_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = djac;
    detrg_(&nk, &x[1], &drg, ier);
    f[linbf_1.nf + 2] = drg;
    goto L1000;

/*   Double Hopf curve (ILN=13) */
L130:
    return;

/*   Cusp curve  (ILN=14) */
L140:
    detjac_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = djac;
    quadr_(&nk, &x[1], &qdr, ier);
    f[linbf_1.nf + 2] = qdr;
    if (*ier == 0) {
	goto L1000;
    }
    eiglbf_(&nk, &x[1], &ier1);
    goto L1000;

/*   Degenerate Hopf curve (ILN=15) */
L150:
    detrg_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = drg;
    vlp_(&nk, &x[1], &vl, ier);
    f[linbf_1.nf + 2] = vl;
    if (*ier == 0) {
	goto L1000;
    }
    eiglbf_(&nk, &x[1], ier);
    goto L1000;

/*   Fold+NT curve  (ILN=16) */
L160:
    detjac_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = djac;
    detkrv_(&nk, &x[1], &dkrv, ier);
    f[linbf_1.nf + 2] = dkrv;
    goto L1000;

/*   Hopf+NT curve  (ILN=17) */
L170:
    detrg_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = drg;
    detntv_(&nk, &x[1], &dntv, ier);
    f[linbf_1.nf + 2] = dntv;
    goto L1000;

L200:
    iln1 = linbf_1.iln - 20;
    switch ((int)linbf_1.iln) {
	case 1:  goto L210;
	case 2:  goto L210;
	case 3:  goto L230;
	case 4:  goto L230;
    }

/*   Degenerate BT and GG curves (ILN=21,22) */
L210:
    detjac_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = djac;
    detrg_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = drg;
    quadr_(&nk, &x[1], &qdr, ier);
    f[linbf_1.nf + 3] = qdr;
    if (*ier == 0) {
	goto L1000;
    }
    eiglbf_(&nk, &x[1], &ier1);
    goto L1000;

/*   BT+NT and GG+NT curves (ILN=23,24) */
L230:
    detjac_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = djac;
    detrg_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = drg;
    detvpr_(&nk, &x[1], &dvpr, ier);
    f[linbf_1.nf + 3] = dvpr;

L1000:
    if (ierfs_1.ierfs < 0)
	*istop = ierfs_1.ierfs;
    if (ihomp_1.ihomp != 0) {
	s__1 = nk - 1;
	for (i = 1; i <= s__1; ++i) {
	    f[i] = ppar_1.p[ihomp_1.ihomp - 1] * f[i] + (1. - ppar_1.p[
		    ihomp_1.ihomp - 1]) * (f[i] - funval_1.fval[i - 1]);
/* L1100: */
	}
    }
    return;

} /* epfunbf_ */

