/* lyapun.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void lyapun_(shortint *n, doublereal *x, void (*funs) (doublereal*, doublereal*), shortint *iprint, doublereal *eps, doublereal *al, doublereal *om, doublereal *vec1, doublereal *vec2, doublereal *vl, shortint *iel)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1, d__2;

    /* Local variables */
    doublereal der23[7*NFMAX-4];
    doublereal derh1[NFMAX2];
    doublereal e[(NFMAX-2)*(NFMAX-2)];
    shortint i, j, l;
    doublereal r, s, scale[NFMAX], derh23[7*NFMAX-4];
    shortint m1;
    shortint nd, nn;
    doublereal epsplo;
    shortint m1e, nm2, igh, ier, int_[NFMAX];
    shortint low;
    doublereal eps1;

    static struct {
      doublereal ann[NFMAX*NFMAX], e1[NFMAX*NFMAX];
    } work7_;
#define work7_1 work7_

    static struct {
      doublereal dh1, dh23;
      shortint ndh1, ndh23;
    } drvr_;
#define drvr_1 drvr_

    static struct {
      doublereal a[NFMAX*NFMAX], rr[NFMAX], ri[NFMAX];
    } mderev_;
#define mderev_1 mderev_



/*   MANAGING PROGRAM FOR COMPUTING FIRST LYAPUNOV VALUE */
/*            23.06.81 */
/*            28.02.90 */
/*            15.11.92 */

    /* Parameter adjustments */
    --vec2;
    --vec1;
    --x;

    /* Function Body */
    m1 = NFMAX;
    m1e = m1 - 2;
    nn = *n * *n;
    nm2 = *n - 2;
    eps1 = 1e-6;
    epsplo = 1e-4;
    *iel = 0;
    nd = *n * 7 - 4;
    drvr_1.dh1 = 1e-7;
    drvr_1.ndh1 = 0;
    drvr_1.dh23 = .005;
    drvr_1.ndh23 = 0;

/*   pE~ATx HA~AlxHyX dAHHyX */

    (*funs)(&x[1], work7_1.ann);
    if (*iprint <= 1) {
	goto L5;
    }

/*   KOHTPOlx zHA~EHij pPAByX ~ACTEj */

L5:
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	if ((d__1 = work7_1.ann[i - 1], fabs(d__1)) <= *eps) {
	    goto L6;
	}
/*   OTKAz: zAdAHHAq TO~KA X HE qBlqETCq CTAciOHAPHOj */
	*iel = 1;
	goto L260;
L6:
	;
    }
    if (ierfs_1.ierfs == 0) {
	goto L7;
    }
    *iel = 6;
    goto L260;
L7:

/*   By~iClEHiE MATPicy liHEAPizAcii - A */

    dervar_(n, &nn, &drvr_1.dh1, &drvr_1.ndh1, &x[1], work7_1.ann, derh1, 
	    der1l_, funs, &ier);
    if (ier == 0) {
	goto L8;
    }
    *iel = 7;
    goto L260;
L8:
    l = 1;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    mderev_1.a[i + j * NFMAX-(NFMAX+1)] = work7_1.ann[l - 1];
	    ++l;
/* L10: */
	}
/* L20: */
    }

/*   By~iClEHiE CObCTBEHHyX zHA~EHij */

    dbalan_(n, n, work7_1.ann, &low, &igh, scale);
    delmhe_(n, n, &low, &igh, work7_1.ann, int_);
    dhqr_(n, n, &low, &igh, work7_1.ann, mderev_1.rr, mderev_1.ri, &ier);
    if (ier == 0) {
	goto L25;
    }
/*   OTKAz: CObCTBEHHyE zHA~EHiq HE HAjdEHy */
    *iel = 2;
    goto L260;
L25:
    if (*iprint <= 1) {
	goto L28;
    }

/*   BydElEHiE blivAj{Ej K MHiMOj OCi */
/*   pAPy CObCTBEHHyX zHA~EHij */

L28:
    *al = mderev_1.rr[0];
    *om = fabs(mderev_1.ri[0]);
    s__1 = *n;
    for (i = 2; i <= s__1; ++i) {
	if (fabs(*al) < (d__1 = mderev_1.rr[i - 1], fabs(d__1))) {
	    goto L40;
	}
	if (fabs(*al) == (d__1 = mderev_1.rr[i - 1], fabs(d__1))) {
	    goto L30;
	}
	*al = mderev_1.rr[i - 1];
	*om = (d__1 = mderev_1.ri[i - 1], fabs(d__1));
	goto L40;
L30:
	if (*om < (d__1 = mderev_1.ri[i - 1], fabs(d__1))) {
	    *om = (d__2 = mderev_1.ri[i - 1], fabs(d__2));
	}
L40:
	;
    }

/*   pPOBEPKA uClOBiq HEjTPAlxHOCTi */

    if (fabs(*al) <= *eps && *om != 0.) {
	goto L45;
    }
/*   OTKAz: HE BypOlHEHO uClOBiE HEjTPAlxHOCTi */
    *iel = 3;
    goto L260;
L45:
    if (*iprint <= 2) {
	goto L50;
    }

/*   AHAliz BzAiMHOgO PACpOlOvEHiq CObCTBEHHyX zHA~EHij */

L50:
    l = 0;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	if ((d__1 = mderev_1.rr[i - 1] - *al, fabs(d__1)) > eps1) {
	    goto L60;
	}
	++l;
L60:
	;
    }
    if (l == 2) {
	goto L70;
    }
/*   OTKAz: dEjCTBiTElxHAq ~ACTx COBpAdAET bOlEE */
/*          ~EM u dBuX CObCTBEHHyX zHA~EHij */
    *iel = 4;
    goto L260;
L70:
/*     pEPEXOd K AHAlizu Clu~Aq N=2 */
    if (*n == 2) {
	goto L240;
    }

/*   OpPEdElEHiE iHBAPiAHTHOj plOCKOCTi */

    if (*om < 1.) {
	epsplo *= *om;
    }
    plo_(n, mderev_1.a, al, om, &vec1[1], &vec2[1], &m1, &epsplo, &ier);
    if (ier == 0) {
	goto L75;
    }
    *iel = 5;
    goto L260;
L75:
    if (*iprint <= 2) {
	goto L80;
    }

/*   pPiBEdEHiE MATPicy liHEAPizAcii K blO~HO-diAgOHAlxHOMu Bidu */

L80:
    block2_(n, mderev_1.a, al, om, &vec1[1], &vec2[1], pq_1.p, pq_1.q, 
	    work7_1.e1, &m1, &ier);
    if ( ier == 0 ) {
	goto L210;
    }
    *iel = 5;
    goto L260;
L210:
    s__1 = *n;
    for (j = 3; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 3; i <= s__2; ++i) {
/* L220: */
	    e[i - 2 + (j - 2) * (NFMAX-2) - (NFMAX-1)] = work7_1.e1[i + j * NFMAX-(NFMAX+1)];
	}
/* L230: */
    }

/*   pEPEXOd K By~iClEHi` lqpuHOBCKOj BEli~iHy */
    goto L250;

/*   AHAliz Clu~Aq N=2 */

L240:
    r = -(*om) / mderev_1.a[NFMAX];
    s = 1.;
    if (r < 0.) {
	s = -1.;
    }
    r = sqrt(s * r);
    vec1[1] = 1. / r;
    vec1[2] = (*al - mderev_1.a[0]) / (mderev_1.a[NFMAX] * r);
    vec2[1] = 0.;
    vec2[2] = -(*om) / (mderev_1.a[NFMAX] * r);
    pq_1.q[0] = vec1[1];
    pq_1.q[1] = vec1[2];
    pq_1.q[NFMAX] = vec2[1];
    pq_1.q[NFMAX+1] = vec2[2];
    pq_1.p[0] = s * pq_1.q[NFMAX+1];
    pq_1.p[1] = -s * pq_1.q[1];
    pq_1.p[NFMAX] = -s * pq_1.q[NFMAX];
    pq_1.p[NFMAX+1] = s * pq_1.q[0];
    if (*iprint <= 2) {
	goto L250;
    }

/*   By~iClEHiE pPOizBOdHyX dlq lqpuHOBCKOj BEli~iHy */

L250:
    dervar_(n, &nd, &drvr_1.dh23, &drvr_1.ndh23, &x[1], der23, derh23, 
	    der23l_, funs, &ier);
    if (ier == 0) {
	goto L251;
    }
    *iel = 8;
    goto L260;

/*   By~iClEHiE lqpuHOBCKOj BEli~iHy */

L251:
    *vl = vliap_(&nm2, al, om, der23, e, &m1e);
    if (*iprint <= 1) {
	goto L1000;
    }
    return;

/*   pE~ATx COOb}EHij Ob OTKAzAX */

L260:
L1000:
    return;
} /* lyapun_ */

