/* cldecsol.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */


void dec_(shortint *n, shortint *ndim, doublereal *a, shortint *ip, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer a_dim1, a_offset;
    doublereal d__1, d__2;

    /* Local variables */
    shortint i, j, k, m;
    doublereal t;
    shortint nm1, kp1;

/* VERSION REAL DOUBLE PRECISION */
/* -----------------------------------------------------------------------
 */
/*  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION. */
/*  INPUT.. */
/*     N = ORDER OF MATRIX. */
/*     NDIM = DECLARED DIMENSION OF ARRAY  A . */
/*     A = MATRIX TO BE TRIANGULARIZED. */
/*  OUTPUT.. */
/*     A(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U . */
/*     A(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L. */
/*     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW. */
/*     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O . */
/*     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE */
/*           SINGULAR AT STAGE K. */
/*  USE  SOL  TO OBTAIN SOLUTION OF LINEAR SYSTEM. */
/*  DETERM(A) = IP(N)*A(1,1)*A(2,2)*...*A(N,N). */
/*  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO. */

/*  REFERENCE.. */
/*     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER, */
/*     C.A.C.M. 15 (1972), P. 274. */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --ip;
    a_dim1 = *ndim;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *ier = 0;
    ip[*n] = 1;
    if (*n == 1) {
	goto L70;
    }
    nm1 = *n - 1;
    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;
	m = k;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
/* L10: */
	    if ((d__1 = a[i + k * a_dim1], fabs(d__1)) > (d__2 = a[m + k * 
		    a_dim1], fabs(d__2))) {
		m = i;
	    }
	}
	ip[k] = m;
	t = a[m + k * a_dim1];
	if (m == k) {
	    goto L20;
	}
	ip[*n] = -ip[*n];
	a[m + k * a_dim1] = a[k + k * a_dim1];
	a[k + k * a_dim1] = t;
L20:
	if (t == 0.) {
	    goto L80;
	}
	t = 1. / t;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
/* L30: */
	    a[i + k * a_dim1] = -a[i + k * a_dim1] * t;
	}
	s__2 = *n;
	for (j = kp1; j <= s__2; ++j) {
	    t = a[m + j * a_dim1];
	    a[m + j * a_dim1] = a[k + j * a_dim1];
	    a[k + j * a_dim1] = t;
	    if (t == 0.) {
		goto L50;
	    }
	    s__3 = *n;
	    for (i = kp1; i <= s__3; ++i) {
/* L40: */
		a[i + j * a_dim1] += a[i + k * a_dim1] * t;
	    }
L50:
	    ;
	}
/* L60: */
    }
L70:
    k = *n;
    if (a[*n + *n * a_dim1] == 0.) {
	goto L80;
    }
    return;
L80:
    *ier = k;
    ip[*n] = 0;
    return;
/* ----------------------- END OF SUBROUTINE DEC -------------------------
 */
} /* dec_ */



void sol_(shortint *n, shortint *ndim, doublereal *a, doublereal *b, shortint *ip)
{
    /* System generated locals */
    shortint s__1, s__2;
    integer a_dim1, a_offset;

    /* Local variables */
    static shortint i, k, m;
    static doublereal t;
    static shortint kb, km1, nm1, kp1;

/* VERSION REAL DOUBLE PRECISION */
/* -----------------------------------------------------------------------
 */
/*  SOLUTION OF LINEAR SYSTEM, A*X = B . */
/*  INPUT.. */
/*    N = ORDER OF MATRIX. */
/*    NDIM = DECLARED DIMENSION OF ARRAY  A . */
/*    A = TRIANGULARIZED MATRIX OBTAINED FROM DEC. */
/*    B = RIGHT HAND SIDE VECTOR. */
/*    IP = PIVOT VECTOR OBTAINED FROM DEC. */
/*  DO NOT USE IF DEC HAS SET IER .NE. 0. */
/*  OUTPUT.. */
/*    B = SOLUTION VECTOR, X . */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --ip;
    --b;
    a_dim1 = *ndim;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    if (*n == 1) {
	goto L50;
    }
    nm1 = *n - 1;
    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;
	m = ip[k];
	t = b[m];
	b[m] = b[k];
	b[k] = t;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
/* L10: */
	    b[i] += a[i + k * a_dim1] * t;
	}
/* L20: */
    }
    s__1 = nm1;
    for (kb = 1; kb <= s__1; ++kb) {
	km1 = *n - kb;
	k = km1 + 1;
	b[k] /= a[k + k * a_dim1];
	t = -b[k];
	s__2 = km1;
	for (i = 1; i <= s__2; ++i) {
/* L30: */
	    b[i] += a[i + k * a_dim1] * t;
	}
/* L40: */
    }
L50:
    b[1] /= a[a_dim1 + 1];
    return;
/* ----------------------- END OF SUBROUTINE SOL -------------------------
 */
} /* sol_ */


void decc_(shortint *n, shortint *ndim, doublereal *ar, doublereal *ai, shortint *ip, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer ar_dim1, ar_offset, ai_dim1, ai_offset;
    doublereal d__1, d__2, d__3, d__4;

    /* Local variables */
    static shortint i, j, k, m;
    static doublereal prodi, prodr, ti, tr;
    static shortint nm1, kp1;
    static doublereal den;

/* VERSION COMPLEX DOUBLE PRECISION */
/* -----------------------------------------------------------------------
 */
/*  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION */
/*  ------ MODIFICATION FOR COMPLEX MATRICES -------- */
/*  INPUT.. */
/*     N = ORDER OF MATRIX. */
/*     NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI . */
/*     (AR, AI) = MATRIX TO BE TRIANGULARIZED. */
/*  OUTPUT.. */
/*     AR(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; REAL PART. */
/*     AI(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; IMAGINARY PART. */
/*     AR(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L. */
/*                                                    REAL PART. */
/*     AI(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L. */
/*                                                    IMAGINARY PART. */
/*     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW. */
/*     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O . */
/*     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE */
/*           SINGULAR AT STAGE K. */
/*  USE  SOL  TO OBTAIN SOLUTION OF LINEAR SYSTEM. */
/*  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO. */

/*  REFERENCE.. */
/*     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER, */
/*     C.A.C.M. 15 (1972), P. 274. */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --ip;
    ai_dim1 = *ndim;
    ai_offset = ai_dim1 + 1;
    ai -= ai_offset;
    ar_dim1 = *ndim;
    ar_offset = ar_dim1 + 1;
    ar -= ar_offset;

    /* Function Body */
    *ier = 0;
    ip[*n] = 1;
    if (*n == 1) {
	goto L70;
    }
    nm1 = *n - 1;
    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;
	m = k;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
/* L10: */
	    if ((d__1 = ar[i + k * ar_dim1], fabs(d__1)) + (d__2 = ai[i + k * 
		    ai_dim1], fabs(d__2)) > (d__3 = ar[m + k * ar_dim1], fabs(
		    d__3)) + (d__4 = ai[m + k * ai_dim1], fabs(d__4))) {
		m = i;
	    }
	}
	ip[k] = m;
	tr = ar[m + k * ar_dim1];
	ti = ai[m + k * ai_dim1];
	if (m == k) {
	    goto L20;
	}
	ip[*n] = -ip[*n];
	ar[m + k * ar_dim1] = ar[k + k * ar_dim1];
	ai[m + k * ai_dim1] = ai[k + k * ai_dim1];
	ar[k + k * ar_dim1] = tr;
	ai[k + k * ai_dim1] = ti;
L20:
	if (fabs(tr) + fabs(ti) == 0.) {
	    goto L80;
	}
	den = tr * tr + ti * ti;
	tr /= den;
	ti = -ti / den;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    prodr = ar[i + k * ar_dim1] * tr - ai[i + k * ai_dim1] * ti;
	    prodi = ai[i + k * ai_dim1] * tr + ar[i + k * ar_dim1] * ti;
	    ar[i + k * ar_dim1] = -prodr;
	    ai[i + k * ai_dim1] = -prodi;
/* L30: */
	}
	s__2 = *n;
	for (j = kp1; j <= s__2; ++j) {
	    tr = ar[m + j * ar_dim1];
	    ti = ai[m + j * ai_dim1];
	    ar[m + j * ar_dim1] = ar[k + j * ar_dim1];
	    ai[m + j * ai_dim1] = ai[k + j * ai_dim1];
	    ar[k + j * ar_dim1] = tr;
	    ai[k + j * ai_dim1] = ti;
	    if (fabs(tr) + fabs(ti) == 0.) {
		goto L50;
	    }
	    if (ti == 0.) {
		s__3 = *n;
		for (i = kp1; i <= s__3; ++i) {
		    prodr = ar[i + k * ar_dim1] * tr;
		    prodi = ai[i + k * ai_dim1] * tr;
		    ar[i + j * ar_dim1] += prodr;
		    ai[i + j * ai_dim1] += prodi;
/* L40: */
		}
		goto L50;
	    }
	    if (tr == 0.) {
		s__3 = *n;
		for (i = kp1; i <= s__3; ++i) {
		    prodr = -ai[i + k * ai_dim1] * ti;
		    prodi = ar[i + k * ar_dim1] * ti;
		    ar[i + j * ar_dim1] += prodr;
		    ai[i + j * ai_dim1] += prodi;
/* L45: */
		}
		goto L50;
	    }
	    s__3 = *n;
	    for (i = kp1; i <= s__3; ++i) {
		prodr = ar[i + k * ar_dim1] * tr - ai[i + k * ai_dim1] * ti;
		prodi = ai[i + k * ai_dim1] * tr + ar[i + k * ar_dim1] * ti;
		ar[i + j * ar_dim1] += prodr;
		ai[i + j * ai_dim1] += prodi;
/* L47: */
	    }
L50:
	    ;
	}
/* L60: */
    }
L70:
    k = *n;
    if ((d__1 = ar[*n + *n * ar_dim1], fabs(d__1)) + (d__2 = ai[*n + *n * 
	    ai_dim1], fabs(d__2)) == 0.) {
	goto L80;
    }
    return;
L80:
    *ier = k;
    ip[*n] = 0;
    return;
/* ----------------------- END OF SUBROUTINE DECC ------------------------
 */
} /* decc_ */



void solc_(shortint *n, shortint *ndim, doublereal *ar, doublereal *ai, doublereal *br, doublereal *bi, shortint *ip)
{
    /* System generated locals */
    shortint s__1, s__2;
    integer ar_dim1, ar_offset, ai_dim1, ai_offset;

    /* Local variables */
    static shortint i, k, m;
    static doublereal prodi, prodr;
    static shortint kb;
    static doublereal ti, tr;
    static shortint km1, nm1, kp1;
    static doublereal den;

/* VERSION COMPLEX DOUBLE PRECISION */
/* -----------------------------------------------------------------------
 */
/*  SOLUTION OF LINEAR SYSTEM, A*X = B . */
/*  INPUT.. */
/*    N = ORDER OF MATRIX. */
/*    NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI. */
/*    (AR,AI) = TRIANGULARIZED MATRIX OBTAINED FROM DEC. */
/*    (BR,BI) = RIGHT HAND SIDE VECTOR. */
/*    IP = PIVOT VECTOR OBTAINED FROM DEC. */
/*  DO NOT USE IF DEC HAS SET IER .NE. 0. */
/*  OUTPUT.. */
/*    (BR,BI) = SOLUTION VECTOR, X . */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --ip;
    --bi;
    --br;
    ai_dim1 = *ndim;
    ai_offset = ai_dim1 + 1;
    ai -= ai_offset;
    ar_dim1 = *ndim;
    ar_offset = ar_dim1 + 1;
    ar -= ar_offset;

    /* Function Body */
    if (*n == 1) {
	goto L50;
    }
    nm1 = *n - 1;
    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;
	m = ip[k];
	tr = br[m];
	ti = bi[m];
	br[m] = br[k];
	bi[m] = bi[k];
	br[k] = tr;
	bi[k] = ti;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    prodr = ar[i + k * ar_dim1] * tr - ai[i + k * ai_dim1] * ti;
	    prodi = ai[i + k * ai_dim1] * tr + ar[i + k * ar_dim1] * ti;
	    br[i] += prodr;
	    bi[i] += prodi;
/* L10: */
	}
/* L20: */
    }
    s__1 = nm1;
    for (kb = 1; kb <= s__1; ++kb) {
	km1 = *n - kb;
	k = km1 + 1;
	den = ar[k + k * ar_dim1] * ar[k + k * ar_dim1] + ai[k + k * ai_dim1] 
		* ai[k + k * ai_dim1];
	prodr = br[k] * ar[k + k * ar_dim1] + bi[k] * ai[k + k * ai_dim1];
	prodi = bi[k] * ar[k + k * ar_dim1] - br[k] * ai[k + k * ai_dim1];
	br[k] = prodr / den;
	bi[k] = prodi / den;
	tr = -br[k];
	ti = -bi[k];
	s__2 = km1;
	for (i = 1; i <= s__2; ++i) {
	    prodr = ar[i + k * ar_dim1] * tr - ai[i + k * ai_dim1] * ti;
	    prodi = ai[i + k * ai_dim1] * tr + ar[i + k * ar_dim1] * ti;
	    br[i] += prodr;
	    bi[i] += prodi;
/* L30: */
	}
/* L40: */
    }
L50:
    den = ar[ar_dim1 + 1] * ar[ar_dim1 + 1] + ai[ai_dim1 + 1] * ai[ai_dim1 + 
	    1];
    prodr = br[1] * ar[ar_dim1 + 1] + bi[1] * ai[ai_dim1 + 1];
    prodi = bi[1] * ar[ar_dim1 + 1] - br[1] * ai[ai_dim1 + 1];
    br[1] = prodr / den;
    bi[1] = prodi / den;
    return;
/* ----------------------- END OF SUBROUTINE SOLC ------------------------
 */
} /* solc_ */

