/* clrad5.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Common Block Declarations */

union {
    struct {
	shortint icont[4];
	doublereal rcont[4*(NFMAX+1)+4];
    } _1;
    struct {
	shortint nn, nn2, nn3, ndum;
	doublereal xsol, hsol, c2m1, c1m1, cont[1];
    } _2;
} cont_;

#define cont_1 (cont_._1)
#define cont_2 (cont_._2)

/* Table of constant values */

static shortint cs__26980 = 4*(NFMAX+1)*(NFMAX+1)+9*(NFMAX+1)+7;
static shortint cs__250 = 3*(NFMAX+1)+7;
static shortint cs__328 = 4*(NFMAX+1)+4;
static doublereal c_b13 = 81.;
static doublereal c_b14 = .33333333333333331;
static doublereal c_b15 = 9.;
static doublereal c_b25 = 1.;
static doublereal c_b46 = .8;
static doublereal c_b70 = .25;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */


void clrad5_(shortint *n, doublereal *t, doublereal *tend, doublereal *x, doublereal *hint, doublereal *hmin, doublereal *hmax, doublereal *epsa, doublereal *epsr, shortint *nmxstp, shortint *mode, shortint *iend, doublereal *work)
{
    shortint ijac, idid, imas;
    doublereal atol;
    shortint itol, iout;
    doublereal rtol;
    shortint i, mljac, mujac, mlmas, mumas;
    shortint iwork[3*(NFMAX+1)+7];

/* * * * * * * * * * * * * * * * * * * * * * * * * * */
/* --- CALL RADAU5 FOR LOCBIF */
/* * * * * * * * * * * * * * * * * * * * * * * * * * */

/*     14.11.92 */
/* -------------------------------------------------- */

/* --- PARAMETERS FOR RADAU5 (FULL JACOBIAN) */
/*        COMMON /CONT1/RCONT(48) */
/* --- DECLARATIONS */
/* --- COMPUTE THE JACOBIAN NUMERICALLY */
    /* Parameter adjustments */
    --work;
    --x;

    /* Function Body */
    ijac = 0;
/* --- JACOBIAN IS A FULL MATRIX */
    mljac = *n;
    mujac = *n;
/* --- DIFFERENTIAL EQUATION IS IN EXPLICIT OR IMPLICIT FORM */
    imas = 0;
    if (cdop5_1.alg != 0.) {
	imas = 1;
    }
    mlmas = 0;
    mumas = 0;
/* --- OUTPUT ROUTINE IS USED DURING INTEGRATION */
    iout = 1;
/* --- REQUIRED TOLERANCE */
    itol = 0;
    atol = *epsa;
    rtol = *epsr;
/* --- DEFAULT VALUES FOR PARAMETERS */
    for (i = 1; i <= 7; ++i) {
	iwork[i - 1] = 0;
	work[i] = 0.;
/* L10: */
    }
    iwork[1] = *nmxstp;
    work[7] = *hmax;
/*      PRINT 102,MODE,NMXSTP,EPSA,EPSR,IWORK(1),IWORK(2),ATOL,RTOL */
/* 102  FORMAT(/'   MODE,NMXSTP,EPSA,EPSR=',2I8,2G13.4, */
/*     *        '                        =',2I8,2G13.4) */
/* --- CALL OF THE SUBROUTINE RADAU5 */
    radau5_(n, funtn_, t, &x[1], tend, hint, &rtol, &atol, &itol, jfun_, &
	    ijac, &mljac, &mujac, masarr_, &imas, &mlmas, &mumas, solou1_, &
	    iout, &work[1], &cs__26980, iwork, &cs__250, &cs__328, &idid);

    *iend = idid;

/* --- PRINT FINAL SOLUTION */
/* --- PRINT STATISTICS */
    return;
} /* clrad5_ */


void solou1_(shortint *nr, doublereal *told, doublereal *t, doublereal *x, shortint *n, shortint *irtrn)
{
    static doublereal h;
    static shortint icode, istop;

/* --- CALL FOR OUTDUM (OUTPUT SUBROUTINE) */
/* CC --- PRINTS SOLUTION AT EQUIDISTANT OUTPUT-POINTS */
/* CC --- BY USING "CONTR5", THE CONTINUOUS COLLOCATION SOLUTION */
/*        COMMON /INTERN/XOUT */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    h = *t - *told;
    if (*nr == 1) {
	icode = 0;
    } else {
	icode = 1;
    }
    outdum_(*n, t, &x[1], &h, icode, &istop);
    if (istop != 0) {
	*irtrn = -5;
    }
    return;
} /* solou1_ */


/*        SUBROUTINE FUNTN1(N,T,X,F) */
/* --- CALL FOR FUNT */
/*        IMPLICIT REAL*8 (A-H,O-Z) */
/*        IMPLICIT INTEGER*2(I-N) */
/*        DIMENSION X(N),F(N) */
/*        CALL FUNT(T,X,F) */
/*        RETURN */
/*        END */

void jfun_(shortint *n, doublereal *t, doublereal *x, doublereal *dfx, shortint *ldfx)
{
    /* System generated locals */
    integer dfx_dim1, dfx_offset;

/* --- EMPTY PROGRAM FOR JACOBIAN */
    /* Parameter adjustments */
    --x;
    dfx_dim1 = *ldfx;
    dfx_offset = dfx_dim1 + 1;
    dfx -= dfx_offset;

    /* Function Body */
    return;
} /* jfun_ */


void masarr_(shortint *n, doublereal *am, shortint *lmas)
{
    /* System generated locals */
    shortint s__1;
    integer am_dim1, am_offset;

    /* Local variables */
    static shortint i;

/* --- MASS MATRIX IN DIAGONAL FORM */
/*        DO 20 I=1,N */
/*          DO 10 J=1,N */
/*            AM(I,J)=0.D0 */
/* 10       CONTINUE */
/* 20     CONTINUE */
/*        DO 30 I=1,N */
/*          IF (I.GT.ALG.AND.N-I+1.GT.-ALG) AM(I,I)=1.D0 */
/* 30     CONTINUE */
    /* Parameter adjustments */
    am_dim1 = *lmas;
    am_offset = am_dim1 + 1;
    am -= am_offset;

    /* Function Body */
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	am[i * am_dim1 + 1] = 0.;
	if ((doublereal) i > cdop5_1.alg && (doublereal) (*n - i + 1) > 
		-cdop5_1.alg) {
	    am[i * am_dim1 + 1] = 1.;
	}
/* L40: */
    }
    return;
} /* masarr_ */


void radau5_(shortint *n, void (*fcn) (shortint *, doublereal *, doublereal *, doublereal *), doublereal *x, doublereal *y, doublereal *xend, doublereal *h, doublereal *rtol, doublereal *atol, shortint *itol, void (*jac) (shortint *, doublereal *, doublereal *, doublereal *, shortint *), shortint *ijac, shortint *mljac, shortint *mujac, void (*mas) (shortint *, doublereal *, shortint *), shortint *imas, shortint *mlmas, shortint *mumas, void (*solout) (shortint *, doublereal *, doublereal *, doublereal *, shortint *, shortint *), shortint *iout, doublereal *work, shortint *lwork, shortint *iwork, shortint *liwork, shortint *lrcont, shortint *idid)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    static doublereal safe, hmax;
    static shortint nmax;
    static doublereal thet;
    static shortint iee2i, iee2r, ieip1, ieip2, nind1, nind2, nind3;
    static doublereal quot1, quot2;
    static shortint i, iejac;
    static logical jband;
    static shortint ldjac, iemas, ldmas, ieiph;
    static logical arret;
    static shortint nhess;
    static doublereal fnewt;
    static shortint ldmas2, iescal;
    static logical implct;
    static shortint istore;
    static logical startn;
    static doublereal uround;
    static shortint nit, iee1, ief1, lde1, ief2, ief3, iey0, iez1, iez2, iez3;

/* ---------------------------------------------------------- */
/*     NUMERICAL SOLUTION OF A STIFF (OR DIFFERENTIAL ALGEBRAIC) */
/*     SYSTEM OF FIRST 0RDER ORDINARY DIFFERENTIAL EQUATIONS */
/*                     M*Y'=F(X,Y). */
/*     THE SYSTEM CAN BE (LINEARLY) IMPLICIT (MASS-MATRIX M .NE. I) */
/*     OR EXPLICIT (M=I). */
/*     THE METHOD USED IS AN IMPLICIT RUNGE-KUTTA METHOD (RADAU IIA) */
/*     OF ORDER 5 WITH STEP SIZE CONTROL AND CONTINUOUS OUTPUT. */
/*     C.F. SECTION IV.8 */

/*     AUTHORS: E. HAIRER AND G. WANNER */
/*              UNIVERSITE DE GENEVE, DEPT. DE MATHEMATIQUES */
/*              CH-1211 GENEVE 24, SWITZERLAND */
/*              E-MAIL:  HAIRER@CGEUGE51.BITNET,  WANNER@CGEUGE51.BITNET 
*/

/*     THIS CODE IS PART OF THE BOOK: */
/*         E. HAIRER AND G. WANNER, SOLVING ORDINARY DIFFERENTIAL */
/*         EQUATIONS II. STIFF AND DIFFERENTIAL-ALGEBRAIC PROBLEMS. */
/*         SPRINGER SERIES IN COMPUTATIONAL MATHEMATICS, */
/*         SPRINGER-VERLAG (1990) */

/*     VERSION OF NOVEMBER 14, 1989 */
/* **** */
/*     ADAPTATION BY A.I.KHIBNIK */
/*                14.01.1991 - 31.01.1991 */
/* **** */

/*     INPUT PARAMETERS */
/*     ---------------- */
/*     N           DIMENSION OF THE SYSTEM */

/*     FCN         NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE */
/*                 VALUE OF F(X,Y): */
/*                    SUBROUTINE FCN(N,X,Y,F) */
/*                    REAL*8 X,Y(N),F(N) */
/*                    F(1)=...   ETC. */

/*     X           INITIAL X-VALUE */

/*     Y(N)        INITIAL VALUES FOR Y */

/*     XEND        FINAL X-VALUE (XEND-X MAY BE POSITIVE OR NEGATIVE) */

/*     H           INITIAL STEP SIZE GUESS; */
/*                 FOR STIFF EQUATIONS WITH INITIAL TRANSIENT, */
/*                 H=1.D0/(NORM OF F'), USUALLY 1.D-3 OR 1.D-5, IS GOOD. 
*/
/*                 THIS CHOICE IS NOT VERY IMPORTANT, THE CODE QUICKLY */
/*                 ADAPTS ITS STEP SIZE. STUDY THE CHOSEN VALUES FOR A FEW
 */
/*                 STEPS IN SUBROUTINE "SOLOUT", WHEN YOU ARE NOT SURE. */
/*                 (IF H=0.D0, THE CODE PUTS H=1.D-6). */

/*     RTOL,ATOL   RELATIVE AND ABSOLUTE ERROR TOLERANCES. THEY */
/*                 CAN BE BOTH SCALARS OR ELSE BOTH VECTORS OF LENGTH N. 
*/

/*     ITOL        SWITCH FOR RTOL AND ATOL: */
/*                   ITOL=0: BOTH RTOL AND ATOL ARE SCALARS. */
/*                     THE CODE KEEPS, ROUGHLY, THE LOCAL ERROR OF */
/*                     Y(I) BELOW RTOL*ABS(Y(I))+ATOL */
/*                   ITOL=1: BOTH RTOL AND ATOL ARE VECTORS. */
/*                     THE CODE KEEPS THE LOCAL ERROR OF Y(I) BELOW */
/*                     RTOL(I)*ABS(Y(I))+ATOL(I). */

/*     JAC         NAME (EXTERNAL) OF THE SUBROUTINE WHICH COMPUTES */
/*                 THE PARTIAL DERIVATIVES OF F(X,Y) WITH RESPECT TO Y */
/*                 (THIS ROUTINE IS ONLY CALLED IF IJAC=1; SUPPLY */
/*                 A DUMMY SUBROUTINE IN THE CASE IJAC=0). */
/*                 FOR IJAC=1, THIS SUBROUTINE MUST HAVE THE FORM */
/*                    SUBROUTINE JAC(N,X,Y,DFY,LDFY) */
/*                    REAL*8 X,Y(N),DFY(LDFY,N) */
/*                    DFY(1,1)= ... */
/*                 LDFY, THE COLUMN-LENGTH OF THE ARRAY, IS */
/*                 FURNISHED BY THE CALLING PROGRAM. */
/*                 IF (MLJAC.EQ.N) THE JACOBIAN IS SUPPOSED TO */
/*                    BE FULL AND THE PARTIAL DERIVATIVES ARE */
/*                    STORED IN DFY AS */
/*                       DFY(I,J) = PARTIAL F(I) / PARTIAL Y(J) */
/*                 ELSE, THE JACOBIAN IS TAKEN AS BANDED AND */
/*                    THE PARTIAL DERIVATIVES ARE STORED */
/*                    DIAGONAL-WISE AS */
/*                       DFY(I-J+MUJAC+1,J) = PARTIAL F(I) / PARTIAL Y(J).
 */

/*     IJAC        SWITCH FOR THE COMPUTATION OF THE JACOBIAN: */
/*                    IJAC=0: JACOBIAN IS COMPUTED INTERNALLY BY FINITE */
/*                       DIFFERENCES, SUBROUTINE "JAC" IS NEVER CALLED. */
/*                    IJAC=1: JACOBIAN IS SUPPLIED BY SUBROUTINE JAC. */

/*     MLJAC       SWITCH FOR THE BANDED STRUCTURE OF THE JACOBIAN: */
/*                    MLJAC=N: JACOBIAN IS A FULL MATRIX. THE LINEAR */
/*                       ALGEBRA IS DONE BY FULL-MATRIX GAUSS-ELIMINATION.
 */
/*                    0<=MLJAC<N: MLJAC IS THE LOWER BANDWITH OF JACOBIAN 
*/
/*                       MATRIX (>= NUMBER OF NON-ZERO DIAGONALS BELOW */
/*                       THE MAIN DIAGONAL). */

/*     MUJAC       UPPER BANDWITH OF JACOBIAN  MATRIX (>= NUMBER OF NON- 
*/
/*                 ZERO DIAGONALS ABOVE THE MAIN DIAGONAL). */
/*                 NEED NOT BE DEFINED IF MLJAC=N. */

/*     ----   MAS,IMAS,MLMAS, AND MUMAS HAVE ANALOG MEANINGS      ----- */
/*     ----   FOR THE "MASS MATRIX" (THE MATRIX "M" OF SECTION IV.8): - */

/*     MAS         NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE MASS- */
/*                 MATRIX M. */
/*                 IF IMAS=0, THIS MATRIX IS ASSUMED TO BE THE IDENTITY */
/*                 MATRIX AND NEEDS NOT TO BE DEFINED; */
/*                 SUPPLY A DUMMY SUBROUTINE IN THIS CASE. */
/*                 IF IMAS=1, THE SUBROUTINE MAS IS OF THE FORM */
/*                    SUBROUTINE MAS(N,AM,LMAS) */
/*                    REAL*8 AM(LMAS,N) */
/*                    AM(1,1)= .... */
/*                    IF (MLMAS.EQ.N) THE MASS-MATRIX IS STORED */
/*                    AS FULL MATRIX LIKE */
/*                         AM(I,J) = M(I,J) */
/*                    ELSE, THE MATRIX IS TAKEN AS BANDED AND STORED */
/*                    DIAGONAL-WISE AS */
/*                         AM(I-J+MUMAS+1,J) = M(I,J). */

/*     IMAS       GIVES INFORMATION ON THE MASS-MATRIX: */
/*                    IMAS=0: M IS SUPPOSED TO BE THE IDENTITY */
/*                       MATRIX, MAS IS NEVER CALLED. */
/*                    IMAS=1: MASS-MATRIX  IS SUPPLIED. */

/*     MLMAS       SWITCH FOR THE BANDED STRUCTURE OF THE MASS-MATRIX: */
/*                    MLMAS=N: THE FULL MATRIX CASE. THE LINEAR */
/*                       ALGEBRA IS DONE BY FULL-MATRIX GAUSS-ELIMINATION.
 */
/*                    0<=MLMAS<N: MLMAS IS THE LOWER BANDWITH OF THE */
/*                       MATRIX (>= NUMBER OF NON-ZERO DIAGONALS BELOW */
/*                       THE MAIN DIAGONAL). */
/*                 MLMAS IS SUPPOSED TO BE .LE. MLJAC. */

/*     MUMAS       UPPER BANDWITH OF MASS-MATRIX (>= NUMBER OF NON- */
/*                 ZERO DIAGONALS ABOVE THE MAIN DIAGONAL). */
/*                 NEED NOT BE DEFINED IF MLMAS=N. */
/*                 MUMAS IS SUPPOSED TO BE .LE. MUJAC. */

/*     SOLOUT      NAME (EXTERNAL) OF SUBROUTINE PROVIDING THE */
/*                 NUMERICAL SOLUTION DURING INTEGRATION. */
/*                 IF IOUT=1, IT IS CALLED AFTER EVERY SUCCESSFUL STEP. */
/*                 SUPPLY A DUMMY SUBROUTINE IF IOUT=0. */
/*                 IT MUST HAVE THE FORM */
/*                    SUBROUTINE SOLOUT (NR,XOLD,X,Y,N,IRTRN) */
/*                    REAL*8 X,Y(N) */
/*                    .... */
/*                 SOLOUT FURNISHES THE SOLUTION "Y" AT THE NR-TH */
/*                    GRID-POINT "X" (THEREBY THE INITIAL VALUE IS */
/*                    THE FIRST GRID-POINT). */
/*                 "XOLD" IS THE PRECEEDING GRID-POINT. */
/*                 "IRTRN" SERVES TO INTERRUPT THE INTEGRATION. IF IRTRN 
*/
/*                    IS SET <0, RADAU5 RETURNS TO THE CALLING PROGRAM. */

/*          -----  CONTINUOUS OUTPUT: ----- */
/*                 DURING CALLS TO "SOLOUT", A CONTINUOUS SOLUTION */
/*                 FOR THE INTERVAL [XOLD,X] IS AVAILABLE THROUGH */
/*                 THE REAL*8 FUNCTION */
/*                        >>>   CONTR5(I,S)   <<< */
/*                 WHICH PROVIDES AN APPROXIMATION TO THE I-TH */
/*                 COMPONENT OF THE SOLUTION AT THE POINT S. THE VALUE */
/*                 S SHOULD LIE IN THE INTERVAL [XOLD,X]. */

/*     IOUT        SWITCH FOR CALLING THE SUBROUTINE SOLOUT: */
/*                    IOUT=0: SUBROUTINE IS NEVER CALLED */
/*                    IOUT=1: SUBROUTINE IS AVAILABLE FOR OUTPUT. */

/*     WORK        ARRAY OF WORKING SPACE OF LENGTH "LWORK". */
/*                 WORK(1), WORK(2),.., WORK(7) SERVE AS PARAMETERS */
/*                 FOR THE CODE. FOR STANDARD USE OF THE CODE */
/*                 WORK(1),..,WORK(7) MUST BE SET TO ZERO BEFORE */
/*                 CALLING. SEE BELOW FOR A MORE SOPHISTICATED USE. */
/*                 WORK(8),..,WORK(LWORK) SERVE AS WORKING SPACE */
/*                 FOR ALL VECTORS AND MATRICES. */
/*                 "LWORK" MUST BE AT LEAST */
/*                             N*(LJAC+LMAS+3*LE+8)+7 */
/*                 WHERE */
/*                    LJAC=N              IF MLJAC=N (FULL JACOBIAN) */
/*                    LJAC=MLJAC+MUJAC+1  IF MLJAC<N (BANDED JAC.) */
/*                 AND */
/*                    LMAS=0              IF IMAS=0 */
/*                    LMAS=N              IF IMAS=1 AND MLMAS=N (FULL) */
/*                    LMAS=MLMAS+MUMAS+1  IF MLMAS<N (BANDED MASS-M.) */
/*                 AND */
/*                    LE=N               IF MLJAC=N (FULL JACOBIAN) */
/*                    LE=2*MLJAC+MUJAC+1 IF MLJAC<N (BANDED JAC.) */

/*                 IN THE USUAL CASE WHERE THE JACOBIAN IS FULL AND THE */
/*                 MASS-MATRIX IS THE INDENTITY (IMAS=0), THE MINIMUM */
/*                 STORAGE REQUIREMENT IS */
/*                             LWORK = 4*N*N+8*N+7. */

/*     LWORK       DECLARED LENGHT OF ARRAY "WORK". */

/*     IWORK       INTEGER WORKING SPACE OF LENGHT "LIWORK". */
/*                 IWORK(1),IWORK(2),...,IWORK(7) SERVE AS PARAMETERS */
/*                 FOR THE CODE. FOR STANDARD USE, SET IWORK(1),.., */
/*                 IWORK(7) TO ZERO BEFORE CALLING. */
/*                 IWORK(8),...,IWORK(LIWORK) SERVE AS WORKING AREA. */
/*                 "LIWORK" MUST BE AT LEAST 3*N+7. */

/*     LIWORK      DECLARED LENGHT OF ARRAY "IWORK". */

/*     LRCONT      DECLARED LENGTH OF COMMON BLOCK */
/*                  >>>  COMMON /CONT/ICONT(4),RCONT(LRCONT)  <<< */
/*                 WHICH MUST BE DECLARED IN THE CALLING PROGRAM. */
/*                 "LRCONT" MUST BE AT LEAST */
/*                             4*N+4 . */
/*                 THIS IS USED FOR STORING THE COEFFICIENTS OF THE */
/*                 CONTINUOUS SOLUTION AND MAKES THE CALLING LIST FOR THE 
*/
/*                 FUNCTION "CONTR5" AS SIMPLE AS POSSIBLE. */

/* ---------------------------------------------------------------------- 
*/

/*     SOPHISTICATED SETTING OF PARAMETERS */
/*     ----------------------------------- */
/*              SEVERAL PARAMETERS OF THE CODE ARE TUNED TO MAKE IT WORK 
*/
/*              WELL. THEY MAY BE DEFINED BY SETTING WORK(1),..,WORK(7) */
/*              AS WELL AS IWORK(1),..,IWORK(7) DIFFERENT FROM ZERO. */
/*              FOR ZERO INPUT, THE CODE CHOOSES DEFAULT VALUES: */

/*    IWORK(1)  IF IWORK(1).NE.0, THE CODE TRANSFORMS THE JACOBIAN */
/*              MATRIX TO HESSENBERG FORM. THIS IS PARTICULARLY */
/*              ADVANTAGEOUS FOR LARGE SYSTEMS WITH FULL JACOBIAN. */
/*              IT DOES NOT WORK FOR BANDED JACOBIAN (MLJAC<N) */
/*              AND NOT FOR IMPLICIT SYSTEMS (IMAS=1). IT IS */
/*              ALSO NOT GOOD FOR SPARSE JACOBIANS. */

/*    IWORK(2)  THIS IS THE MAXIMAL NUMBER OF ALLOWED STEPS. */
/*              THE DEFAULT VALUE (FOR IWORK(2)=0) IS 10000. */

/*    IWORK(3)  THE MAXIMUM NUMBER OF NEWTON ITERATIONS FOR THE */
/*              SOLUTION OF THE IMPLICIT SYSTEM IN EACH STEP. */
/*              THE DEFAULT VALUE (FOR IWORK(3)=0) IS 7. */

/*    IWORK(4)  IF IWORK(4).EQ.0 THE EXTRAPOLATED COLLOCATION SOLUTION */
/*              IS TAKEN AS STARTING VALUE FOR NEWTON'S METHOD. */
/*              IF IWORK(4).NE.0 ZERO STARTING VALUES ARE USED. */
/*              THE LATTER IS RECOMMENDED IF NEWTON'S METHOD HAS */
/*              DIFFICULTIES WITH CONVERGENCE (THIS IS THE CASE WHEN */
/*              NSTEP IS LARGER THAN NACCPT + NREJCT). */
/*              DEFAULT IS IWORK(4)=0. */

/*       THE FOLLOWING 3 PARAMETERS ARE IMPORTANT FOR */
/*       DIFFERENTIAL-ALGEBRAIC SYSTEMS OF INDEX > 1. */
/*       THE FUNCTION-SUBROUTINE SHOULD BE WRITTEN SUCH THAT */
/*       THE INDEX 1,2,3 VARIABLES APPEAR IN THIS ORDER. */
/*       IN ESTIMATING THE ERROR THE INDEX 2 VARIABLES ARE */
/*       MULTIPLIED BY H, THE INDEX 3 VARIABLES BY H**2. */

/*    IWORK(5)  DIMENSION OF THE INDEX 1 VARIABLES (MUST BE > 0). FOR */
/*              ODE'S THIS EQUALS THE DIMENSION OF THE SYSTEM. */
/*              DEFAULT IWORK(5)=N. */

/*    IWORK(6)  DIMENSION OF THE INDEX 2 VARIABLES. DEFAULT IWORK(6)=0. */

/*    IWORK(7)  DIMENSION OF THE INDEX 3 VARIABLES. DEFAULT IWORK(7)=0. */


/*    WORK(1)   UROUND, THE ROUNDING UNIT, DEFAULT 1.D-16. */

/*    WORK(2)   THE SAFETY FACTOR IN STEP SIZE PREDICTION, */
/*              DEFAULT 0.9D0. */

/*    WORK(3)   DECIDES WHETHER THE JACOBIAN SHOULD BE RECOMPUTED; */
/*              INCREASE WORK(3), TO 0.1 SAY, WHEN JACOBIAN EVALUATIONS */
/*              ARE COSTLY. FOR SMALL SYSTEMS WORK(3) SHOULD BE SMALLER */
/*              (0.001D0, SAY). NEGATIV WORK(3) FORCES THE CODE THE */
/*              COMPUTE THE JACOBIAN AFTER EVERY ACCEPTED STEP. */
/*              DEFAULT 0.001D0. */

/*    WORK(4)   STOPPING CRITERION FOR NEWTON'S METHOD, USUALLY CHOSEN <1.
 */
/*              SMALLER VALUES OF WORK(4) MAKE THE CODE SLOWER, BUT SAFER.
 */
/*              DEFAULT 0.03D0. */

/*    WORK(5) AND WORK(6) : IF WORK(5) < HNEW/HOLD < WORK(6), THEN THE */
/*              STEP SIZE IS NOT CHANGED. THIS SAVES, TOGETHER WITH A */
/*              LARGE WORK(3), LU-DECOMPOSITIONS AND COMPUTING TIME FOR */
/*              LARGE SYSTEMS. FOR SMALL SYSTEMS ONE MAY HAVE */
/*              WORK(5)=1.D0, WORK(6)=1.2D0, FOR LARGE FULL SYSTEMS */
/*              WORK(5)=0.99D0, WORK(6)=2.D0 MIGHT BE GOOD. */
/*              DEFAULTS WORK(5)=1.D0, WORK(6)=1.2D0 . */

/*    WORK(7)   MAXIMAL STEP SIZE, DEFAULT XEND-X. */

/* -----------------------------------------------------------------------
 */

/*     OUTPUT PARAMETERS */
/*     ----------------- */
/*     X           X-VALUE FOR WHICH THE SOLUTION HAS BEEN COMPUTED */
/*                 (AFTER SUCCESSFUL RETURN X=XEND). */

/*     Y(N)        NUMERICAL SOLUTION AT X */

/*     H           PREDICTED STEP SIZE OF THE LAST ACCEPTED STEP */

/*     IDID        REPORTS ON SUCCESSFULNESS UPON RETURN: */
/*                   IDID=1  COMPUTATION SUCCESSFUL, */
/*                   IDID<0 COMPUTATION UNSUCCESSFUL. */

/* -----------------------------------------------------------------------
 */
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/*          DECLARATIONS */
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/* --- COMMON STAT CAN BE INSPECTED FOR STATISTICAL PURPOSES: */
/* ---    NFCN      NUMBER OF FUNCTION EVALUATIONS (THOSE FOR NUMERICAL */
/*                  EVALUATION OF THE JACOBIAN ARE NOT COUNTED) */
/* ---    NJAC      NUMBER OF JACOBIAN EVALUATIONS (EITHER ANALYTICALLY */
/*                  OR NUMERICALLY) */
/* ---    NSTEP     NUMBER OF COMPUTED STEPS */
/* ---    NACCPT    NUMBER OF ACCEPTED STEPS */
/* ---    NREJCT    NUMBER OF REJECTED STEPS (DUE TO ERROR TEST), */
/*                  (STEP REJECTIONS IN THE FIRST STEP ARE NOT COUNTED) */
/* ---    NDEC      NUMBER OF LU-DECOMPOSITIONS OF BOTH MATRICES */
/* ---    NSOL      NUMBER OF FORWARD-BACKWARD SUBSTITUTIONS, OF BOTH */
/*                  SYSTEMS; THE NSTEP FORWARD-BACKWARD SUBSTITUTIONS, */
/*                  NEEDED FOR STEP SIZE SELECTION, ARE NOT COUNTED */
/* *** *** *** *** *** *** *** */
/*        SETTING THE PARAMETERS */
/* *** *** *** *** *** *** *** */
    /* Parameter adjustments */
    --y;
    --rtol;
    --atol;
    --work;
    --iwork;

    /* Function Body */
    ierfs_1.ierfs = 0;
    iabort_1.iabort = 0;
    stat_1.nfcn = 0;
    njac_1.njac = 0;
    stat_1.nstep = 0;
    stat_1.naccpt = 0;
    stat_1.nrejct = 0;
    stat_1.ndec = 0;
    stat_1.nsol = 0;
    arret = FALSE_;
/* -------- SWITCH FOR TRANSFORMATION OF JACOBIAN TO HESSIAN FORM --- */
    nhess = iwork[1];
    if (*n <= 2) {
	nhess = 0;
    }
/* -------- NMAX , THE MAXIMAL NUMBER OF STEPS ----- */
    if (iwork[2] == 0) {
	nmax = 10000;
    } else {
	nmax = iwork[2];
	if (nmax <= 0) {
	    arret = TRUE_;
	}
    }
/* -------- NIT    MAXIMAL NUMBER OF NEWTON ITERATIONS */
    if (iwork[3] == 0) {
	nit = 7;
    } else {
	nit = iwork[3];
	if (nit <= 0) {
	    arret = TRUE_;
	}
    }
/* -------- STARTN  SWITCH FOR STARTING VALUES OF NEWTON ITERATIONS */
    if (iwork[4] == 0) {
	startn = FALSE_;
    } else {
	startn = TRUE_;
    }
/* -------- PARAMETER FOR DIFFERENTIAL-ALGEBRAIC COMPONENTS */
    nind1 = iwork[5];
    nind2 = iwork[6];
    nind3 = iwork[7];
    if (nind1 == 0) {
	nind1 = *n;
    }
    if (nind1 + nind2 + nind3 != *n) {
	arret = TRUE_;
    }
/* -------- UROUND   SMALLEST NUMBER SATISFYING 1.D0+UROUND>1.D0 */
    if (work[1] == 0.) {
	uround = 1e-16;
    } else {
	uround = work[1];
	if (uround <= 1e-19 || uround >= 1.) {
	    arret = TRUE_;
	}
    }
/* --------- SAFE     SAFETY FACTOR IN STEP SIZE PREDICTION */
    if (work[2] == 0.) {
	safe = .9;
    } else {
	safe = work[2];
	if (safe <= .001 || safe >= 1.) {
	    arret = TRUE_;
	}
    }
/* ------ THET     DECIDES WHETHER THE JACOBIAN SHOULD BE RECOMPUTED; */
    if (work[3] == 0.) {
	thet = .001;
    } else {
	thet = work[3];
    }
/* --- FNEWT  STOPPING CRITERION FOR NEWTON'S METHOD, USUALLY CHOSEN <1. 
*/
    if (work[4] == 0.) {
	fnewt = .03;
    } else {
	fnewt = work[4];
    }
/* --- QUOT1 AND QUOT2: IF QUOT1 < HNEW/HOLD < QUOT2, STEP SIZE = CONST. 
*/
    if (work[5] == 0.) {
	quot1 = 1.;
    } else {
	quot1 = work[5];
    }
    if (work[6] == 0.) {
	quot2 = 1.2;
    } else {
	quot2 = work[6];
    }
/* -------- MAXIMAL STEP SIZE */
    if (work[7] == 0.) {
	hmax = *xend - *x;
    } else {
	hmax = work[7];
    }
/* --------- CHECK IF TOLERANCES ARE O.K. */
    if (*itol == 0) {
	if (atol[1] <= 0. || rtol[1] <= uround * 10.) {
	    arret = TRUE_;
	}
    } else {
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
	    if (atol[i] <= 0. || rtol[i] <= uround * 10.) {
		arret = TRUE_;
	    }
/* L15: */
	}
    }
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/*         COMPUTATION OF ARRAY ENTRIES */
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/* ---- IMPLICIT, BANDED OR NOT ? */
    implct = *imas != 0;
    jband = *mljac != *n;
/* -------- COMPUTATION OF THE ROW-DIMENSIONS OF THE 2-ARRAYS --- */
/* -- JACOBIAN  AND  MATRICES E1, E2 */
    if (jband) {
	ldjac = *mljac + *mujac + 1;
	lde1 = (*mljac << 1) + *mujac + 1;
    } else {
	ldjac = *n;
	lde1 = *n;
    }
/* -- MASS MATRIX */
    if (implct) {
	if (*mlmas != *n) {
	    ldmas = *mlmas + *mumas + 1;
	} else {
	    ldmas = *n;
	}
/* ------ BANDWITH OF "MAS" NOT LARGER THAN BANDWITH OF "JAC" */
	if (*mlmas > *mljac || *mumas > *mujac) {
	    arret = TRUE_;
	}
    } else {
	ldmas = 0;
    }
    ldmas2 = max(1,(integer) ldmas);
/* ------ HESSENBERG OPTION ONLY FOR EXPLICIT EQU. WITH FULL JACOBIAN */
    if ((implct || jband) && nhess != 0) {
	arret = TRUE_;
    }
/* ------- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN WORK ----- */
    iez1 = 8;
    iez2 = iez1 + *n;
    iez3 = iez2 + *n;
    iey0 = iez3 + *n;
    iescal = iey0 + *n;
    ief1 = iescal + *n;
    ief2 = ief1 + *n;
    ief3 = ief2 + *n;
    iejac = ief3 + *n;
    iemas = iejac + *n * ldjac;
    iee1 = iemas + *n * ldmas;
    iee2r = iee1 + *n * lde1;
    iee2i = iee2r + *n * lde1;
/* ------ TOTAL STORAGE REQUIREMENT ----------- */
    istore = iee2i + *n * lde1 - 1;
    if (istore > *lwork) {
	arret = TRUE_;
    }
/* ------- ENTRY POINTS FOR INTEGER WORKSPACE ----- */
    ieip1 = 8;
    ieip2 = ieip1 + *n;
    ieiph = ieip2 + *n;
/* --------- TOTAL REQUIREMENT --------------- */
    istore = ieiph + *n - 1;
    if (istore > *liwork) {
	arret = TRUE_;
    }
/* --------- CONTROL OF LENGTH OF COMMON BLOCK "CONT" ------- */
    if (*lrcont < (*n << 2) + 4) {
	arret = TRUE_;
    }
/* ------ WHEN A FAIL HAS OCCURED, WE RETURN WITH IDID=-1 */
    if (arret) {
	*idid = -1;
	return;
    }
/* -------- CALL TO CORE INTEGRATOR ------------ */
    radcor_(n, fcn, x, &y[1], xend, &hmax, h, &rtol[1], &atol[1], itol, jac, 
	    ijac, mljac, mujac, mas, imas, mlmas, mumas, solout, iout, idid, &
	    nmax, &uround, &safe, &thet, &fnewt, &quot1, &quot2, &nit, &nhess,
	     &startn, &nind1, &nind2, &nind3, &implct, &jband, &ldjac, &lde1, 
	    &ldmas2, &work[iez1], &work[iez2], &work[iez3], &work[iey0], &
	    work[iescal], &work[ief1], &work[ief2], &work[ief3], &work[iejac],
	     &work[iee1], &work[iee2r], &work[iee2i], &work[iemas], &iwork[
	    ieip1], &iwork[ieip2], &iwork[ieiph]);
/* ----------- RETURN ----------- */
    return;
} /* radau5_ */




/*  ----- ... AND HERE IS THE CORE INTEGRATOR  ---------- */

void radcor_(shortint *n, void (*fcn) (shortint *, doublereal *, doublereal *, doublereal *), doublereal *x, doublereal *y, doublereal *xend, doublereal *hmax, doublereal *h, doublereal *rtol, doublereal *atol, shortint *itol, void (*jac) (shortint *, doublereal *, doublereal *, doublereal *, shortint *), shortint *ijac, shortint *mljac, shortint *mujac, void (*mas) (shortint *, doublereal *, shortint *), shortint *imas, shortint *mlmas, shortint *mumas, void (*solout) (shortint *, doublereal *, doublereal *, doublereal *, shortint *, shortint *), shortint *iout, shortint *idid, shortint *nmax, doublereal *uround, doublereal *safe, doublereal *thet, doublereal *fnewt, doublereal *quot1, doublereal *quot2, shortint *nit, shortint *nhess, logical *startn, shortint *nind1, shortint *nind2, shortint *nind3, logical *implct, logical *banded, shortint *ldjac, shortint *lde1, shortint *ldmas, doublereal *z1, doublereal *z2, doublereal *z3, doublereal *y0, doublereal *scal, doublereal *f1, doublereal *f2, doublereal *f3, doublereal *fjac, doublereal *e1, doublereal *e2r, doublereal *e2i, doublereal *fmas, shortint *ip1, shortint *ip2, shortint *iphes)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer fjac_dim1, fjac_offset, fmas_dim1, fmas_offset, e1_dim1, 
	    e1_offset, e2r_dim1, e2r_offset, e2i_dim1, e2i_offset, i__1, i__2;
    doublereal d__1, d__2, d__3, d__4;

    /* Local variables */
    static doublereal c1mc2, beta, alph, hold, delt;
    static shortint ione;
    static doublereal hnew, xold, dyno, dyth;
    static shortint newt;
    static doublereal hopt, quot;
    static shortint i, mbjac;
    static doublereal hhfac;
    static shortint mdiag, j, mdiff;
    static doublereal betan, alphn, denom, theta, ysafe, hmaxn;
    static shortint nsing;
    static doublereal c1, c2;
    static logical first;
    static shortint i1, irtrn, nrsol, nsolu, n2, n3, i2;
    static doublereal xosol, s1, u1, s2, s3, a1, a2, a3, qnewt, acont3;
    static logical index1, index2, index3;
    static doublereal bb, ak;
    static logical caljac;
    static doublereal fj;
    static shortint mbdiag;
    static doublereal t11, t12, t13, t21, t22, t23, t31, faccon, qt;
    static logical reject;
    static doublereal dd1, dd2, dd3, posneg, ak1, ak2, ak3;
    static shortint j1b, j2b;
    static doublereal dynold, f1i, c1q, c2q, c3q, f2i, f3i, rr0, z1i, z2i, 
	    z3i, sq6, fac;
    static shortint mbb, mle;
    static doublereal ti11, cno, ti12, ti13, ti21, ti22, ti23, ti31, ti32, 
	    ti33;
    static shortint mue, ier;
    static doublereal err;
    static doublereal xph, sum, fac1, hee1, hee2, hee3, cfac;

/* ---------------------------------------------------------- */
/*     CORE INTEGRATOR FOR RADAU5 */
/*     PARAMETERS SAME AS IN RADAU5 WITH WORKSPACE ADDED */
/* ---------------------------------------------------------- */
/*         DECLARATIONS */
/* ---------------------------------------------------------- */
/*      COMMON /CONT/NN,NN2,NN3,NDUM */
/*      COMMON /CONT1/XSOL,HSOL,C2M1,C1M1,CONT(1) */
/* *** */
/* *** */
/* *** *** *** *** *** *** *** */
/*  INITIALISATIONS */
/* *** *** *** *** *** *** *** */
/* *** */
    /* Parameter adjustments */
    --iphes;
    --ip2;
    --ip1;
    --f3;
    --f2;
    --f1;
    --scal;
    --y0;
    --z3;
    --z2;
    --z1;
    --y;
    --rtol;
    --atol;
    fjac_dim1 = *ldjac;
    fjac_offset = fjac_dim1 + 1;
    fjac -= fjac_offset;
    e2i_dim1 = *lde1;
    e2i_offset = e2i_dim1 + 1;
    e2i -= e2i_offset;
    e2r_dim1 = *lde1;
    e2r_offset = e2r_dim1 + 1;
    e2r -= e2r_offset;
    e1_dim1 = *lde1;
    e1_offset = e1_dim1 + 1;
    e1 -= e1_offset;
    fmas_dim1 = *ldmas;
    fmas_offset = fmas_dim1 + 1;
    fmas -= fmas_offset;

    /* Function Body */
    ione = 1;
/* *** */
/* --------- DUPLIFY N FOR COMMON BLOCK CONT ----- */
    cont_2.nn = *n;
    cont_2.nn2 = *n << 1;
    cont_2.nn3 = *n * 3;
/* -------- CHECK THE INDEX OF THE PROBLEM ----- */
    index1 = *nind1 != 0;
    index2 = *nind2 != 0;
    index3 = *nind3 != 0;
/* ------- COMPUTE MASS MATRIX FOR IMPLICIT CASE ---------- */
    if (*implct) {
	(*mas)(n, &fmas[fmas_offset], ldmas);
    }
/* ---------- CONSTANTS --------- */
    sq6 = sqrt(6.);
    c1 = (4. - sq6) / 10.;
    c2 = (sq6 + 4.) / 10.;
    cont_2.c1m1 = c1 - 1.;
    cont_2.c2m1 = c2 - 1.;
    c1mc2 = c1 - c2;
    dd1 = -(sq6 * 7. + 13.) / 3.;
    dd2 = (sq6 * 7. - 13.) / 3.;
    dd3 = -.33333333333333331;
    u1 = (pow(c_b13, c_b14) + 6. - pow(c_b15, c_b14)) / 30.;
    alph = (12. - pow(c_b13, c_b14) + pow(c_b15, c_b14)) / 60.;
    beta = (pow(c_b13, c_b14) + pow(c_b15, c_b14)) * sqrt(3.) / 60.;
/* Computing 2nd power */
    d__1 = alph;
/* Computing 2nd power */
    d__2 = beta;
    cno = d__1 * d__1 + d__2 * d__2;
    t11 = .091232394870892942792;
    t12 = -.14125529502095420843;
    t13 = -.030029194105147424492;
    t21 = .24171793270710701896;
    t22 = .20412935229379993199;
    t23 = .38294211275726193779;
    t31 = .96604818261509293619;
    ti11 = 4.325579890063155351;
    ti12 = .33919925181580986954;
    ti13 = .54177053993587487119;
    ti21 = -4.1787185915519047273;
    ti22 = -.32768282076106238708;
    ti23 = .47662355450055045196;
    ti31 = -.50287263494578687595;
    ti32 = 2.5719269498556054292;
    ti33 = -.59603920482822492497;
    d__1 = *xend - *x;
    posneg = (d__1>=0.0?fabs(c_b25):-fabs(c_b25));
/* Computing MIN */
    d__2 = fabs(*hmax), d__3 = (d__1 = *xend - *x, fabs(d__1));
    hmaxn = min(d__2,d__3);
    if (fabs(*h) <= *uround * 10.) {
	*h = 1e-6;
    }
/* Computing MIN */
    d__1 = fabs(*h);
    *h = min(d__1,hmaxn);
    *h = (posneg>=0.0?fabs(*h):-fabs(*h));
    hold = *h;
    reject = FALSE_;
    first = TRUE_;
    faccon = 1.;
    cfac = *safe * ((*nit << 1) + 1);
    nsing = 0;
    xold = *x;
    if (*iout != 0) {
	irtrn = 1;
	nrsol = 1;
	xosol = xold;
	cont_2.xsol = *x;
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
/* L7: */
	    cont_2.cont[i - 1] = y[i];
	}
	nsolu = *n;
	cont_2.hsol = hold;
	(*solout)(&nrsol, &xosol, &cont_2.xsol, cont_2.cont, &nsolu, &irtrn);
	if (irtrn < 0) {
	    goto L79;
	}
    }
    mle = *mljac;
    mue = *mujac;
    mbjac = *mljac + *mujac + 1;
    mbb = *mlmas + *mumas + 1;
    mdiag = mle + mue + 1;
    mdiff = mle + mue - *mumas;
    mbdiag = *mumas + 1;
    n2 = *n << 1;
    n3 = *n * 3;
    if (*itol == 0) {
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
/* L8: */
	    scal[i] = atol[1] + rtol[1] * (d__1 = y[i], fabs(d__1));
	}
    } else {
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
/* L9: */
	    scal[i] = atol[i] + rtol[i] * (d__1 = y[i], fabs(d__1));
	}
    }
    hhfac = *h;
    (*fcn)(n, x, &y[1], &y0[1]);
    if (ierfs_1.ierfs != 0) {
	goto L78;
    }
    ++stat_1.nfcn;
/* --- BASIC INTEGRATION STEP */
L10:
/* *** *** *** *** *** *** *** */
/*  COMPUTATION OF THE JACOBIAN */
/* *** *** *** *** *** *** *** */
    ++njac_1.njac;
    if (*ijac == 0) {
/* --- COMPUTE JACOBIAN MATRIX NUMERICALLY */
	if (*banded) {
	} else {
/* --- JACOBIAN IS FULL */
	    s__1 = *n;
	    for (i = 1; i <= s__1; ++i) {
		ysafe = y[i];
/*              DELT=DSQRT(UROUND*DMAX1(1.D-5,ABS(YSAFE))) */
/* Computing MAX */
		d__1 = 1., d__2 = fabs(ysafe);
		delt = sqrt(*uround * max(d__1,d__2));
		y[i] = ysafe + delt;
		(*fcn)(n, x, &y[1], cont_2.cont);
		y[i] = ysafe;
		if (ierfs_1.ierfs != 0) {
		    goto L78;
		}
		s__2 = *n;
		for (j = 1; j <= s__2; ++j) {
/* L17: */
		    fjac[j + i * fjac_dim1] = (cont_2.cont[j - 1] - y0[j]) / 
			    delt;
		}
/* L18: */
	    }
	}
    } else {
/* --- COMPUTE JACOBIAN MATRIX ANALYTICALLY */
	(*jac)(n, x, &y[1], &fjac[fjac_offset], ldjac);
    }
    caljac = TRUE_;
L20:
/* *** *** *** *** *** *** *** */
/*  COMPUTE THE MATRICES E1 AND E2 AND THEIR DECOMPOSITIONS */
/* *** *** *** *** *** *** *** */
    fac1 = 1. / (*h * u1);
    alphn = alph / (*h * cno);
    betan = beta / (*h * cno);
    if (*implct) {
	if (*banded) {
/* --- THE MATRIX E (B IS A BANDED MATRIX, JACOBIAN A BANDED MATRI
X) */
	} else {
	    if (*mlmas != *n) {
/* --- THE MATRIX E (B IS A BANDED MATRIX, JACOBIAN A FULL MAT
RIX) */
		s__1 = *n;
		for (j = 1; j <= s__1; ++j) {
		    s__2 = *n;
		    for (i = 1; i <= s__2; ++i) {
			fj = -fjac[i + j * fjac_dim1];
			e1[i + j * e1_dim1] = fj;
			e2r[i + j * e2r_dim1] = fj;
/* L225: */
			e2i[i + j * e2i_dim1] = 0.;
		    }
		}
		s__2 = *n;
		for (j = 1; j <= s__2; ++j) {
/* Computing MAX */
		    i__1 = 1, i__2 = j - *mumas;
		    i1 = max(i__1,i__2);
/* Computing MIN */
		    s__1 = *n, s__3 = j + *mlmas;
		    i2 = min(s__1,s__3);
		    s__1 = i2;
		    for (i = i1; i <= s__1; ++i) {
			bb = fmas[i - j + mbdiag + j * fmas_dim1];
			e1[i + j * e1_dim1] += fac1 * bb;
			e2r[i + j * e2r_dim1] += alphn * bb;
/* L226: */
			e2i[i + j * e2i_dim1] = betan * bb;
		    }
		}
		dec_(n, lde1, &e1[e1_offset], &ip1[1], &ier);
		if (ier != 0) {
		    goto L78;
		}
		decc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &ip2[1], &
			ier);
		if (ier != 0) {
		    goto L78;
		}
	    } else {
/* --- THE MATRIX E (B IS A FULL MATRIX, JACOBIAN A FULL MATRI
X) */
		if (*mljac == *n) {
		    s__1 = *n;
		    for (j = 1; j <= s__1; ++j) {
			s__2 = *n;
			for (i = 1; i <= s__2; ++i) {
			    fj = -fjac[i + j * fjac_dim1];
			    bb = fmas[i + j * fmas_dim1];
			    e1[i + j * e1_dim1] = bb * fac1 + fj;
			    e2r[i + j * e2r_dim1] = bb * alphn + fj;
/* L324: */
			    e2i[i + j * e2i_dim1] = bb * betan;
			}
		    }
		    dec_(n, lde1, &e1[e1_offset], &ip1[1], &ier);
		    if (ier != 0) {
			goto L78;
		    }
		    decc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &ip2[1]
			    , &ier);
		    if (ier != 0) {
			goto L78;
		    }
		} else {
/* --- THE MATRIX E (B IS A FULL MATRIX, JACOBIAN A BANDED
 MATRIX) */
		}
	    }
	}
    } else {
	if (*banded) {
	} else {
/* --- THE MATRIX E (B=IDENTITY, JACOBIAN A FULL MATRIX) */
	    if (*nhess == 0) {
		s__2 = *n;
		for (j = 1; j <= s__2; ++j) {
		    s__1 = *n;
		    for (i = 1; i <= s__1; ++i) {
			fj = -fjac[i + j * fjac_dim1];
			e1[i + j * e1_dim1] = fj;
			e2r[i + j * e2r_dim1] = fj;
/* L525: */
			e2i[i + j * e2i_dim1] = 0.;
		    }
		    e1[j + j * e1_dim1] += fac1;
		    e2r[j + j * e2r_dim1] += alphn;
/* L526: */
		    e2i[j + j * e2i_dim1] = betan;
		}
		dec_(n, lde1, &e1[e1_offset], &ip1[1], &ier);
		if (ier != 0) {
		    goto L78;
		}
		decc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &ip2[1], &
			ier);
		if (ier != 0) {
		    goto L78;
		}
	    } else {
	    }
	}
    }
    ++stat_1.ndec;
L30:
    ++stat_1.nstep;
/* ***  IF (NSTEP.GT.NMAX.OR.X+.1D0*H.EQ.X.OR.DABS(H).LE.UROUND) GOTO 89 
*/
    if (stat_1.nstep > *nmax) {
	goto L89;
    }
    rr0 = *x + *h * .1;
    if (rr0 == *x || fabs(*h) <= *uround) {
	goto L89;
    }
    if (index2) {
	s__2 = *nind1 + *nind2;
	for (i = *nind1 + 1; i <= s__2; ++i) {
/* L465: */
	    scal[i] /= hhfac;
	}
    }
    if (index3) {
	s__2 = *nind1 + *nind2 + *nind3;
	for (i = *nind1 + *nind2 + 1; i <= s__2; ++i) {
/* L466: */
	    scal[i] /= hhfac * hhfac;
	}
    }
    xph = *x + *h;
/* *** *** *** *** *** *** *** */
/*  STARTING VALUES FOR NEWTON ITERATION */
/* *** *** *** *** *** *** *** */
    if (first || *startn) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    z1[i] = 0.;
	    z2[i] = 0.;
	    z3[i] = 0.;
	    f1[i] = 0.;
	    f2[i] = 0.;
/* L32: */
	    f3[i] = 0.;
	}
    } else {
	c3q = *h / hold;
	c1q = c1 * c3q;
	c2q = c2 * c3q;
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    ak1 = cont_2.cont[i + *n - 1];
	    ak2 = cont_2.cont[i + n2 - 1];
	    ak3 = cont_2.cont[i + n3 - 1];
	    z1i = c1q * (ak1 + (c1q - cont_2.c2m1) * (ak2 + (c1q - 
		    cont_2.c1m1) * ak3));
	    z2i = c2q * (ak1 + (c2q - cont_2.c2m1) * (ak2 + (c2q - 
		    cont_2.c1m1) * ak3));
	    z3i = c3q * (ak1 + (c3q - cont_2.c2m1) * (ak2 + (c3q - 
		    cont_2.c1m1) * ak3));
	    z1[i] = z1i;
	    z2[i] = z2i;
	    z3[i] = z3i;
	    f1[i] = ti11 * z1i + ti12 * z2i + ti13 * z3i;
	    f2[i] = ti21 * z1i + ti22 * z2i + ti23 * z3i;
/* L35: */
	    f3[i] = ti31 * z1i + ti32 * z2i + ti33 * z3i;
	}
    }
/* *** *** *** *** *** *** *** */
/*  LOOP FOR THE SIMPLIFIED NEWTON ITERATION */
/* *** *** *** *** *** *** *** */
    newt = 0;
    d__1 = max(faccon,*uround);
    faccon = pow(d__1, c_b46);
    theta = fabs(*thet);
L40:
    if (newt >= *nit) {
	goto L78;
    }
/* ---     COMPUTE THE RIGHT-HAND SIDE */
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L41: */
	cont_2.cont[i - 1] = y[i] + z1[i];
    }
    d__1 = *x + c1 * *h;
    (*fcn)(n, &d__1, cont_2.cont, &z1[1]);
    if (ierfs_1.ierfs != 0) {
	goto L78;
    }
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L42: */
	cont_2.cont[i - 1] = y[i] + z2[i];
    }
    d__1 = *x + c2 * *h;
    (*fcn)(n, &d__1, cont_2.cont, &z2[1]);
    if (ierfs_1.ierfs != 0) {
	goto L78;
    }
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L43: */
	cont_2.cont[i - 1] = y[i] + z3[i];
    }
    (*fcn)(n, &xph, cont_2.cont, &z3[1]);
    if (ierfs_1.ierfs != 0) {
	goto L78;
    }
    stat_1.nfcn += 3;
/* ---     SOLVE THE LINEAR SYSTEMS */
    if (*implct) {
	if (*mlmas != *n) {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
		s1 = 0.;
		s2 = 0.;
		s3 = 0.;
/* Computing MAX */
		i__1 = 1, i__2 = i - *mlmas;
		j1b = max(i__1,i__2);
/* Computing MIN */
		s__1 = *n, s__3 = i + *mumas;
		j2b = min(s__1,s__3);
		s__1 = j2b;
		for (j = j1b; j <= s__1; ++j) {
		    bb = fmas[i - j + mbdiag + j * fmas_dim1];
		    s1 -= bb * f1[j];
		    s2 -= bb * f2[j];
/* L145: */
		    s3 -= bb * f3[j];
		}
		a1 = z1[i];
		a2 = z2[i];
		a3 = z3[i];
		z1[i] = s1 * fac1 + ti11 * a1 + ti12 * a2 + ti13 * a3;
		z2[i] = s2 * alphn - s3 * betan + ti21 * a1 + ti22 * a2 + 
			ti23 * a3;
/* L146: */
		z3[i] = s3 * alphn + s2 * betan + ti31 * a1 + ti32 * a2 + 
			ti33 * a3;
	    }
	    if (*banded) {
	    } else {
		sol_(n, lde1, &e1[e1_offset], &z1[1], &ip1[1]);
		solc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &z2[1], &
			z3[1], &ip2[1]);
	    }
	} else {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
		s1 = 0.;
		s2 = 0.;
		s3 = 0.;
		s__1 = *n;
		for (j = 1; j <= s__1; ++j) {
		    bb = fmas[i + j * fmas_dim1];
		    s1 -= bb * f1[j];
		    s2 -= bb * f2[j];
/* L245: */
		    s3 -= bb * f3[j];
		}
		a1 = z1[i];
		a2 = z2[i];
		a3 = z3[i];
		z1[i] = s1 * fac1 + ti11 * a1 + ti12 * a2 + ti13 * a3;
		z2[i] = s2 * alphn - s3 * betan + ti21 * a1 + ti22 * a2 + 
			ti23 * a3;
/* L246: */
		z3[i] = s3 * alphn + s2 * betan + ti31 * a1 + ti32 * a2 + 
			ti33 * a3;
	    }
	    sol_(n, lde1, &e1[e1_offset], &z1[1], &ip1[1]);
	    solc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &z2[1], &z3[1],
		     &ip2[1]);
	}
    } else {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    a1 = z1[i];
	    a2 = z2[i];
	    a3 = z3[i];
	    s2 = -f2[i];
	    s3 = -f3[i];
	    z1[i] = -f1[i] * fac1 + ti11 * a1 + ti12 * a2 + ti13 * a3;
	    z2[i] = s2 * alphn - s3 * betan + ti21 * a1 + ti22 * a2 + ti23 * 
		    a3;
/* L345: */
	    z3[i] = s3 * alphn + s2 * betan + ti31 * a1 + ti32 * a2 + ti33 * 
		    a3;
	}
	if (*banded) {
	} else {
	    if (*nhess == 0) {
		sol_(n, lde1, &e1[e1_offset], &z1[1], &ip1[1]);
		solc_(n, lde1, &e2r[e2r_offset], &e2i[e2i_offset], &z2[1], &
			z3[1], &ip2[1]);
	    } else {
	    }
	}
    }
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
	f1[i] += z1[i];
	f2[i] += z2[i];
/* L51: */
	f3[i] += z3[i];
    }
    ++stat_1.nsol;
    ++newt;
    dyno = 0.;
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
	denom = scal[i];
/* L57: */
/* Computing 2nd power */
	d__1 = z1[i] / denom;
/* Computing 2nd power */
	d__2 = z2[i] / denom;
/* Computing 2nd power */
	d__3 = z3[i] / denom;
	dyno = dyno + d__1 * d__1 + d__2 * d__2 + d__3 * d__3;
    }
    dyno = sqrt(dyno / n3);
/* ---     BAD CONVERGENCE OR NUMBER OF ITERATIONS TO LARGE */
    if (newt >= 2 && newt < *nit) {
	theta = dyno / dynold;
	if (theta < .99) {
	    faccon = theta / (1. - theta);
	    i__1 = *nit - 1 - newt;
	    dyth = faccon * dyno * pow(theta, i__1);
/* Computing MAX */
/* Computing MIN */
	    d__3 = 20., d__4 = dyth / *fnewt;
	    d__1 = 1e-4, d__2 = min(d__3,d__4);
	    qnewt = max(d__1,d__2);
	    if (qnewt >= 1.) {
		d__1 = -1. / (*nit + 4. - 1 - newt);
		hhfac = pow(qnewt, d__1) * .8;
		*h = hhfac * *h;
		reject = TRUE_;
		if (caljac) {
		    goto L20;
		}
		goto L10;
	    }
	} else {
	    goto L78;
	}
    }
    dynold = max(dyno,*uround);
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
	f1i = f1[i];
	f2i = f2[i];
	f3i = f3[i];
	z1[i] = t11 * f1i + t12 * f2i + t13 * f3i;
	z2[i] = t21 * f1i + t22 * f2i + t23 * f3i;
/* L58: */
	z3[i] = t31 * f1i + f2i;
    }
    if (faccon * dyno > *fnewt) {
	goto L40;
    }
/* *** *** *** *** *** *** *** */
/*  ERROR ESTIMATION */
/* *** *** *** *** *** *** *** */
    hee1 = dd1 / *h;
    hee2 = dd2 / *h;
    hee3 = dd3 / *h;
    if (*implct) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/* L359: */
	    f1[i] = hee1 * z1[i] + hee2 * z2[i] + hee3 * z3[i];
	}
	if (*mlmas == *n) {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
		sum = 0.;
		s__1 = *n;
		for (j = 1; j <= s__1; ++j) {
/* L360: */
		    sum += fmas[i + j * fmas_dim1] * f1[j];
		}
/* L361: */
		f2[i] = sum;
	    }
	} else {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
		sum = 0.;
/* Computing MAX */
		i__1 = 1, i__2 = i - *mlmas;
		j1b = max(i__1,i__2);
/* Computing MIN */
		s__1 = *n, s__3 = i + *mumas;
		j2b = min(s__1,s__3);
		s__1 = j2b;
		for (j = j1b; j <= s__1; ++j) {
/* L362: */
		    sum += fmas[i - j + mbdiag + j * fmas_dim1] * f1[j];
		}
/* L363: */
		f2[i] = sum;
	    }
	}
    } else {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/* L461: */
	    f2[i] = hee1 * z1[i] + hee2 * z2[i] + hee3 * z3[i];
	}
    }
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L462: */
	cont_2.cont[i - 1] = f2[i] + y0[i];
    }
    if (*banded) {
    } else {
	if (*nhess == 0) {
	    sol_(n, lde1, &e1[e1_offset], cont_2.cont, &ip1[1]);
	} else {
	}
    }
    err = 0.;
    s__2 = *n;
    for (i = 1; i <= s__2; ++i) {
/* L354: */
/* Computing 2nd power */
	d__1 = cont_2.cont[i - 1] / scal[i];
	err += d__1 * d__1;
    }
/* Computing MAX */
    d__1 = sqrt(err / *n);
    err = max(d__1,1e-10);
    if ((first || reject) && err >= 1.) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/* L460: */
	    cont_2.cont[i - 1] = y[i] + cont_2.cont[i - 1];
	}
	(*fcn)(n, x, cont_2.cont, &f1[1]);
	if (ierfs_1.ierfs != 0) {
	    goto L78;
	}
	++stat_1.nfcn;
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/* L463: */
	    cont_2.cont[i - 1] = f1[i] + f2[i];
	}
	if (*banded) {
	} else {
	    if (*nhess == 0) {
		sol_(n, lde1, &e1[e1_offset], cont_2.cont, &ip1[1]);
	    } else {
	    }
	}
	err = 0.;
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/* L364: */
/* Computing 2nd power */
	    d__1 = cont_2.cont[i - 1] / scal[i];
	    err += d__1 * d__1;
	}
/* Computing MAX */
	d__1 = sqrt(err / *n);
	err = max(d__1,1e-10);
    }
/* --- COMPUTATION OF HNEW */
/* --- WE REQUIRE .2<=HNEW/H<=8. */
/* Computing MIN */
    d__1 = *safe, d__2 = cfac / (newt + (*nit << 1));
    fac = min(d__1,d__2);
/* Computing MAX */
/* Computing MIN */
    d__3 = 5., d__4 = pow(err, c_b70) / fac;
    d__1 = .125, d__2 = min(d__3,d__4);
    quot = max(d__1,d__2);
    hnew = *h / quot;
/* *** *** *** *** *** *** *** */
/*  IS THE ERROR SMALL ENOUGH ? */
/* *** *** *** *** *** *** *** */
    if (err < 1.) {
/* --- STEP IS ACCEPTED */
	first = FALSE_;
	++stat_1.naccpt;
	xold = *x;
	hold = *h;
	*x = xph;
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    y[i] += z3[i];
	    z2i = z2[i];
	    z1i = z1[i];
	    cont_2.cont[i + *n - 1] = (z2i - z3[i]) / cont_2.c2m1;
	    ak = (z1i - z2i) / c1mc2;
	    acont3 = z1i / c1;
	    acont3 = (ak - acont3) / c2;
	    cont_2.cont[i + n2 - 1] = (ak - cont_2.cont[i + *n - 1]) / 
		    cont_2.c1m1;
/* L75: */
	    cont_2.cont[i + n3 - 1] = cont_2.cont[i + n2 - 1] - acont3;
	}
	if (*itol == 0) {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
/* L81: */
		scal[i] = atol[1] + rtol[1] * (d__1 = y[i], fabs(d__1));
	    }
	} else {
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
/* L82: */
		scal[i] = atol[i] + rtol[i] * (d__1 = y[i], fabs(d__1));
	    }
	}
	if (*iout != 0) {
	    nrsol = stat_1.naccpt + 1;
	    cont_2.xsol = *x;
	    xosol = xold;
	    s__2 = *n;
	    for (i = 1; i <= s__2; ++i) {
/* L77: */
		cont_2.cont[i - 1] = y[i];
	    }
	    nsolu = *n;
	    cont_2.hsol = hold;
	    (*solout)(&nrsol, &xosol, &cont_2.xsol, cont_2.cont, &nsolu, &
		    irtrn);
	    if (irtrn < 0) {
		goto L79;
	    }
	}
	caljac = FALSE_;
/* ***         IF ((X-XEND)*POSNEG+UROUND.GT.0.D0) THEN */
	rr0 = (*x - *xend) * posneg;
	if (rr0 + *uround > 0.) {
	    *h = hopt;
	    *idid = 1;
	    return;
	}
	(*fcn)(n, x, &y[1], &y0[1]);
	if (ierfs_1.ierfs != 0) {
	    goto L78;
	}
	++stat_1.nfcn;
/* Computing MIN */
	d__1 = fabs(hnew);
	hnew = posneg * min(d__1,hmaxn);
	hopt = hnew;
	if (reject) {
/* Computing MIN */
	    d__1 = fabs(hnew), d__2 = fabs(*h);
	    hnew = posneg * min(d__1,d__2);
	}
	reject = FALSE_;
/* ***         IF ((X+HNEW/QUOT1-XEND)*POSNEG.GT.0.D0) THEN */
	if ((*x + hnew * 1.1 / *quot1 - *xend) * posneg > 0.) {
	    *h = *xend - *x;
	} else {
	    qt = hnew / *h;
	    hhfac = *h;
	    if (theta <= *thet && qt >= *quot1 && qt <= *quot2) {
		goto L30;
	    }
	    *h = hnew;
	}
	hhfac = *h;
	if (theta <= *thet) {
	    goto L20;
	}
	goto L10;
    } else {
/* --- STEP IS REJECTED */
	reject = TRUE_;
	if (first) {
	    *h *= .1;
	    hhfac = .1;
	} else {
	    hhfac = hnew / *h;
	    *h = hnew;
	}
	if (stat_1.naccpt >= 1) {
	    ++stat_1.nrejct;
	}
	if (caljac) {
	    goto L20;
	}
	goto L10;
    }
/* --- UNEXPECTED STEP-REJECTION */
L78:
/* **** RHS FAIL PROCESSING */
    if (ierfs_1.ierfs < 0 || iabort_1.iabort != 0 || stat_1.nfcn == 0) {
/* **** COMPUTATION INTERRUPTED */
	goto L79;
    }
/* **** STEP IS REJECTED */
    if (ier != 0) {
/* $if defined(hib) */
/*          WRITE (6,*) ' MATRIX IS SINGULAR, IER=',IER,' X=',X,' H=',
H */
/* $endif */
	++nsing;
	if (nsing >= 6) {
	    goto L89;
	}
    }
    *h *= .5;
    hhfac = .5;
    reject = TRUE_;
    if (caljac) {
	goto L20;
    }
    goto L10;
/* --- FAIL EXIT */
L79:
    *idid = -5;
    goto L90;
L89:
    *idid = -3;
L90:
/*      IDID=-1 */
    return;
} /* radcor_ */



doublereal contr5_(shortint *i, doublereal *x)
{
    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    static doublereal s;

/* ---------------------------------------------------------- */
/*     THIS FUNCTION CAN BE USED FOR CONINUOUS OUTPUT. IT PROVIDES AN */
/*     APPROXIMATION TO THE I-TH COMPONENT OF THE SOLUTION AT X. */
/*     IT GIVES THE VALUE OF THE COLLOCATION POLYNOMIAL, DEFINED FOR */
/*     THE LAST SUCCESSFULLY COMPUTED STEP (BY RADAU5). */
/* ---------------------------------------------------------- */
/*      COMMON /CONT/NN,NN2,NN3,NDUM */
/*      COMMON /CONT1/XSOL,HSOL,C2M1,C1M1,CONT(1) */
    s = (*x - cont_2.xsol) / cont_2.hsol;
    ret_val = cont_2.cont[*i - 1] + s * (cont_2.cont[*i + cont_2.nn - 1] + (s 
	    - cont_2.c2m1) * (cont_2.cont[*i + cont_2.nn2 - 1] + (s - 
	    cont_2.c1m1) * cont_2.cont[*i + cont_2.nn3 - 1]));
    return ret_val;
} /* contr5_ */

