/* drkts1.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/*      SUBROUTINE DRKTS1(NDIM,X,XEND,Y,HI,HMIN,HMAX,EPS, */



void drkts1_(int ndim, doublereal *xt, double xend, doublereal *y, doublereal *hi, 
	     double hmin, double hmax, double eps, 
	     void (*fct)( shortint*, doublereal *, doublereal *, doublereal *),
	     void (*outp)( int, doublereal *, doublereal *, doublereal *, int, 
			  shortint * ), 
	     shortint *iend, doublereal *dery, doublereal *aux )
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    shortint ndim_;
    shortint irec, ihlf, imod;
    doublereal delt, a[4], b[4], c[4], h;
    shortint i, j, iendd, icode;
    doublereal x;
    shortint istep, itest, istop;
    doublereal r1, r2, aj, bj, cj;
    shortint nh;
    doublereal sh, tk, xmh;
    ndim_ = ndim;
    
/*      SUBROUTINE DRKTS1(PRMT,Y,DERY,NDIM,IEND,FCT,OUTP, AUX) */

/*      COMMON/CDRKAS/HMIN,HMAX,HI,TK,NH */
    /* Parameter adjustments */
    aux -= 9;
    --dery;
    --y;

    /* Function Body */
    ierfs_1.ierfs = 0;
    iabort_1.iabort = 0;
    istop = 0;
    *iend = 0;
    stat_1.nfcn = 0;
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 8] = dery[i] * 0.066666666666666667;
    }
    if ((xend - x) * *hi == 0.) {
	goto L37;
    }
    if (hmin < 0. || *hi < hmin || *hi > hmax) {
	goto L37;
    }

    if (xend > x) {
	h = *hi;
	sh = 1.;
    } else {
	h = -(*hi);
	sh = -1.;
    }

    nh = -1;
    tk = x;
    (*fct)(&ndim_, &x, &y[1], &dery[1]);
    if (ierfs_1.ierfs != 0) {
	goto L36;
    }
    ++stat_1.nfcn;
    a[0] = .5;
    a[1] = .29289321881345248;
    a[2] = 1.7071067811865475;
    a[3] = .16666666666666667;
    b[0] = 2.;
    b[1] = 1.;
    b[2] = 1.;
    b[3] = 2.;
    c[0] = .5;
    c[1] = .29289321881345248;
    c[2] = 1.7071067811865475;
    c[3] = .5;
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 1] = y[i];
	aux[(i << 3) + 2] = dery[i];
	aux[(i << 3) + 3] = 0.;
	aux[(i << 3) + 6] = 0.;
    }
    irec = 0;
    h += h;
    ihlf = -1;
    istep = 0;
    iendd = 0;
    icode = 0;

    x = *xt;


L4:
    if ((xend - x - h * 1.1) * sh > 0.) {
	goto L7;
    }
    h = xend - x;
    iendd = 1;
L7:
    tk = x;
    ++nh;
    printf( "  x=%g  h=%g  nh=%d  XT=%g\n",
	   x, h, nh, *xt );
    (*outp)(ndim, &x, &y[1], &h, icode, &istop);
    icode = 1;
    if (istop != 0) {
	goto L40;
    }
/* L8: */
    itest = 0;
L9:
    ++istep;
    j = 1;

L10:
    aj = a[j - 1];
    bj = b[j - 1];
    cj = c[j - 1];
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	r1 = h * dery[i];
	r2 = aj * (r1 - bj * aux[(i << 3) + 6]);
	y[i] += r2;
	r2 = r2 + r2 + r2;
	aux[(i << 3) + 6] = aux[(i << 3) + 6] + r2 - cj * r1;
    }
    if (j - 4 >= 0) {
	goto L15;
    } else {
	goto L12;
    }
L12:
    ++j;
    if (j - 3 != 0) {
	goto L13;
    } else {
	goto L14;
    }
L13:
    x += h * .5;
L14:
    (*fct)(&ndim_, &x, &y[1], &dery[1]);
    if (ierfs_1.ierfs != 0) {
	goto L36;
    }
    ++stat_1.nfcn;
    goto L10;

L15:
    if (itest > 0) {
	goto L20;
    }
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 4] = y[i];
    }
    itest = 1;
    istep = istep + istep - 2;
L18:
    ++ihlf;
    x -= h;
    h *= .5;
    if (iendd == 0) {
	*hi = fabs(h);
    }
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	y[i] = aux[(i << 3) + 1];
	dery[i] = aux[(i << 3) + 2];
	aux[(i << 3) + 6] = aux[(i << 3) + 3];
    }
    goto L9;

L20:
    imod = istep / 2;
    if (istep - imod - imod == 0) {
	goto L23;
    }
    (*fct)(&ndim_, &x, &y[1], &dery[1]);
    if (ierfs_1.ierfs != 0) {
	goto L36;
    }
    ++stat_1.nfcn;
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 5] = y[i];
	aux[(i << 3) + 7] = dery[i];
    }
    goto L9;

L23:
    delt = 0.;
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	delt += aux[(i << 3) + 8] * (d__1 = aux[(i << 3) + 4] - y[i], fabs(
		d__1));
    }
    if (delt <= eps) {
	goto L28;
    }
    if (h * sh < hmin * 2.) {
	goto L36;
    }
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 4] = aux[(i << 3) + 5];
    }
    istep = istep + istep - 4;
    x -= h;
    iendd = 0;
    goto L18;

L28:
    (*fct)(&ndim_, &x, &y[1], &dery[1]);
    if (ierfs_1.ierfs != 0) {
	goto L36;
    }
    ++stat_1.nfcn;
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	aux[(i << 3) + 1] = y[i];
	aux[(i << 3) + 2] = dery[i];
	aux[(i << 3) + 3] = aux[(i << 3) + 6];
	y[i] = aux[(i << 3) + 5];
	dery[i] = aux[(i << 3) + 7];
    }
    tk = x - h;
    ++nh;
    printf( "  x-h=%g  nh=%d  x=%g  h=%g  XT=%g\n", x-h, nh, x, h, *xt );
/*      CALL OUTP(NDIM,X-H,Y,H,ICODE,ISTOP) */
    xmh = x - h;
    (*outp)(ndim, &xmh, &y[1], &h, icode, &istop);
    printf( "  x-h=%g  nh=%d  x=%g  h=%g  XT=%g\n",
	   x-h, nh, x, h, *xt );
    if (istop != 0) {
	goto L40;
    }
    s__1 = ndim;
    for (i = 1; i <= s__1; ++i) {
	y[i] = aux[(i << 3) + 1];
	dery[i] = aux[(i << 3) + 2];
    }
    irec = ihlf;
    if (iendd > 0) {
	icode = 2;
	(*outp)(ndim, &x, &y[1], &h, icode, &istop);
	if (istop != 0) {
	    goto L40;
	}
	*iend = 1;
	return;
    }
    --ihlf;
    istep /= 2;
    h += h;
    printf( "  x-h=%g  nh=%d  x=%g  h=%g\n", x-h, nh, x, h );
    if (h * sh > hmax) {
	goto L4;
    }
    imod = istep / 2;
    if (istep - imod - imod != 0) {
	goto L4;
    }
    if (delt - eps * .02 > 0.) {
	goto L4;
    }
    --ihlf;
    istep /= 2;
    h += h;
    goto L4;

L36:
    *iend = -3;
    if (ierfs_1.ierfs < 0 || iabort_1.iabort != 0) {
	goto L40;
    }
    return;
L37:
    *iend = -1;
    return;
L40:
    *iend = -5;
    return;
} /* drkts1_ */

