/* integr.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void integr_(shortint *n, doublereal *t, doublereal *tmax, doublereal *x, doublereal *h, doublereal *hmax, doublereal *epsabs, doublereal *epsrel, doublereal *dh, shortint *nmax, shortint *mode, shortint *iend)
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    doublereal epsa, tend, hmin, hint, epsr, 
    work[4*(NFMAX+1)*(NFMAX+1)+9*(NFMAX+1)+7], f[NFMAX+1];
    shortint i;
    shortint nmxstp;


/*   CALL FOR ODEs SOLVERS */

/*       MODE =  1 - DOPRI5 */
/*            =  2 - DOPRI5 */
/*            =  3 - DOPRI5 */
/*            = -1 - RADAU5 */

/*          27.09.90 */
/*          31.01.91 */
/*          16.02.91 */
/* 	   19.08.91 */
/*          14.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *iend = 0;
    d__1 = *h * intout_1.idirec;
    tend = *t + (d__1>=0.0?fabs(*tmax):-fabs(*tmax));
    hmin = 1e-10;
    hint = fabs(*h);
    epsa = *epsabs;
    epsr = *epsrel;
    nmxstp = *nmax;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	f[i - 1] = 1. / *n;
/* L10: */
    }
/*     SELECT CASE */
/*         CASE (1,2,3) */
    if (*mode == 1 || *mode == 2 || *mode == 3) {
	cldop5_(n, t, &tend, &x[1], &hint, &hmin, hmax, &epsa, &epsr, &nmxstp,
		 mode, iend, work);
	if (*iend != 1) {
	    goto L90;
	}
	*iend = 0;
	goto L30;
    }
/*         CASE (4) */
    if (*mode == 4) {
	drkts1_(*n, t, tend, &x[1], &hint, hmin, *hmax, epsa, funtn_, 
		outdum_, iend, f, work);
	if (*iend != 1) {
	    goto L90;
	}
	*iend = 0;
	goto L30;
    }
/*         CASE (-1) */
    if (*mode == -1) {
	clrad5_(n, t, &tend, &x[1], &hint, &hmin, hmax, &epsa, &epsr, &nmxstp,
		 mode, iend, work);
	if (*iend != 1) {
	    goto L90;
	}
	*iend = 0;
	goto L30;
    }
/*         CASE DEFAULT */
    *iend = -1;
/*      END SELECT */

L30:
    return;

L90:
    if (*iend != -5) {
	*iend = -99;
    }
    return;
} /* integr_ */


void outdum_( int n, doublereal *t, doublereal *x, doublereal *h, int icode, shortint *istop )
{
    /* Parameter adjustments */
    --x;

    /* Function Body */
    *istop = 0;
    if (intout_1.iout == 0)
	return;
    if (icode != 1)
	return;
    ++npnt_1.np;
    outpt_(&x[1], npnt_1.np, t, istop);
} /* outdum_ */


void funtn_( shortint *n, doublereal *t, doublereal *x, doublereal *f )
{
/* --- CALL FOR FUNT */
    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    funt_(t, &x[1], &f[1]);
/* --- CALL FOR VALUE OF ADDITIONAL RHS */
    if (adrhs_1.iadrhs != 0) {
	if (ierfs_1.ierfs == 0 && iabort_1.iabort == 0) {
	    fadrhs_(t, &x[1], &f[1]);
	}
    }
} /* funtn_ */

