/* lcfunbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void lcfunbf_(doublereal *x, doublereal *f, shortint *ier, shortint *istop)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    static doublereal djac, fsec;
    static doublereal h[NFMAX];
    static shortint i, k;
    static shortint nk;
    static doublereal drg, dev, qdr, dtr;
    static shortint iln1;


/*   COMPUTING DETERMINING FUNCTIONS FOR LOCAL BIFURCATION CURVES. */
/*      LIMIT CYCLES OF ODEs. */

/*          18.05.1990 */
/*          02.09.1990 */
/*          22.08.1991 */
/*          16.11.92 */
/*          07.09.93 */
/*          08.07.94 */

    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    *ier = 0;
    *istop = 0;
    nk = linbf_1.nf + linbf_1.nap;
    linbfe_1.ipr = 1;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L1: */
    }
    if (linbfo_1.indfun != 0) {
	goto L3;
    }
    funm_(&x[1], &f[1]);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	goto L1000;
    }
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	h[i - 1] = f[i];
	f[i] -= x[i];
/* L2: */
    }

L3:
    fsecpl_(&nk, &x[1], h, &fsec, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 1] = fsec;
/*      CALL FUNS(X,G) */
/*      F(NF+1)=G(ISEC) */
    switch ((int)(linbf_1.nap - 1)) {
	case 1:  goto L1000;
	case 2:  goto L5;
	case 3:  goto L100;
	case 4:  goto L200;
    }
L5:
    switch ((int)linbf_1.iln) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
    }

/*   FOLD CURVE */
L10:
    detfld_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    goto L1000;

/*   HOPF CURVE */
L20:
    dethpf_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = drg;
    goto L1000;

/*   FLIP CURVE */
L30:
    detflp_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    goto L1000;

/*   DOUBLE EIGENVALUE CURVE */
L40:
    detev_(&nk, &x[1], &dev, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = dev;
    goto L1000;

L100:
    iln1 = linbf_1.iln - 10;
    switch ((int)iln1) {
	case 1:  goto L110;
	case 2:  goto L120;
	case 3:  goto L110;
	case 4:  goto L120;
	case 5:  goto L150;
	case 6:  goto L160;
	case 7:  goto L170;
	case 8:  goto L180;
	case 9:  goto L190;
    }

/*   FOLD + HOPF  (ILN=11,13) */
L110:
    detfld_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    dethpf_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = drg;
    goto L1000;

/*   FLIP + HOPF  (ILN=12,14) */
L120:
    detflp_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    dethpf_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = drg;
    goto L1000;

/*   FOLD + FLIP  (ILN=15) */
L150:
    detfld_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    detflp_(&nk, &x[1], &djac, ier);
    f[linbf_1.nf + 3] = djac;
    goto L1000;

/*   CUSP CURVE (ILN=16) */
L160:
    detfld_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    quadr_(&nk, &x[1], &qdr, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = qdr;
    goto L1000;

/*   FOLD + NONTRANSVERSALITY  (ILN=17) */
L170:
    detfld_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    trfld_(&nk, &x[1], &dtr, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = dtr;
    goto L1000;

/*   HOPF + NONTRANSVERSALITY  (ILN=18) */
L180:
    dethpf_(&nk, &x[1], &drg, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = drg;
    trhpf_(&nk, &x[1], &dtr, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = dtr;
    goto L1000;

/*   FLIP + NONTRANSVERSALITY  (ILN=19) */
L190:
    detflp_(&nk, &x[1], &djac, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 2] = djac;
    trflp_(&nk, &x[1], &dtr, ier);
    if (*ier != 0) {
	goto L1000;
    }
    f[linbf_1.nf + 3] = dtr;
    goto L1000;

L200:
    iln1 = linbf_1.iln - 20;
    goto L1000;
/*      GO TO (210,210,230,230),ILN */

L1000:
    if (ierfs_1.ierfs < 0) {
	goto L1200;
    }
    if (ihomp_1.ihomp != 0) {
	s__1 = nk - 1;
	for (i = 1; i <= s__1; ++i) {
	    f[i] = ppar_1.p[ihomp_1.ihomp - 1] * f[i] + (1. - ppar_1.p[
		    ihomp_1.ihomp - 1]) * (f[i] - funval_1.fval[i - 1]);
/* L1100: */
	}
    }
    return;
L1200:
    *istop = ierfs_1.ierfs;
    return;

} /* lcfunbf_ */

