/* lcmodjac.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void lcmodjac_(shortint *nk, doublereal *x, doublereal *d, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    static doublereal f[NFMAX];
    static shortint i, j, k, l;
    static doublereal r, r1, hf[NFMAX];

    static struct {
      doublereal h[NFMAX];
    } finpnt_;
#define finpnt_1 finpnt_


/*   MODIFICATION OF THE JACOBY MATRIX TO STUDY LIMIT CYCLE BIFURCATIONS 
*/
/*        20.02.1991 */
/*        16.11.92 */
/*        18.10.93 */
/*        08.07.94 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF */
/*    IER    - ERROR CONDITION */
/*                 0 - NORMAL VALUE */

    /* Parameter adjustments */
    --x;
    --d;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L10: */
    }
    funs_(&x[1], f);
/*      WRITE (*,*) ' x=',X, ' f =',F,' ier=',IERFS */
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    funs_(finpnt_1.h, hf);
/*      WRITE (*,*) ' h=',H, ' hf=',HF,' ier=',IERFS */
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }

    r1 = 0.;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	r1 += f[i - 1] * hf[i - 1];
    }
/*      WRITE (*,*) ' r1=',r1 */
    if (r1 <= 1e-10) {
	*ier = -1;
	return;
    }

    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	l = linbf_1.nf * (i - 1);
	r = 0.;
	s__2 = linbf_1.nf;
	for (j = 1; j <= s__2; ++j) {
/*          R=R+D(I,J)*F(J) */
	    r += d[l + j] * f[j - 1];
/* L30: */
	}
	s__2 = linbf_1.nf;
	for (j = 1; j <= s__2; ++j) {
/*          D(I,J)=D(I,J)-R*HF(J)/R1 */
	    d[l + j] -= r * hf[j - 1] / r1;
/* L40: */
	}
/* L50: */
    }

    return;
} /* lcmodjac_ */

