/* dervar.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dervar_(shortint *n, shortint *nd, doublereal *dh0, shortint *ndh, doublereal *x, doublereal *der, doublereal *derh, void (*deriv) (/* ??? */), void (*fun) (/* ??? */), shortint *ier)
                 
                
              
                           
/* Subroutine */                            
              
{
    /* Initialized data */

    static doublereal ten = 10.;
    static doublereal e1 = 1.01;
    static doublereal e2 = 1e-8;

    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    shortint ihnd[NFMAX2], i, j;
    doublereal r, r1, r2, dh;
    shortint kd;
    doublereal dh10, der1[NFMAX2], der2[NFMAX2];


/*   CHOOSING THE STEP SIZES FOR NUMERICAL DERIVATIVES */
/*           21.02.90 */
/*           14.11.92 */

    /* Parameter adjustments */
    --x;
    --derh;
    --der;

    /* Function Body */
    *ier = 0;

/*   COMPUTING DERIVATIVES WITH STEP DH0 */

    dh = *dh0;
    (*deriv)(n, nd, &dh, &x[1], &der[1], fun, ier);
    if (*ier != 0) {
	return;
    }
    s__1 = *nd;
    for (i = 1; i <= s__1; ++i) {
	ihnd[i - 1] = 0;
	derh[i] = *dh0;
/* L10: */
    }
    if (*ndh <= 0) {
	goto L100;
    }

/*   PREPARATION FOR MAIN SEARCHING PROCEDURE */

    dh10 = dh * ten;
    (*deriv)(n, nd, &dh10, &x[1], der1, fun, ier);
    if (*ier != 0) {
	return;
    }

/*   SEARCHING OPTIMAL STEP SIZE AND COMPUTING DERIVATIVES */

    kd = 0;
    s__1 = *ndh;
    for (j = 1; j <= s__1; ++j) {
	dh /= ten;
	(*deriv)(n, nd, &dh, &x[1], der2, fun, ier);
	if (*ier != 0) {
	    return;
	}
	s__2 = *nd;
	for (i = 1; i <= s__2; ++i) {
	    if (ihnd[i - 1] > 0) {
		goto L30;
	    }
	    r1 = (d__1 = der[i] - der1[i - 1], fabs(d__1));
	    r2 = (d__1 = der[i] - der2[i - 1], fabs(d__1));
	    r = (d__1 = der[i], fabs(d__1));
	    if (e1 * r2 < r1 && r2 > e2 * r) {
		goto L20;
	    }
	    ihnd[i - 1] = j;
	    ++kd;
	    if (kd == *nd) {
		goto L100;
	    }
	    goto L30;
L20:
	    ihnd[i - 1] = -j;
	    der1[i - 1] = der[i];
	    der[i] = der2[i - 1];
	    derh[i] = dh;
L30:
	    ;
	}
/* L40: */
    }
L100:
    return;
} /* dervar_ */

