/* funadd.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void funadd_( char *funnam, shortint *ierr, doublereal *x, doublereal *funres )
{
    /* Local variables */
    shortint iiifun;
    doublereal rnrmin;

/*         26.08.1991 */
/*         14.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    if( strcmp( funnam, "BIFCRS" ) == 0) {        /*   BIFFN1 */
	*funres = corr1_1.det * corr1_1.sgndet;
	goto L100;
    }

    if (strcmp(funnam, "BIFFN1") == 0) {          /*   BIFFN1 */
	*funres = linbfw_1.funh[0];
	goto L100;
    }

    if (strcmp(funnam, "BIFFN2") == 0) {   /*   BIFFN2 */
	*funres = linbfw_1.funh[1];
	goto L100;
    }

    if (strcmp(funnam, "BIFFN3") == 0) {     /*   BIFFN3 */
	*funres = linbfw_1.funh[2];
	goto L100;
    }

    if (strcmp(funnam, "ARCLNG") == 0) {     /*   Arclengh */
	*funres = linbfw_1.arclng;
	goto L100;
    }

    if (strcmp(funnam, "NPOINT") == 0) { /*   Number of a point on a curve */
	*funres = linbfw_1.rnpt;
	goto L100;
    }

    if (strcmp(funnam, "NFIX  ") == 0) {  /*   Current continuation index */
	*funres = (doublereal) wrto1_1.nfix1;
	goto L100;
    }

    if (strcmp(funnam, "NITER ") == 0) {   /*   Number of newton iterations */
	*funres = (doublereal) wrto6_1.it2;
	goto L100;
    }

    if (strcmp(funnam, "ACCNWT") == 0) {
/*   Achived accuracy of newton procedure at current point */
	*funres = wrto4_1.epsn;
	goto L100;
    }

    if (strcmp(funnam, "HCUR  ") == 0) {  /*   Current step-size */
	*funres = wrto2_1.dmove1;
	goto L100;
    }

    if (strcmp(funnam, "HNEW  ") == 0) {  /*   Chosen step-size */
	*funres = wrto2_1.dmove;
	goto L100;
    }

    if (strcmp(funnam, "INT00 ") == 0 || strcmp(funnam, "SINT00") == 0) {
/*   Integral 0 */
	iiifun = 0;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT00") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT01 ") == 0 || strcmp(funnam, "SINT01") == 0) {
/*   Integral 1 */
	iiifun = 1;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT01") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT02 ") == 0 || strcmp(funnam, "SINT02") == 0) {
/*   Integral 2 */
	iiifun = 2;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT02") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT03 ") == 0 || strcmp(funnam, "SINT03") == 0) {
/*   Integral 3 */
	iiifun = 3;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT03") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT04 ") == 0 || strcmp(funnam, "SINT04") == 0) {
/*   Integral 4 */
	iiifun = 4;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT04") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT05 ") == 0 || strcmp(funnam, "SINT05") == 0) {
/*   Integral 5 */
	iiifun = 5;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT05") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT06 ") == 0 || strcmp(funnam, "SINT06") == 0) {
/*   Integral 6 */
	iiifun = 6;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT06") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT07 ") == 0 || strcmp(funnam, "SINT07") == 0) {
/*   Integral 7 */
	iiifun = 7;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT07") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT08 ") == 0 || strcmp(funnam, "SINT08") == 0) {
/*   Integral 8 */
	iiifun = 8;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT08") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT09 ") == 0 || strcmp(funnam, "SINT09") == 0) {
/*   Integral 9 */
	iiifun = 9;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT09") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

    if (strcmp(funnam, "INT10 ") == 0 || strcmp(funnam, "SINT10") == 0) {
/*   Integral 10 */
	iiifun = 10;
	rnrmin = funcvl_(&iiifun);
	*funres = rnrmin;
	if (strcmp(funnam, "SINT10") == 0) {
	    *funres = sqrt((fabs(*funres)));
	}
	goto L100;
    }

/*   CASE DEFAULT */
    *ierr = -1;
    return;

L100:
    *ierr = 0;

/*      WRITE (6,101) N,M,L,IT,FUNNAM,FUNRES,(FUNH(I),I=1,5) */
/* 101  FORMAT(' N,M,L,IT=',4I4,2X,A6,2X,G11.4,/'  funh=',5G13.4) */
} /* funadd_ */

