/* funcvl.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
doublereal funcvl_(shortint *iiifun)
{
    /* System generated locals */
    shortint s__1;
    shortint i__1;
    doublereal ret_val, d__1;

    /* Local variables */
    shortint iend, mode;
    doublereal hmax;
    shortint nmax;
    doublereal tmax, h;
    shortint i, k;
    doublereal t, y[NFMAX+1], dh, epsabs;
    doublereal epsrel;


/*          23.08.1991 */
/*          14.11.92 */

/*      PRINT *,' FUNCVL:--------------------------------' */
/*      PRINT *,'  ILN',ILN,'  IADRHS=',IADRHS,'  IIIFUN=',IIIFUN */
/*      PRINT *,'  XCUR=',(XCUR(I),I=1,6) */
    if (linbf_1.iln == -2) {
	ret_val = 0.;
/*      PRINT *,' FUNCVL:********************************' */
	return ret_val;
    }

    adrhs_1.iadrhs = 1;
    adrhs_1.ifnint = *iiifun;
    ierfs_1.ierfs = 0;
    iend = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = curpnt_1.xcur[linbf_1.nf + i - 1];
    }
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	y[i - 1] = curpnt_1.xcur[i - 1];
/* L10: */
    }
    y[linbf_1.nf] = 0.;
    t = 0.;
    tmax = (d__1 = intgr_1.tmaxi * itmap_1.itmap, fabs(d__1));
    h = intgr_1.hi;
    epsabs = fabs(intgr_1.epsai);
    epsrel = fabs(intgr_1.epsri);
    dh = intgr_1.dhi;
    hmax = fabs(intgr_1.hmxi);
    if (hmax > tmax * .1) {
	hmax = tmax * .1;
    }
    mode = intgr_1.solver;
    nmax = intgr_1.rmxstp;

    i__1 = linbf_1.nf + 1;
    integr_(&i__1, &t, &tmax, y, &h, &hmax, &epsabs, &epsrel, &dh, &nmax, &
	    mode, &iend);
    adrhs_1.iadrhs = 0;
    h = intgr_1.hi;
    if (iend != 0) {
	goto L99;
    }
    ret_val = y[linbf_1.nf];
/*      PRINT *,'  FUNCVL=',FUNCVL */
/*      PRINT *,' FUNCVL:********************************' */
    return ret_val;

L99:
    ret_val = -1e30;
/*      PRINT *,'  FUNCVL=',FUNCVL */
/*      PRINT *,' FUNCVL:********************************' */
    return ret_val;
} /* funcvl_ */


void fadrhs_(doublereal *t, doublereal *x, doublereal *f)
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    static shortint iend, jfun;
    static doublereal g;
    static shortint i;
    static doublereal r, xx[NFMAX+1];

/* --- COMPUTING THE LAST RHS VALUE */
/*      PRINT *,' FADRHS:--------------------------------' */
/*      PRINT *,'  T=',T,'  IFNINT=',IFNINT,'  NF=',NF */
    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    xx[0] = *t;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	xx[i] = x[i];
/* L10: */
    }
    f[linbf_1.nf + 1] = 0.;
    if (adrhs_1.ifnint == 0) {
	r = 0.;
	s__1 = linbf_1.nf;
	for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	    d__1 = x[i];
	    r += d__1 * d__1;
/* L20: */
	}
	f[linbf_1.nf + 1] = r;
/* 	   PRINT *,'  F(NF+1)=',F(NF+1) */
/*           PRINT *,' FADRHS:  1*************************' */
	return;
    } else {
	jfun = abs(adrhs_1.ifnint) - 1;
	iend = 0;
	userfun_(&jfun, &iend, xx, &g);
	if (iend != 0) {
	    goto L100;
	}
	f[linbf_1.nf + 1] = g;
/*        F(NF+1)=(X(1)-X(3))**2+(X(2)-X(4))**2 */
/* 	   PRINT *,'  F(NF+1)=',F(NF+1) */
/*           PRINT *,' FADRHS:  2*************************' */
	return;
    }
/*   ERROR PROCESSING */
L100:
    if (iend < 0) {
	ierfs_1.ierfs = 102;
	iabort_1.iabort = 1;
    } else {
	ierfs_1.ierfs = 103;
    }
    return;
} /* fadrhs_ */

