/* ordbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void ordbf_(shortint *istep, shortint *nk, doublereal *x, shortint *mode, shortint *istop)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    shortint nout, i, j, k, l;
    doublereal r1, r2;
    shortint li, lj;
    doublereal xx[NDIM];
    doublereal arc;

    static struct linbfs__ {
      doublereal arcs[NBUF], xs[NBUF][NDIM], gs[NBUF][IFMAX],
      rrs[NBUF][NFMAX], ris[NBUF][NFMAX], rmods[NBUF][NFMAX],
      args[NBUF][NFMAX], valpts[NBUF][NVALPT];
    } linbfs_;
#define linbfs_1 linbfs_

    static struct linbft__ {
      shortint ivals[NBUF][NVALPT], ipts[NBUF][NPTYP2];
    } linbft_;
#define linbft_1 linbft_

/* 		21.05.1990 */
/*               07.08.1991 */
/*               14.11.92 */
/*      REAL  ARCS,XS,GS,RRS,RIS,VALPTS */
/* ---- */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    switch ((int)*mode) {
	case 1:  goto L1;
	case 2:  goto L100;
    }
    return;
/* ------------------------------------------------------------- */
/* ----	Part 1. Store current point. */
L1:

    if (linbfv_1.nbf < NBUF) {
	goto L10;
    }
    return;
L10:
    ++linbfv_1.nbf;
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	linbfs_1.xs[linbfv_1.nbf-1][i-1] = x[i];
/* L20: */
    }
    for (i = 1; i <= NFMAX; ++i) {
	linbfs_1.rrs[linbfv_1.nbf-1][i-1] = linbfe_1.rr[i - 1];
	linbfs_1.ris[linbfv_1.nbf-1][i-1] = linbfe_1.ri[i - 1];
	linbfs_1.rmods[linbfv_1.nbf-1][i-1] = linbee_1.rmod[i - 1];
	linbfs_1.args[linbfv_1.nbf-1][i-1] = linbee_1.arg[i - 1];
/* L30: */
    }
    for (i = 1; i <= NVALPT; ++i) {
	linbfs_1.valpts[linbfv_1.nbf-1][i-1] = linbfr_1.valpt[i - 1];
	linbft_1.ivals[linbfv_1.nbf-1][i-1] = linbfq_1.ival[i - 1];
/* L40: */
    }
    for (i = 1; i <= IFMAX; ++i) {
	linbfs_1.gs[linbfv_1.nbf-1][i-1] = out1_1.g[i - 1];
/* L50: */
    }
    for (i = 1; i <= NPTYP1; ++i) {
	linbft_1.ipts[linbfv_1.nbf-1][i-1] = linbfq_1.ipt[i - 1];
/* L60: */
    }
    linbft_1.ipts[linbfv_1.nbf-1][NPTYP2-1] = *istep;
    return;
/* ------------------------------------------------------------- */
/* 	Part 2. Order and output stored points. */

L100:
/* 	 To compute secant length. */
    r1 = 0.;
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = linbfu_1.prp[i - 1] - linbfs_1.xs[0][i-1];
	r1 += d__1 * d__1;
/* L110: */
    }
/* 	 To compute the projection coordinate for every point. */
    if (linbfv_1.nbf > 1) {
	goto L120;
    }
    linbfv_1.ns[0] = 1;
    goto L140;
/* ................. */
L120:
    linbfu_1.sc[0] = 1.;
    s__1 = linbfv_1.nbf;
    for (j = 2; j <= s__1; ++j) {
	r2 = 0.;
	s__2 = *nk;
	for (i = 1; i <= s__2; ++i) {
	    r2 += (linbfu_1.prp[i - 1] - linbfs_1.xs[0][i-1]) * (
		    linbfu_1.prp[i - 1] - linbfs_1.xs[j-1][i-1]);
/* L121: */
	}
	linbfu_1.sc[j - 1] = r2 / r1;
/* L122: */
    }
/* 	 To order points. */
/* L130: */
    linbfv_1.ns[linbfv_1.nbf - 1] = 1;
    s__1 = linbfv_1.nbf - 1;
    for (j = 1; j <= s__1; ++j) {
	linbfv_1.ns[j - 1] = j + 1;
/* L131: */
    }
    s__1 = linbfv_1.nbf - 1;
    for (j = 1; j <= s__1; ++j) {
	lj = linbfv_1.ns[j - 1];
	r1 = linbfu_1.sc[lj - 1];
	s__2 = linbfv_1.nbf - 1;
	for (i = j; i <= s__2; ++i) {
	    li = linbfv_1.ns[i - 1];
	    if (linbfu_1.sc[li - 1] >= r1) {
		goto L134;
	    }
	    linbfv_1.ns[i - 1] = lj;
	    linbfv_1.ns[j - 1] = li;
	    r1 = linbfu_1.sc[li - 1];
	    lj = li;
L134:
	    ;
	}
/* L135: */
    }
/* 	 To compute arc length for ordered points. */
L140:
    s__1 = linbfv_1.nbf;
    for (j = 1; j <= s__1; ++j) {
	r1 = 0.;
	l = linbfv_1.ns[j - 1];
	s__2 = *nk;
	for (i = 1; i <= s__2; ++i) {
/* Computing 2nd power */
	    d__1 = (linbfu_1.prp[i - 1] - linbfs_1.xs[l-1][i-1]) * 
		    scaleb_1.scx[i - 1];
	    r1 += d__1 * d__1;
	    linbfu_1.prp[i - 1] = linbfs_1.xs[l-1][i-1];
/* L141: */
	}
	linbfu_1.sca[j - 1] = sqrt(r1);
	linbfu_1.arcl += linbfu_1.sca[j - 1];
	linbfs_1.arcs[l - 1] = linbfu_1.arcl;
/* L142: */
    }
/*        To output the ordered points. */
/* L150: */
    nout = 0;
L151:
    ++nout;
    l = linbfv_1.ns[nout - 1];
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	xx[i - 1] = linbfs_1.xs[l-1][i-1];
/* L160: */
    }
    for (i = 1; i <= NFMAX; ++i) {
	linbfe_1.rr[i - 1] = linbfs_1.rrs[l-1][i-1];
	linbfe_1.ri[i - 1] = linbfs_1.ris[l-1][i-1];
	linbee_1.rmod[i - 1] = linbfs_1.rmods[l-1][i-1];
	linbee_1.arg[i - 1] = linbfs_1.args[l-1][i-1];
/* L170: */
    }
    for (i = 1; i <= NVALPT; ++i) {
	linbfr_1.valpt[i - 1] = linbfs_1.valpts[l-1][i-1];
	linbfq_1.ival[i - 1] = linbft_1.ivals[l-1][i-1];
/* L180: */
    }
    for (i = 1; i <= IFMAX; ++i) {
	out1_1.g[i - 1] = linbfs_1.gs[l-1][i-1];
/* L190: */
    }
    for (i = 1; i <= NPTYP1; ++i) {
	linbfq_1.ipt[i - 1] = linbft_1.ipts[l-1][i-1];
/* L200: */
    }
    linbfq_1.istp = linbft_1.ipts[l-1][NPTYP2-1];
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = linbfs_1.xs[l-1][(linbf_1.nf + i)-1];
/* L210: */
    }
    ++linbfv_1.npc;
    arc = linbfs_1.arcs[l - 1];
    outfun_(nk, xx, &linbfv_1.npc, &arc, istop);
    if (*istop != 0) {
	return;
    }
    outpt_(xx, linbfv_1.npc, &arc, istop);
    if (*istop != 0) {
	return;
    }
    if (nout < linbfv_1.nbf) {
	goto L151;
    }
/* 	 To prepare for the next storing. */
    linbfv_1.nbf = 0;
    return;
} /* ordbf_ */

