/* detflp.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void detflp_(shortint *nk, doublereal *x, doublereal *djac, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    shortint i;
    doublereal r1, r2, r3, r4, r5, r6;
    shortint nfp1;


/*   DETP1 COMPUTE DETERMINANT OF THE JACOBY MATRIX FOR THE CASE -1 */
/*        24.04.1990 */
/*        31.08.1990 */
/*        16.11.92 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    DYAC   - COMPUTED VALUE OF DETERMINANT */
/*    IER    - ERROR CONDITION */
/*               0 - NORMAL VALUE */

/*   VARIABLES IN COMMON BLOCKS: */
/*    NF     - PHASE DIMENSION OF THE PROBLEM */
/*    DHF    - STEPSIZE TO COMPUTE JACOBIAN NUMERICALLY */

/*   WORKING SPACE: */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF CONTAINING JACOBIAN */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funm_, ier);
    if (*ier != 0) {
	return;
    }
    modjac_(nk, &x[1], linbf2_1.d, ier);
    if (*ier != 0) {
	return;
    }

    linbf_1.nf2 = linbf_1.nf * linbf_1.nf;
    nfp1 = linbf_1.nf + 1;
    s__1 = linbf_1.nf2;
    s__2 = nfp1;
    for (i = 1; s__2 < 0 ? i >= s__1 : i <= s__1; i += s__2) {
	linbf2_1.d[i - 1] += 1.;
/* L15: */
    }
    switch ((int)linbf_1.nf) {
	case 1:  goto L20;
	case 2:  goto L30;
	case 3:  goto L40;
    }
    goto L50;

/*   CASE: PHASE DIMENSION NF = 1 */

L20:
    *djac = linbf2_1.d[0];
    return;

/*   CASE: PHASE DIMENSION NF = 2 */

L30:
    *djac = linbf2_1.d[0] * linbf2_1.d[3] - linbf2_1.d[1] * linbf2_1.d[2];
    return;

/*   CASE: PHASE DIMENSION NF = 3 */

L40:
    r1 = linbf2_1.d[0] * linbf2_1.d[4] * linbf2_1.d[8];
    r2 = linbf2_1.d[3] * linbf2_1.d[7] * linbf2_1.d[2];
    r3 = linbf2_1.d[1] * linbf2_1.d[5] * linbf2_1.d[6];
    r4 = linbf2_1.d[6] * linbf2_1.d[4] * linbf2_1.d[2];
    r5 = linbf2_1.d[7] * linbf2_1.d[5] * linbf2_1.d[0];
    r6 = linbf2_1.d[3] * linbf2_1.d[1] * linbf2_1.d[8];
    *djac = r1 + r2 + r3 - r4 - r5 - r6;
    return;

/*   CASE: PHASE DIMENSION NF > 3 */

L50:
    detbf_(linbf2_1.d, &linbf_1.nf, djac);
    return;
} /* detflp_ */

