/* dethpf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dethpf_(shortint *nk, doublereal *x, doublereal *drg, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    doublereal c[NFMAX];
    shortint i, j, k, l, m;
    doublereal r1, r2, r3, r4, r5, r6;
    doublereal ca[NFMAX+1], cb[NFMAX+1];
    shortint lm1;
    doublereal det;
    shortint nfp1;


/*   DETIFI COMPUTE BIFURCATION FUNCTION FOR NEUTRAL EIGENVALUES CASE */
/*                      IN ITERATED MAPS */
/*     (THE FUNCTION IS ADAPTATION OF DETERMINANT OF HURWITZ MATRIX) */
/*        24.04.1990 */
/*        31.08.1990 */
/*        16.11.92 */

/*   FORMAL PARAMETERS: */
/*    NK     - DIMENSION OF THE CONTINUATION PROBLEM */
/*    X      - VECTOR OF THE STATE VARIABLES (LENGTH NK) */
/*    DRG    - COMPUTED VALUE OF DETERMINANT */
/*    IER    - ERROR CONDITION */
/*               0 - NORMAL VALUE */

/*   VARIABLES IN COMMON BLOCKS: */
/*    NF     - PHASE DIMENSION OF THE PROBLEM */
/*    DHF    - STEPSIZE TO COMPUTE JACOBIAN NUMERICALLY */

/*   WORKING SPACE: */
/*    D      - REAL ARRAY OF THE LENGTH NF*NF CONTAINING JACOBIAN */
/*    C      - REAL ARRAY OF THE LENGTH NF CONTAINING COEFFICIENTS OF */
/*               THE CHARACTERISTIC POLINOMIAL */
/*    CA     - REAL ARRAY OF THE LENGTH NF+1 */
/*    CB     - REAL ARRAY OF THE LENGTH NF+1 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;

/*   CASE: PHASE DIMENSION NF = 1 */

    if (linbf_1.nf > 1) {
	goto L10;
    }
    *ier = 1;
    *drg = 1.;
    return;

/*   CASE: PHASE DIMENSION NF > 1 */

L10:
    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funm_, ier);
    if (*ier != 0) {
	return;
    }
    modjac_(nk, &x[1], linbf2_1.d, ier);
    if (*ier != 0) {
	return;
    }

    if (linbf_1.nf == 2) {
	goto L70;
    }
    if (linbf_1.nf == 3) {
	goto L60;
    }

/*   CASE: PHASE DIMENSION NF > 3 */

/*    COMPUTE COEFFICIENTS OF THE CHARACTERISTIC POLINOMIAL */

    koeev1_(linbf2_1.d, &linbf_1.nf, &linbf_1.nf, c, ier);
    if (*ier == 0) {
	goto L20;
    }
    return;

L20:
    nfp1 = linbf_1.nf + 1;
    ca[0] = 1.;
    s__1 = nfp1;
    for (i = 2; i <= s__1; ++i) {
	ca[i - 1] = c[i - 2];
/* L22: */
    }
    s__1 = nfp1;
    for (k = 1; k <= s__1; ++k) {
	l = linbf_1.nf + 2 - k;
	cb[l - 1] = 0.;
	s__2 = l;
	for (i = 1; i <= s__2; ++i) {
	    cb[l - 1] += ca[i - 1];
/* L23: */
	}
	if (l == 1) {
	    goto L25;
	}
	lm1 = l - 1;
	s__2 = lm1;
	for (i = 1; i <= s__2; ++i) {
	    ca[i - 1] = ((l - i) * ca[i - 1] - i * ca[i]) / k;
/* L24: */
	}
L25:
	;
    }
    m = linbf_1.nf - 1;
    k = 0;
    s__1 = m;
    for (i = 1; i <= s__1; ++i) {
	s__2 = m;
	for (j = 1; j <= s__2; ++j) {
	    l = (i << 1) - j;
	    ++k;
	    if (l > linbf_1.nf || l < 1) {
		goto L30;
	    }
	    linbf2_1.d[k - 1] = cb[l];
	    goto L40;
L30:
	    linbf2_1.d[k - 1] = 0.;
	    if (l == 0) {
		linbf2_1.d[k - 1] = cb[0];
	    }
L40:
	    ;
	}
/* L50: */
    }
    detbf_(linbf2_1.d, &m, drg);
    return;

/*   CASE: PHASE DIMENSION NF = 3 */

L60:
    r1 = linbf2_1.d[0] * linbf2_1.d[4] * linbf2_1.d[8];
    r2 = linbf2_1.d[3] * linbf2_1.d[7] * linbf2_1.d[2];
    r3 = linbf2_1.d[1] * linbf2_1.d[5] * linbf2_1.d[6];
    r4 = linbf2_1.d[6] * linbf2_1.d[4] * linbf2_1.d[2];
    r5 = linbf2_1.d[7] * linbf2_1.d[5] * linbf2_1.d[0];
    r6 = linbf2_1.d[3] * linbf2_1.d[1] * linbf2_1.d[8];
    det = r1 + r2 + r3 - r4 - r5 - r6;
    r1 = linbf2_1.d[4] * linbf2_1.d[8] - linbf2_1.d[5] * linbf2_1.d[7];
    r2 = linbf2_1.d[0] * linbf2_1.d[4] - linbf2_1.d[1] * linbf2_1.d[3];
    r3 = linbf2_1.d[0] * linbf2_1.d[8] - linbf2_1.d[2] * linbf2_1.d[6];
/* Computing 2nd power */
    d__1 = det;
    *drg = d__1 * d__1 - (linbf2_1.d[0] + linbf2_1.d[4] + linbf2_1.d[8]) * 
	    det + (r1 + r2 + r3 - 1.);
    return;

/*   CASE: PHASE DIMENSION NF = 2 */

L70:
    *drg = linbf2_1.d[0] * linbf2_1.d[3] - linbf2_1.d[1] * linbf2_1.d[2] - 1.;
    return;
} /* dethpf_ */

