/* fpcodebf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpcodebf_(shortint *iptype, doublereal *bifval)
{
    shortint i, ipt1, ipt2, ipt3, ipt4;


/*   In this subprogram we produce special code */
/*      IPTYPE for every point on a curve */
/*         ITERATED MAPS */
/*          29.05.1989 */
/*          02.09.1990 */
/*          16.11.92 */
/*          10.07.94 */

/* ---- */
/* ---- */
    /* Parameter adjustments */
    --bifval;

    /* Function Body */
    ipt1 = linbfq_1.ipt[0];
    ipt2 = linbfq_1.ipt[1];
    ipt3 = linbfq_1.ipt[2];
    ipt4 = linbfq_1.ipt[3];
    for (i = 1; i <= NBFVL; ++i) {
	bifval[i] = linbfr_1.valpt[i - 1];
/* L1: */
    }
    switch ((int)ipt2) {
	case 1:  goto L1000;
	case 2:  goto L2000;
	case 3:  goto L3000;
	case 4:  goto L4000;
    }

/* =================================================================== */
L1000:
/*   Regular point */
    *iptype = 100;
    if (ipt1 != 2) {
	goto L1100;
    }
/* 			    Hopf line */
    if (ipt3 == 1) {
	*iptype = 101;
    }
/* 				 focus case, L1=BV(1) */
    if (ipt3 == 2) {
	*iptype = 102;
    }
/* 				 focus case, L1=? */
    if (ipt3 == -1) {
	*iptype = 103;
    }
/* 				 saddle case */
L1100:
    if (ipt1 != 1 || ipt1 != 11) {
	return;
    }
/* 			    Mult2 or Bogdanov */
    if (linbfq_1.ival[0] == 0) {
	*iptype = 101;
    }
/* 				 a=BV(1) */
    if (linbfq_1.ival[0] != 0) {
	*iptype = 102;
    }
/* 				 a=? */
    return;

/* =================================================================== */
L2000:
/*   Selfcrossing */
    if (linbfq_1.inder == 0) {
	*iptype = 201;
    }
/* 			    O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 211;
    }
/* 			    Warning */
    return;

/* =================================================================== */
L3000:
/*   Singular point */
    *iptype = 300;
    if (ipt1 == 0) {
	goto L3001;
    }
    if (ipt1 == 1) {
	goto L3011;
    }
    if (ipt1 == 2) {
	goto L3021;
    }
    if (ipt1 == 3) {
	goto L3031;
    }
    if (ipt1 == 4) {
	goto L3041;
    }
    if (ipt1 == 11) {
	goto L3111;
    }
    if (ipt1 == 12) {
	goto L3121;
    }
    if (ipt1 == 13) {
	goto L3131;
    }
    if (ipt1 == 14) {
	goto L3141;
    }
    if (ipt1 == 15) {
	goto L3151;
    }
    if (ipt1 == 16) {
	goto L3161;
    }
    if (ipt1 == 17) {
	goto L3171;
    }
    if (ipt1 == 18) {
	goto L3181;
    }
    if (ipt1 == 19) {
	goto L3191;
    }
    return;

L3001:
/* ---   Equilibrium   --------------------------------- */
    if (ipt3 != 1) {
	goto L3002;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3002:
    if (ipt3 != 2) {
	goto L3003;
    }
/* 		    Neutrality condition */
    if (ipt4 == 1 && linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   focus case, L1=BV(1) */
    if (ipt4 == 1 && linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   warning, focus case, L1=BV(1) */
    if (ipt4 == 2 && linbfq_1.inder == 0) {
	*iptype = 323;
    }
/* 				   focus case, L1=? */
    if (ipt4 == 2 && linbfq_1.inder != 0) {
	*iptype = 324;
    }
/* 				   warning, focus case, L1=? */
    if (ipt4 == -1 && linbfq_1.inder == 0) {
	*iptype = 325;
    }
/* 				   saddle case */
    if (ipt4 == -1 && linbfq_1.inder != 0) {
	*iptype = 326;
    }
/* 				   warning, saddle case */
    return;

L3003:
    if (ipt3 != 3) {
	goto L3004;
    }
/* 		    Flip condition */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
L3004:
    if (ipt3 != 4) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.inder == 0) {
	*iptype = 341;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 342;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3011:
/* ---   Fold    ------------------------------------ */
    if (ipt3 != 1) {
	goto L3012;
    }
/* 		    Neutrality condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3012:
    if (ipt3 != 2) {
	goto L3013;
    }
/* 		    Flip condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 323;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 324;
    }
/*                                Warning, a=? */
L3013:
    if (ipt3 != 3) {
	goto L3014;
    }
/* 		    Cusp */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;
L3014:
    if (ipt3 != 4) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 341;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 342;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 343;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 344;
    }
/*                                Warning, a=? */
    return;
/* ---------------------------------------------------- */
L3021:
/* ---   Hopf   --------------------------------------- */
    if (ipt3 != 1) {
	goto L3022;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3022:
    if (ipt3 != 2) {
	goto L3023;
    }
/* 		    Flip condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
L3023:
    if (ipt3 != 3) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3031:
/* ---   Flip   --------------------------------------- */
    if (ipt3 != 1) {
	goto L3032;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3032:
    if (ipt3 != 2) {
	goto L3033;
    }
/* 		    Neutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
L3033:
    if (ipt3 != 3) {
	return;
    }
/* 		    Multiple eigenvalues */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3041:
/* ---   Multiple eigenvalues	----------------------- */
    if (ipt3 != 1) {
	goto L3042;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3042:
    if (ipt3 != 2) {
	goto L3043;
    }
/* 		    Neutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
L3043:
    if (ipt3 != 3) {
	return;
    }
/* 		    Flip condition */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3111:
/* ---   Bogdanov	  ----------------------------------- */
    if (ipt3 != 1) {
	goto L3112;
    }
/* 		    Cusp */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;
L3112:
    if (ipt3 != 2) {
	return;
    }
/* 		    Flip */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3121:
/* ---   Double -1   --------------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
/* ---------------------------------------------------- */
L3131:
/* ---   Fold + Hopf  -------------------------------- */
    if (ipt3 != 1) {
	goto L3132;
    }
/* 		    Flip condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3132:
    if (ipt3 != 2) {
	return;
    }
/* 		    Cusp */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3141:
/* ---   Flip + Hopf  -------------------------------- */
    if (ipt3 != 1) {
	return;
    }
/* 		    Fold condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

/* ---------------------------------------------------- */
L3151:
/* ---   Fold + Flip  -------------------------------- */
    if (ipt3 != 1) {
	goto L3152;
    }
/* 		    Neutrality condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;

L3152:
    if (ipt3 != 2) {
	return;
    }
/* 		    Cusp */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;

/* ---------------------------------------------------- */
L3161:
/* ---   Cusp	------------------------------------- */
    if (ipt3 != 1) {
	goto L3162;
    }
/* 		    Neutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning */
    return;

L3162:
    if (ipt3 != 2) {
	return;
    }
/* 		    Flip */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3171:
/* ---   Fold + Nontransversality  -------------------- */
    if (ipt3 != 1) {
	goto L3172;
    }
/* 		    Neutrality condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3172:
    if (ipt3 != 2) {
	goto L3173;
    }
/* 		    Flip condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 323;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 324;
    }
/*                                Warning, a=? */
L3173:
    if (ipt3 != 3) {
	return;
    }
/* 		    Cusp */
    if (linbfq_1.inder == 0) {
	*iptype = 331;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 332;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3181:
/* ---   Hopf + Nontransversality  -------------------- */
    if (ipt3 != 1) {
	goto L3182;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3182:
    if (ipt3 != 2) {
	return;
    }
/* 		    Flip condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
/* ---------------------------------------------------- */
L3191:
/* ---   Flip + Nontransversality  -------------------- */
    if (ipt3 != 1) {
	goto L3192;
    }
/* 		    Multiplicity condition */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder == 0) {
	*iptype = 311;
    }
/* 				   a=BV(1) */
    if (linbfq_1.ival[0] == 0 && linbfq_1.inder != 0) {
	*iptype = 312;
    }
/* 				   Warning, a=BV(1) */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder == 0) {
	*iptype = 313;
    }
/* 				   a=? */
    if (linbfq_1.ival[0] != 0 && linbfq_1.inder != 0) {
	*iptype = 314;
    }
/*                                Warning, a=? */
    return;
L3192:
    if (ipt3 != 2) {
	return;
    }
/* 		    Neutrality condition */
    if (linbfq_1.inder == 0) {
	*iptype = 321;
    }
/* 				   O'K */
    if (linbfq_1.inder != 0) {
	*iptype = 322;
    }
/* 				   Warning */
    return;
/* =================================================================== */
L4000:
/*   Extremum */
/* 	      Parameter's number - BV(1),  Extremal value - BV(2) */
    if (ipt3 > 0 && linbfq_1.inder == 0) {
	*iptype = 401;
    }
/* 			   Maximum */
    if (ipt3 < 0 && linbfq_1.inder == 0) {
	*iptype = 402;
    }
/* 			   Minimum */
    if (ipt3 > 0 && linbfq_1.inder != 0) {
	*iptype = 411;
    }
/* 			   Maximum , warning */
    if (ipt3 < 0 && linbfq_1.inder != 0) {
	*iptype = 412;
    }
/* 			   Minimum , warning */
    return;
} /* fpcodebf_ */

