/* fpdfunbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpdfunbf_(doublereal *x, doublereal *dfun, shortint *ndimm, shortint *nx, shortint *ier, shortint *istop)
{
    /* Initialized data */

    static doublereal eps0 = 1e-10;

    /* System generated locals */
    shortint s__1, s__2;
    integer dfun_dim1, dfun_offset;
    doublereal d__1;

    /* Local variables */
    doublereal f[NDIM-1];
    shortint i, j, k;
    doublereal r;
    doublereal dh, fp[NDIM-1], dhx;
    shortint nfp1, nxm1;

/*         ITERATED MAPS */
/*           31.08.1990 */
/*           16.11.92 */
/*           10.07.94 */

    /* Parameter adjustments */
    --x;
    dfun_dim1 = *ndimm;
    dfun_offset = dfun_dim1 + 1;
    dfun -= dfun_offset;

    /* Function Body */
    *ier = 0;
    *istop = 0;
    ++njac_1.njacb;
    der1bf_(nx, &dhf, &x[1], linbf2_1.d, funm_, ier);
    if (*ier < 0) {
	*istop = *ier;
    }
    if (*ier != 0) {
	return;
    }
    k = 0;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	s__2 = linbf_1.nf;
	for (j = 1; j <= s__2; ++j) {
	    ++k;
	    dfun[j + i * dfun_dim1] = linbf2_1.d[k - 1];
/* L10: */
	}
	dfun[i + i * dfun_dim1] += -1.;
/* L20: */
    }
    dh = fabs(add1b_1.dx);
    funbf_(&x[1], f, ier, istop);
    if (*ier != 0 || *istop != 0) {
	return;
    }
    nxm1 = *nx - 1;
    nfp1 = linbf_1.nf + 1;
    s__1 = *nx;
    for (i = nfp1; i <= s__1; ++i) {
	r = x[i];
	dhx = dh * (fabs(r) + 1.);
	x[i] = r + dhx;
	funbf_(&x[1], fp, ier, istop);
	x[i] = r;
	if (*ier != 0 || *istop != 0) {
	    return;
	}
	s__2 = nxm1;
	for (j = 1; j <= s__2; ++j) {
	    dfun[j + i * dfun_dim1] = (fp[j - 1] - f[j - 1]) / dhx;
	    if ((d__1 = dfun[j + i * dfun_dim1], fabs(d__1)) < eps0) {
		dfun[j + i * dfun_dim1] = 0.;
	    }
/* L30: */
	}
/* L40: */
    }
/*      PRINT 101,(X(I),I=1,NX) */
/* 101  FORMAT(1X,'X=',3G13.5) */
/*      PRINT 102,((DFUN(I,J),J=1,NX),I=1,NF) */
/* 102  FORMAT(1X,'D=',3G13.5) */
    if (*nx == linbf_1.nf + 1) {
	return;
    }
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	r = x[i];
	dhx = dh * (fabs(r) + 1.);
	x[i] = r + dhx;
	linbfo_1.indfun = 1;
	funbf_(&x[1], fp, ier, istop);
	linbfo_1.indfun = 0;
	x[i] = r;
	if (*ier != 0 || *istop != 0) {
	    return;
	}
	s__2 = nxm1;
	for (j = nfp1; j <= s__2; ++j) {
	    dfun[j + i * dfun_dim1] = (fp[j - 1] - f[j - 1]) / dhx;
	    if ((d__1 = dfun[j + i * dfun_dim1], fabs(d__1)) < eps0) {
		dfun[j + i * dfun_dim1] = 0.;
	    }
/* L50: */
	}
/* L60: */
    }
    return;
} /* fpdfunbf_ */

