/* fpeiglbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpeiglbf_(shortint *nk, doublereal *x, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1, d__2;

    /* Local variables */
    shortint jmin;
    shortint i, j;
    doublereal scale[NFMAX];
    doublereal r1, r2, r3, r4;
    doublereal pi;
    doublereal rmdmin;
    shortint nf1, igh, int_[NFMAX], low;
    doublereal pid2;


/*   COMPUTING AND PRINTING EIGENVALUES */
/*           ITERATED MAPS */
/*     31.08.1990 */
/*     16.11.92 */
/*     10.07.94 */

/*         IPR=0  - COMPUTING, */
/*         IPR=1  - COMPUTING AND PRINTING, */
/*         IPR=2  - PRINTING. */


    /* Parameter adjustments */
    --x;

    /* Function Body */
    if (linbfe_1.ipr == 2) {
	goto L40;
    }

    pi = atan(1.) * 4.;
    pid2 = pi / 2.;

/*   By~iClEHiE MATPicy liHEAPizAcii */

    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funm_, ier);
    if (*ier != 0) {
	goto L60;
    }

/*   By~iClEHiE CObCTBEHHyX zHA~EHij */

    dbalan_(&linbf_1.nf, &linbf_1.nf, linbf2_1.d, &low, &igh, scale);
    delmhe_(&linbf_1.nf, &linbf_1.nf, &low, &igh, linbf2_1.d, int_);
    dhqr_(&linbf_1.nf, &linbf_1.nf, &low, &igh, linbf2_1.d, linbfe_1.rr, 
	    linbfe_1.ri, ier);
    if (*ier != 0) {
	goto L50;
    }

/*   ORDERING EIGENVALUES BY MODULUS */

    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
/*        RMOD(I)=DSQRT(RR(I)*RR(I)+RI(I)*RI(I)) */
/* Computing 2nd power */
	d__1 = linbfe_1.rr[i - 1];
/* Computing 2nd power */
	d__2 = linbfe_1.ri[i - 1];
	linbee_1.rmod[i - 1] = sqrt(d__1 * d__1 + d__2 * d__2);
/* 	PRINT 801,I,RR(I),RI(I),WRK */
/*        WRK=RR(I)**2+RI(I)**2 */
/* 	PRINT 801,I,RR(I),RI(I),WRK */
/* 801    FORMAT('  EIGLBF: I,RR,RI,WRK= ',I2,3G15.6) */
/*        RMOD(I)=DSQRT(WRK) */
/* 	PRINT 802,RMOD(I) */
/* 802    FORMAT('  EIGLBF: RMOD=',G15.6) */
	if ((d__1 = linbfe_1.rr[i - 1] / linbee_1.rmod[i - 1], fabs(d__1)) > 
		.5) {
	    linbee_1.arg[i - 1] = atan((d__2 = linbfe_1.ri[i - 1] / 
		    linbfe_1.rr[i - 1], fabs(d__2)));
	}
/* 	PRINT 803,ARG(I) */
/* 803    FORMAT('  EIGLBF: case 1  ARG=',G15.6) */
	if ((d__1 = linbfe_1.rr[i - 1] / linbee_1.rmod[i - 1], fabs(d__1)) <= 
		.5) {
	    linbee_1.arg[i - 1] = pid2 - atan((d__2 = linbfe_1.rr[i - 1] / 
		    linbfe_1.ri[i - 1], fabs(d__2)));
	}
/* 	PRINT 804,ARG(I) */
/* 804    FORMAT('  EIGLBF: case 2  ARG=',G15.6) */
	if (linbfe_1.rr[i - 1] < 0.) {
	    linbee_1.arg[i - 1] = pi - linbee_1.arg[i - 1];
	}
	if (linbfe_1.ri[i - 1] < 0.) {
	    linbee_1.arg[i - 1] = -linbee_1.arg[i - 1];
	}
	linbee_1.arg[i - 1] = linbee_1.arg[i - 1] / pi * 180.;
/* L15: */
    }
    nf1 = linbf_1.nf - 1;
    s__1 = nf1;
    for (j = 1; j <= s__1; ++j) {
	rmdmin = linbee_1.rmod[j - 1];
	jmin = j;
	s__2 = nf1;
	for (i = j; i <= s__2; ++i) {
	    if (linbee_1.rmod[i] >= rmdmin) {
		goto L20;
	    }
	    rmdmin = linbee_1.rmod[i];
	    jmin = i + 1;
L20:
	    ;
	}
	if (jmin == j) {
	    goto L30;
	}
	r1 = linbfe_1.rr[j - 1];
	r2 = linbfe_1.ri[j - 1];
	r3 = linbee_1.rmod[j - 1];
	r4 = linbee_1.arg[j - 1];
	linbfe_1.rr[j - 1] = linbfe_1.rr[jmin - 1];
	linbfe_1.ri[j - 1] = linbfe_1.ri[jmin - 1];
	linbee_1.rmod[j - 1] = linbee_1.rmod[jmin - 1];
	linbee_1.arg[j - 1] = linbee_1.arg[jmin - 1];
	linbfe_1.rr[jmin - 1] = r1;
	linbfe_1.ri[jmin - 1] = r2;
	linbee_1.rmod[jmin - 1] = r3;
	linbee_1.arg[jmin - 1] = r4;
L30:
	;
    }

/*   PRINTING EIGENVALUES */

    if (linbfe_1.ipr == 0) {
	return;
    }
L40:
    return;

/*   ObPAbOTKA B Clu~AE HEBy~iClEHiq CObCTBEHHyX zHA~EHij */

L50:
    return;
L60:
    return;
} /* fpeiglbf_ */

