/* fpquadr.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpquadr_(shortint *nk, doublereal *x, doublereal *qdr, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    shortint i, j, k, l, irang;
    doublereal r1, r2;
    shortint nd;
    doublereal ds[NFMAX2], r32;
    doublereal dh0;
    shortint ndh;
    doublereal eps;
    shortint nfp1;


/*   COMPUTING THE COEFFICIENT ON SECOND-ORDER TERM */
/*            ITERATED MAPS */
/*        24.02.1990 */
/*        02.09.1990 */
/*        16.11.92 */
/*        10.07.94 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L10: */
    }

/*   COMPUTING JACOBY MATRIX */

    dh0 = dhf;
    ndh = 0;
    dervar_(&linbf_1.nf, &linbf_1.nf2, &dh0, &ndh, &x[1], linbf2_1.d, ds, 
	    der1l_, funm_, ier);
    if (*ier != 0) {
	return;
    }
    modjac_(nk, &x[1], linbf2_1.d, ier);
    if (*ier != 0) {
	return;
    }


    linbf_1.nf2 = linbf_1.nf * linbf_1.nf;
    nfp1 = linbf_1.nf + 1;
    s__1 = linbf_1.nf2;
    s__2 = nfp1;
    for (i = 1; s__2 < 0 ? i >= s__1 : i <= s__1; i += s__2) {
	linbf2_1.d[i - 1] += -1.;
/* L15: */
    }
/*   NF=1 */
    if (linbf_1.nf == 1) {
	goto L60;
    }
/*   NF>1 */
    l = 1;
    s__2 = linbf_1.nf;
    for (i = 1; i <= s__2; ++i) {
	k = i;
	s__1 = linbf_1.nf;
	for (j = 1; j <= s__1; ++j) {
	    ds[l - 1] = linbf2_1.d[k - 1];
	    ++l;
	    k += linbf_1.nf;
/* L20: */
	}
/* L30: */
    }

/*   COMPUTING RIGHT EIGENVECTOR CORRESPONDIND UNITY EIGENVALUE */

    eps = 0.01;
    dvgaus_(&linbf_1.nf, &linbf_1.nf, linbf2_1.d, quavec_1.vec1, &eps, &irang)
	    ;
    if (irang != linbf_1.nf - 1) {
	goto L100;
    }

/*   COMPUTING LEFT EIGENVECTOR CORRESPONDIND UNITY EIGENVALUE */

    dvgaus_(&linbf_1.nf, &linbf_1.nf, ds, quavec_1.vec2, &eps, &irang);
/*     PRINT 901,IRANG */
    if (irang != linbf_1.nf - 1) {
	goto L100;
    }

/*   SCALING EIGENVECTORS */

    r1 = 0.;
    r2 = 0.;
    r32 = 0.;
    s__2 = linbf_1.nf;
    for (i = 1; i <= s__2; ++i) {
/* Computing 2nd power */
	d__1 = quavec_1.vec1[i - 1];
	r1 += d__1 * d__1;
/* Computing 2nd power */
	d__1 = quavec_1.vec2[i - 1];
	r2 += d__1 * d__1;
	r32 += quavec_1.vec3[i - 1] * quavec_1.vec2[i - 1];
/* L40: */
    }
    r1 = 1. / sqrt(r1);
    r2 = 1. / sqrt(r2);
    if (r32 < 0.) {
	r2 = -r2;
    }
    s__2 = linbf_1.nf;
    for (i = 1; i <= s__2; ++i) {
	quavec_1.vec1[i - 1] = r1 * quavec_1.vec1[i - 1];
	quavec_1.vec2[i - 1] = r2 * quavec_1.vec2[i - 1];
	quavec_1.vec3[i - 1] = quavec_1.vec2[i - 1];
/* L50: */
    }
    goto L70;

/*   EIGENVECTORS FOR CASE NF=1 */

L60:
    quavec_1.vec1[0] = 1.;
    quavec_1.vec2[0] = 1.;
    quavec_1.vec3[0] = 1.;

/*   COMPUTING SECOND DERIVATIVE */

L70:
    nd = 1;
    dh0 = 1e-4;
    ndh = 0;
    dervar_(&linbf_1.nf, &nd, &dh0, &ndh, &x[1], linbf2_1.d, ds, der2q_, 
	    funm_, ier);
    if (*ier != 0) {
	return;
    }
    *qdr = linbf2_1.d[0];
    return;
L100:
    *ier = irang + 1;
    return;
} /* fpquadr_ */

