#include <stdio.h>

#ifndef _LOCLBF_H_
#define _LOCLBF_H_

#define NFMAX 80
#define NDIM 84
#define IFMAX 20
#define NPTYP 4
#define NDIM1 (NDIM-1)
#define NPARMX 10
#define NACTMX 4
#define IUFMAX 80
#define NBFVL 5
#define NRPC 40
#define NRVC (3*NFMAX+NPARMX+IUFMAX+1)
#define NVALPT 10
#define NFMAX2 (NFMAX*NFMAX)
#define NPTYP1 (NPTYP+1)
#define NUMTRANS 13
#define NBUF 10
#define NHRVC (NFMAX+NPARMX+IUFMAX+1)
#define NFMAX1 (NFMAX+1)
#define NU ((2*NFMAX-1)*(2*NFMAX-1))
#define NPTYP2 (NPTYP1+1)
#define NFMX2d (NFMAX*NFMAX*2)
#define NDS ((NFMAX-2)*(NFMAX-2))
#define MMAX (13+(NFMAX-2)*8)

#define doublereal double
#define shortint short int
#define integer int
#define shortlogical short int
#define logical int
#define ftnlen int
#define FALSE_ 0
#define TRUE_ 0
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif

#include "prototypes.h"

extern void epmessng_( int linetype, int pointtype, double *bifval, char *text);
extern void fpmessng_( int linetype, int pointtype, double *bifval, char *text);
extern void lcmessng_( int linetype, int pointtype, double *bifval, char *text);
extern void psmessng_( int linetype, int pointtype, double *bifval, char *text);
extern void messng_( int linetype, int pointtype, double *bifval, char *text );
extern void fplinlbf_(int ikr, int n, doublereal *x0, int npar, doublereal *p0, doublereal *pmin, doublereal *pmax, int nap1, shortint *iap, double h0, double e, shortint *iend);
extern void comput_(int idir);
extern void errmsg_( int what );
extern void messag_( char *text, int nnpt, int linetype, int pointtype, int n, int m, int l, doublereal *bifval, shortint *iend, ftnlen text_len);
extern void proto_( int n, int m, int l, char *linetype, shortint *ierr );
extern void protc_(void);
extern void protte_( char *text );
extern void protoc_( int n, int m, int l, double *x, double *p, double *g, double *t, double *rr, double *ri, double *bifval, shortint *line, shortlogical *actpar, int pointtype, int npt, shortint *ierr );
extern void showbe_( int indstp, double hcur, double hnew );
extern void funadd_( char *funnam, shortint *ierr, doublereal *x, doublereal *funres );
extern void psinitnm_(void);
extern void fpoutpt_(doublereal *xp, int npc, doublereal *t, shortint *istop);
extern void lcinitnm_(void);
extern void psoutpt_(doublereal *xp, int npc, doublereal *t, shortint *istop);
extern void epinitnm_(void);
extern void initnm_(void);
extern void diagno_(shortint *iend);
extern void recomp_(void);
extern void showit_( int niter, double epsn, double anormf );
extern void userfun_( shortint *ifn, shortint *ierr, doublereal *pcoord, doublereal *funres);
extern void funt_( doublereal *t, doublereal *x, doublereal *f );
extern void store_(FILE *ncan, shortint *pointtype, shortint *npt, shortint *n, shortint *m, shortint *l, doublereal *x, doublereal *p, doublereal *g, doublereal *t, doublereal *rr, doublereal *ri, doublereal *bifval, shortint *ierr);
extern void endmes_( char *text, shortint *iend, shortint *n, shortint *m, shortint *l, doublereal *x, doublereal *p, doublereal *g, doublereal *t, doublereal *rr, doublereal *ri, doublereal *bifval );
extern void storec_( FILE *ncan );
extern void storer_( FILE *ncan );
extern FILE *storeo_( int ncan );
extern void setch_( char *strng, int cmntyp, int index );
extern void epoutpt_(doublereal *xp, int npc, doublereal *t, shortint *istop );
extern void lcoutpt_(doublereal *xp, int npc, doublereal *t, shortint *istop );
extern void outpt_( doublereal *xp, int npc, doublereal *t, shortint *istop );
extern void outdum_( int n, doublereal *t, doublereal *x, doublereal *h, int icode, shortint *istop );
extern double dhf;
extern short wrt;
extern short npt;
extern short maxnpt;
extern short isound;
extern short messag;
extern short iflash;
extern FILE *fp7;
extern FILE *fp8;


extern struct add1b__ {
  doublereal dx, hvmn, hvmx;
} add1b_;
#define add1b_1 add1b_

extern struct ierfs__ {
  shortint ierfs, ierdum;
} ierfs_;
#define ierfs_1 ierfs_

extern struct stat__ {
  shortint nfcn, nstep, naccpt, nrejct, ndec, nsol;
} stat_;
#define stat_1 stat_

extern struct cdop5__ {
  doublereal reltol, rmeth, alg;
} cdop5_;
#define cdop5_1 cdop5_

extern struct contrh__ {
  doublereal cdemp, rmode, angmax, angmin, angcrv;
} contrh_;
#define contrh_1 contrh_

extern struct wrto6__ {
  shortint itc, it2;
} wrto6_;
#define wrto6_1 wrto6_

extern struct ihomp__ {
  shortint ihomp;
} ihomp_;
#define ihomp_1 ihomp_

extern struct funval__ {
  doublereal fval[NDIM];
} funval_;
#define funval_1 funval_

extern struct scaleb__ {
  doublereal scx[NDIM];
} scaleb_;
#define scaleb_1 scaleb_

extern struct add3a__ {
  shortint nuf, iprzer, ifuns[IFMAX];
} add3a_;
#define add3a_1 add3a_

extern struct nampar__ {
  char *nampar1[NRPC];
} nampar_;
#define nampar_1 nampar_

extern struct parnum__ {
  shortint ncpar;
} parnum_;
#define parnum_1 parnum_

extern struct lntp__ {
  char *lntp[20];
} lntp_;
#define lntp_1 lntp_

extern struct real__ {
  doublereal rvc[NRVC], rpc[NRPC], rlim[4];
} real_;
#define real_1 real_

extern struct logic__ {
  shortlogical active[NRVC], state, inst;
} logic_;
#define logic_1 logic_

extern struct integ__ {
  shortint k, iline, nvar, id[NRVC], linetype, ix, iy;
} integ_;
#define integ_1 integ_

extern struct linbf__ {
  shortint nf, nap, iln, nf2, itp;
} linbf_;
#define linbf_1 linbf_

extern struct linbfq__ {
  shortint ipt[NPTYP1], inder, ival[NVALPT], istp;
} linbfq_;
#define linbfq_1 linbfq_

extern struct linbfr__ {
  doublereal valpt[NVALPT];
} linbfr_;
#define linbfr_1 linbfr_

extern struct linbfw__ {
  doublereal funh[IFMAX], arclng, rnpt;
} linbfw_;
#define linbfw_1 linbfw_

extern struct wrto1__ {
  shortint nfix1, nfix;
} wrto1_;
#define wrto1_1 wrto1_

extern struct wrto2__ {
  doublereal dmove1, dmove;
} wrto2_;
#define wrto2_1 wrto2_

extern struct ppar__ {
  doublereal p[NPARMX];
} ppar_;
#define ppar_1 ppar_

extern struct ippar__ {
  shortint ip[NPARMX];
} ippar_;
#define ippar_1 ippar_

extern struct work__ {
  doublereal dxp[(NFMAX+1)*(NFMAX+1)];
} work_;
#define work_1 work_

extern struct linbf2__ {
  doublereal d[NFMAX2];
} linbf2_;
#define linbf2_1 linbf2_

extern struct linbfo__ {
  shortint indfun;
} linbfo_;
#define linbfo_1 linbfo_

extern struct njac__ {
  shortint njac, njacn, njacb;
} njac_;
#define njac_1 njac_

extern struct linbf3__ {
  doublereal eps, hv0;
} linbf3_;
#define linbf3_1 linbf3_

extern struct linbfc__ {
  doublereal al[NPARMX], ar[NPARMX];
} linbfc_;
#define linbfc_1 linbfc_

extern struct linbfe__ {
  doublereal rr[NFMAX], ri[NFMAX];
  shortint ipr;
} linbfe_;
#define linbfe_1 linbfe_

extern struct linbfn__ {
  shortint iold;
} linbfn_;
#define linbfn_1 linbfn_

extern struct linbfp__ {
  shortint igran;
} linbfp_;
#define linbfp_1 linbfp_

extern struct quavec__ {
  doublereal vec1[NFMAX], vec2[NFMAX], vec3[NFMAX];
} quavec_;
#define quavec_1 quavec_

extern struct add1a__ {
  shortint ipr, nstep, ncan;
} add1a_;
#define add1a_1 add1a_

extern struct add2a__ {
  shortint icrs, iprcrs;
} add2a_;
#define add2a_1 add2a_

extern struct add2b__ {
  doublereal epscrs;
} add2b_;
#define add2b_1 add2b_

extern struct add3b__ {
  doublereal epszer;
} add3b_;
#define add3b_1 add3b_

extern struct add4a__ {
  shortint nue, iprext, ivars[NDIM];
} add4a_;
#define add4a_1 add4a_

extern struct add4b__ {
  doublereal epsext;
} add4b_;
#define add4b_1 add4b_

extern struct add5a__ {
  doublereal pxgmn, pxgmx;
} add5a_;
#define add5a_1 add5a_

extern struct add6a__ {
  doublereal xgmn, xgmx;
} add6a_;
#define add6a_1 add6a_

extern struct add7a__ {
  doublereal epsnwt;
} add7a_;
#define add7a_1 add7a_

extern struct add7b__ {
  shortint itnwt;
} add7b_;
#define add7b_1 add7b_

extern struct ipsng__ {
  shortint ipsng1, ipsng2;
} ipsng_;
#define ipsng_1 ipsng_

extern struct linbfm__ {
  doublereal dhold, derold[NFMAX2], xold[NDIM];
} linbfm_;
#define linbfm_1 linbfm_

extern struct work5__ {
  doublereal u[NU];
} work5_;
#define work5_1 work5_

extern struct itmap__ {
  shortint itmap;
} itmap_;
#define itmap_1 itmap_

extern struct intgr__ {
  doublereal tmaxi, hi, epsai, epsri, dhi, hmxi, hmni, solver, rmxstp;
} intgr_;
#define intgr_1 intgr_

extern struct intout__ {
  shortint iout, idirec;
} intout_;
#define intout_1 intout_

extern struct npnt__ {
  shortint np;
} npnt_;
#define npnt_1 npnt_

extern struct out1__ {
  doublereal g[IFMAX];
} out1_;
#define out1_1 out1_

extern struct linbee__ {
  doublereal rmod[NFMAX], arg[NFMAX];
} linbee_;
#define linbee_1 linbee_

extern struct linbfu__ {
  doublereal arcl, prp[NDIM], sc[NBUF], sca[NBUF];
} linbfu_;
#define linbfu_1 linbfu_

extern struct linbfv__ {
  shortint npc, nbf, ns[NBUF];
} linbfv_;
#define linbfv_1 linbfv_

extern struct iabort__ {
  shortint iabort;
} iabort_;
#define iabort_1 iabort_

extern struct adrhs__ {
  shortint iadrhs, ifnint;
} adrhs_;
#define adrhs_1 adrhs_

extern struct mswtch__ {
  shortint mflag;
} mswtch_;
#define mswtch_1 mswtch_

extern struct nmlit__ {
  shortint n, m, l, it;
} nmlit_;
#define nmlit_1 nmlit_

extern struct lnnm__ {
  shortint lnnm;
} lnnm_;
#define lnnm_1 lnnm_

extern struct nfuns__ {
  integer nfuns;
} nfuns_;
#define nfuns_1 nfuns_

extern struct inifvl__ {
  shortint ifvl;
} inifvl_;
#define inifvl_1 inifvl_

extern struct isec__ {
  shortint isec;
} isec_;
#define isec_1 isec_

extern struct out2__ {
  shortint indz, ierf[IFMAX];
} out2_;
#define out2_1 out2_

extern struct out4__ {
  doublereal epsz, epszr, fzero;
} out4_;
#define out4_1 out4_

extern struct out6__ {
  shortint inde;
} out6_;
#define out6_1 out6_

extern struct out7__ {
  shortint indc;
} out7_;
#define out7_1 out7_

extern struct out8__ {
  shortint indout;
} out8_;
#define out8_1 out8_

extern struct iorbit__ {
  shortint iorbit;
} iorbit_;
#define iorbit_1 iorbit_

extern struct ih__ {
  shortint ih;
} ih_;
#define ih_1 ih_

extern struct soldot__ {
  shortint soldot;
} soldot_;
#define soldot_1 soldot_

extern struct initv__ {
  shortint init;
} initv_;
#define initv_1 initv_

extern struct epsh0__ {
  doublereal epscrv, h0crv;
} epsh0_;
#define epsh0_1 epsh0_

extern struct np123__ {
  shortint np1, np2, np3;
} np123_;
#define np123_1 np123_

extern struct h__ {
  doublereal h;
} h_;
#define h_1 h_

extern struct mesblk__ {
  char textcm[60];
} mesblk_;
#define mesblk_1 mesblk_

extern struct wrto4__ {
  doublereal epsc, epsn;
} wrto4_;
#define wrto4_1 wrto4_

extern struct corr1__ {
  doublereal det, cond, sgndet;
} corr1_;
#define corr1_1 corr1_

extern struct all1__ {
  doublereal xgmn, xgmx;
} all1_;
#define all1_1 all1_

extern struct all2__ {
  shortint ipoisk;
} all2_;
#define all2_1 all2_

extern struct all3__ {
  shortint ibnd;
} all3_;
#define all3_1 all3_

extern struct cnwt1__ {
  shortint ipnt1;
} cnwt1_;
#define cnwt1_1 cnwt1_

extern struct curpnt__ {
  doublereal xcur[NDIM];
} curpnt_;
#define curpnt_1 curpnt_

extern struct secpl__ {
  doublereal pl[NFMAX+1];
} secpl_;
#define secpl_1 secpl_

extern struct pq__ {
  doublereal p[NFMAX*NFMAX], q[NFMAX*NFMAX];
} pq_;
#define pq_1 pq_

extern struct wrte1__ {
  doublereal hmin, hmax;
} wrte1_;
#define wrte1_1 wrte1_

extern struct comp__ {
  shortlogical comp, stop, auto_;
} comp_;
#define comp_1 comp_

extern struct line0__ {
  shortint line0;
} line0_;
#define line0_1 line0_

extern struct xycolo__ {
  shortint xycolor[16];
} xycolo_;
#define xycolo_1 xycolo_

extern struct all4__ {
  doublereal detstp;
} all4_;
#define all4_1 all4_

extern struct updt__ {
  shortlogical updt;
} updt_;
#define updt_1 updt_

extern struct color__ {
  shortint colortype, fillcolor;
} color_;
#define color_1 color_

extern struct drawl__ {
  shortint rdraw1[4], rdraw[4], rmsg[4], rline[4];
} drawl_;
#define drawl_1 drawl_

extern struct ix0iy0__ {
  shortint ix0, iy0;
} ix0iy0_;
#define ix0iy0_1 ix0iy0_

extern struct wrto7__ {
  doublereal vmove[NDIM], vmovn[NDIM];
} wrto7_;
#define wrto7_1 wrto7_

extern struct workbe__ {
  doublereal dfun[NDIM*NDIM], a[NDIM*NDIM];
} workbe_;
#define workbe_1 workbe_

extern struct leqv1__ {
  doublereal detl, condl;
} leqv1_;
#define leqv1_1 leqv1_

extern struct dern1__ {
  doublereal dx;
} dern1_;
#define dern1_1 dern1_

extern struct bfvl__ {
  doublereal bifval[NBFVL];
} bfvl_;
#define bfvl_1 bfvl_

extern struct error__ {
  shortint ier;
} error_;
#define error_1 error_

extern struct checkn__ {
  doublereal epsnad, epsnnf;
} checkn_;
#define checkn_1 checkn_

extern struct zero2__ {
  shortint ifunsa[IFMAX];
} zero2_;
#define zero2_1 zero2_

extern struct stname__ {
  char fstor[NFMAX], fstor1[NFMAX];
} stname_;
#define stname_1 stname

extern struct numflg__ {
  shortint numflg;
} numflg_;
#define numflg_1 numflg_

extern struct keyflg__ {
  shortint keyflg, keycode;
} keyflg_;
#define keyflg_1 keyflg_

extern struct jpos__ {
  shortint j, pos;
} jpos_;
#define jpos_1 jpos_

extern struct maxline__ {
  shortint maxline;
} maxline_;
#define maxline_1 maxline_




extern char nc[][7];
extern char vc[][14];
extern char pc[][14];
extern char lim[][14];

#include "../locpanels/locpanels.h"

#endif
