/* pslinlbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void pslinlbf_(shortint *ikr, shortint *n, doublereal *x0, shortint *npar, doublereal *p0, doublereal *pmin, doublereal *pmax, shortint *nap1, shortint *iap, doublereal *h0, doublereal *e, shortint *iend)
{
    /* Initialized data */

    static shortint iadd[7] = { 1,1,1,1,1,0,1 };

    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    shortint icol[NDIM];
    doublereal dfun[NDIM*(NDIM-1)];
    shortint irow[NDIM];
    doublereal f[NDIM];
    shortint i, k;
    doublereal r, x[NDIM];
    shortint irank, istop, ng, nk;
    doublereal epstan;
    shortint nk1, ier;


/* ------------------------------------------------------------------- */
/*   A PACKAGE FOR CONTINUATION AND BIFURCATION ANALYSIS */
/*   OF FIXED POINTS AND PERIODIC ORBITS OF ITERATED MAPS */
/*                X'=F(X,P) */

/*   AUTHORS:  A.I.KHIBNIK AND E.V.NIKOLAEV */

/*             INSTITUTE OF MATHEMATICAL PROBLEMS IN BIOLOGY */
/*               (former RESEARCH COMPUTING CENTRE) */
/*             RUSSIAN ACADEMY OF SCIENCES */
/*             PUSHCHINO MOSCOW REGION */
/*             142292 RUSSIA */

/*   VERSION OF  19 DECEMBER 1990 */

/*     (LAST REVISION 08.08.1991, 16.11.92, 10.07.94) */
/* ------------------------------------------------------------------- */

/*   SHORT DESCRIPTION. */

/*   A. INPUT PARAMETERS. */
/*      ---------------- */

/*   IKR    - THE CODE OF THE CURVE (SEE BELOW) */
/*   N      - DIMENSION OF THE SYSTEM (N.LE.10) */
/*   X0     - INITIAL VALUES OF STATE VARIABLES */
/*            (VECTOR OF THE LENGTH N) */
/*   NPAR   - NUMBER OF CONTROL PARAMETERS (NPAR.LE.10) */
/*   P0     - INITIAL VALUES OF THE CONTROL PARAMETERS */
/*            (VECTOR OF THE LENGTH NPAR) */
/*   PMIN   - LOWER LIMITS OF THE CONTROL PARAMETERS */
/*            (VECTOR OF THE LENGTH NPAR) */
/*   PMAX   - UPPER LIMITS OF THE CONTROL PARAMETERS */
/*            (VECTOR OF THE LENGTH NPAR) */
/*   NAP1   - NUMBER OF ACTIVE (FREE) PARAMETERS (NAP1.LE.4) */
/*   IAP    - INDICES OF THE ACTIVE PARAMETERS */
/*            (INTEGER VECTOR OF THE LENGTH NAP1) */
/*   H0     - INITIAL STEP SIZE GUESS */
/*   E      - ACCURACY OF CURVE COMPUTATION */

/*   B. OUTPUT PARAMETERS. */
/*      ----------------- */

/*   IEND   - REPORTS ON SUCCESSFULNESS AND FINAL STATE UPON RETURN */

/*            IEND>0 - COMPUTATION SUCCESSFUL: */
/*             1  -  GIVEN NUMBER OF STEPS DONE, */
/*             2  -  BOUNDARY VALUE OF A CONTROL PARAMETER REACHED, */
/*             3  -  CLOSED CURVE FOUND, */
/*             4  -  THE SAME AS IEND=2, BUT WITHOUT PRECISE LOCATION */
/*                   OF THE BOUNDARY POINT. */

/*            IEND<0 -  COMPUTATION UNSUCCESSFUL: */
/*            -1  -  ERROR IN INPUT DATA, */
/*            -2  -  CAN'T FIND FIRST POINT ON A CURVE */
/*            -3  -  CURRENT STEP SIZE LESS THEN MINIMAL */
/*            -4  -  CAN'T FIND TANGENT VECTOR AT THE FIRST POINT */
/*            -5  -  COMPUTATIONS INTERRUPTED IN USER'S SUBROUTINE */
/*            -6  -  NOT USED IN THIS VERSION */
/*            -7  -  CAN'T COMPUTE RHS VALUES AT INITIAL POINT */
/*            -8  -  CAN'T FIND JACOBY MATRIX AT INITIAL POINT */
/*            -9  -  CAN'T FIND TANGENT VECTOR AT INITIAL POINT */

/*   C. USER-SUPPLIED SUBROUTINES. */
/*      ------------------------- */

/*   1. SUBROUTINE TO COMPUTE RIGHT HAND SIDES OF THE SYSTEM */

/*                SUBROUTINE FUNM(X,F) */
/*                REAL*8 X(1),F(1),P(1) */
/*                INTEGER*2 IERFS */
/*                COMMON /PPAR/  P */
/*                COMMON /IERFS/ IERFS */
/*                F(1)=... */

/*                F(N)=... */
/*                IERFS=... */
/*                RETURN */
/*                END */

/*    HERE: */
/*           X - VECTOR OF STATE VARIABLES, */
/*           P - VECTOR OF CONTROL PARAMETERS, */
/*           F - VECTOR OF COMPUTED RHS VALUES. */
/*    IERFS=0 INDICATE THAT RHS COMPUTED SUCCESSFULLY, */
/*            OTHERWISE IERFS SHOULD BE ASSIGNED TO NONZERO VALUE. */
/*                 ----------------- */

/*   2. SUBROUTINE TO SET NEW VALUES OF COMPUTATIONAL PARAMETERS */
/*       INSTEAD OF DEFAULT ONES (OPTIONAL) */

/*                SUBROUTINE INITBF */
/*                IMPLICIT REAL*8 (A-H,O-Z) */
/*                IMPLICIT INTEGER*2 (I-N) */
/*                COMMON ... */

/*                RETURN */
/*                END */

/*       SEE COMMENTS IN THE TEXT OF INITBF. */
/*                 ----------------- */

/*   3. SUBROUTINES TO ORGANIZE USER'S OUTPUT */
/* ----------------------------------------------------------------- */
/*       20.09.1990 */

    /* Parameter adjustments */
    --x0;
    --pmax;
    --pmin;
    --p0;
    --iap;

    /* Function Body */
/*      IKR:       -1 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 */
/*                   18 19 20 21 22 23 24 */
/*      DATA ITYPE / 1,2,3,4,0,5,0,0,0,0,0, 0, 6, 7, 8, 9,10,11,12, */
/*     *               0, 0, 0,13,14,15,16/ */

/*      DATA ICFN / */
/*     *            1,5, */

/*   SPECIFYING INTERNAL PARAMETERS */

    nfuns_1.nfuns = 0;
    njac_1.njac = 0;
    njac_1.njacn = 0;
    njac_1.njacb = 0;
    ier = 0;
    istop = 0;
    ierfs_1.ierfs = 0;
    ipsng_1.ipsng1 = 1;
    ipsng_1.ipsng2 = 2;
    intout_1.iout = 0;
    intout_1.idirec = 1;
    linbf_1.nf = *n;
    linbf_1.nf2 = linbf_1.nf * linbf_1.nf;
    linbf_1.nap = *nap1;
    linbf_1.iln = *ikr;
/*      ITP=ITYPE(IKR+2) */
    dhf = 1e-7;
    nk = linbf_1.nf + linbf_1.nap;
    nk1 = nk - 1;
    ng = *n + 1;
/*      XGMN=PMIN(IAP(1)) */
/*      XGMX=PMAX(IAP(1)) */
    linbf3_1.eps = *e;
    linbf3_1.hv0 = *h0;
/*      NSTEP=500 */
    add1b_1.dx = -1e-7;
    linbfn_1.iold = 0;
    linbfo_1.indfun = 0;
    linbfp_1.igran = 0;
    inifvl_1.ifvl = 0;
    itmap_1.itmap = 1;

/* ---------------------------------------------- */
/*      IPRB=-2 */
/*      HVMN=1.D-10 */
/*      HVMX=100.*DABS(H0) */
/*      ICRS=0 */
/*      IPRCRS=-1 */
/*      EPSCRS=EPS */
/*      NUE=NAP */
/*      IPREXT=-1 */
/*      EPSEXT=EPS */
/*      DO 10 I=1,NAP */
/*        IVARS(I)=NF+I */
/* 10   CONTINUE */
/*      IPRZER=-1 */
/*      EPSZER=EPS */
/* ---------------------------------------------- */

    *iend = -6;
/*      SELECT CASE (ILN) */
/*         CASE (-1,0) */
    if (linbf_1.iln == -1 || linbf_1.iln == 0) {
	if (linbf_1.nap != 1) {
	    return;
	}
    }
/*         CASE (1,2,3,4) */
    if (linbf_1.iln == 1 || linbf_1.iln == 2 || linbf_1.iln == 3 || 
	    linbf_1.iln == 4) {
	if (linbf_1.nap != 2) {
	    return;
	}
    }
/*         CASE (11,12,13,14,15,16,17,18,19) */
    if (linbf_1.iln == 11 || linbf_1.iln == 12 || linbf_1.iln == 13 || 
	    linbf_1.iln == 14 || linbf_1.iln == 15 || linbf_1.iln == 16 || 
	    linbf_1.iln == 17 || linbf_1.iln == 18 || linbf_1.iln == 19) {
	if (linbf_1.nap != 3) {
	    return;
	}
    }
/*         CASE DEFAULT */
/*           RETURN */
/*      END SELECT */
    *iend = 0;

    add3a_1.nuf = 0;

    if (linbf_1.iln != 0) {
	goto L11;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 3;
    add3a_1.ifuns[3] = 4;
    goto L100;

L11:
    if (linbf_1.iln != 1) {
	goto L12;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 5;
    add3a_1.ifuns[3] = 4;
    goto L100;

L12:
    if (linbf_1.iln != 2) {
	goto L13;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 4;
    goto L100;

L13:
    if (linbf_1.iln != 3) {
	goto L14;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 4;
    goto L100;

L14:
    if (linbf_1.iln != 4) {
	goto L21;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 3;
    goto L100;

L21:
    if (linbf_1.iln != 11) {
	goto L22;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 5;
    add3a_1.ifuns[1] = 3;
    goto L100;

L22:
    if (linbf_1.iln != 12) {
	goto L23;
    }
    add3a_1.nuf = 1;
    add3a_1.ifuns[0] = 1;
    goto L100;

L23:
    if (linbf_1.iln != 13) {
	goto L24;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 3;
    add3a_1.ifuns[1] = 5;
    goto L100;

L24:
    if (linbf_1.iln != 14) {
	goto L25;
    }
    add3a_1.nuf = 1;
    add3a_1.ifuns[0] = 1;
    goto L100;

L25:
    if (linbf_1.iln != 15) {
	goto L26;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 5;
    goto L100;

L26:
    if (linbf_1.iln != 16) {
	goto L27;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    goto L100;

L27:
    if (linbf_1.iln != 17) {
	goto L28;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 5;
    add3a_1.ifuns[3] = 4;
    goto L100;

L28:
    if (linbf_1.iln != 18) {
	goto L29;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 4;
    goto L100;

L29:
    if (linbf_1.iln != 19) {
	goto L100;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 4;
    goto L100;

L100:
    s__1 = *npar;
    for (i = 1; i <= s__1; ++i) {
	ppar_1.p[i - 1] = p0[i];
	linbfc_1.al[i - 1] = pmin[i];
	linbfc_1.ar[i - 1] = pmax[i];
/* L110: */
    }
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	x[i - 1] = x0[i];
	linbfe_1.rr[i - 1] = 0.;
	linbfe_1.ri[i - 1] = 0.;
	linbee_1.rmod[i - 1] = 0.;
	linbee_1.arg[i - 1] = 0.;
/* L120: */
    }
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = iap[i];
	ippar_1.ip[i - 1] = k;
	x[linbf_1.nf + i - 1] = p0[k];
/* L130: */
    }
    quavec_1.vec3[0] = 1.;
    s__1 = linbf_1.nf;
    for (i = 2; i <= s__1; ++i) {
	quavec_1.vec3[i - 1] = 0.;
/* L140: */
    }
    s__1 = nk;
    for (i = 1; i <= s__1; ++i) {
	scaleb_1.scx[i - 1] = 1.;
	funval_1.fval[i - 1] = 0.;
/* L145: */
    }

/*   PRINTING INPUT DATA */

    initbf_();
    funbf_(x, f, &ier, &istop);
    if (ier == 0 && istop == 0) {
	goto L150;
    }
    *iend = -7;
    goto L170;
L150:
    r = 0.;
    s__1 = nk - 1;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = f[i - 1];
	r += d__1 * d__1;
	if (inifvl_1.ifvl != 0) {
	    funval_1.fval[i - 1] = f[i - 1];
	}
/* L152: */
    }
    funval_1.fval[nk - 1] = sqrt(r);
    dfunbf_(x, dfun, &nk1, &nk, &ier, &istop);
    if (ier == 0 && istop == 0) {
	goto L161;
    }
    *iend = -8;
    goto L170;
L161:
    epstan = 1e-10;
    dmfgr_(dfun, &nk1, &nk, &epstan, &irank, irow, icol);
    if (irank == nk1) {
	goto L162;
    }
    *iend = -9;
    goto L170;
L162:
    ng = icol[nk - 1];
/*      PRINT 1101,IRANK,NG,(icol(i),i=1,nk),(dfun(nk1*nk1+i),i=1,nk1) */
/* 1101 FORMAT(/1x,'irank=',i2,'  ng=',i2,' icol=',6i3,/' dfun=',6g13.4) 
*/
    r = 1.;
    s__1 = nk1;
    for (i = 1; i <= s__1; ++i) {
	if (icol[i - 1] == linbf_1.nf + 1) {
	    r = dfun[nk1 * nk1 + i - 1];
	}
/* L163: */
    }
    if (fabs(r) < .001) {
	r = 0.;
    }
    if (r < 0.) {
	linbf3_1.hv0 = -linbf3_1.hv0;
    }

    beetle_(&nk, &ng, iadd, x, &linbf3_1.hv0, &linbf3_1.eps, funbf_, dfunbf_, 
	    outlbf_, iend);
L170:
    if (ierfs_1.ierfs != 0) {
	*iend = -5;
    }
    return;
} /* pslinlbf_ */

