#include <xview/xview.h>
#include <xview/panel.h>
#ifndef _LOCPANELS_H_
#define _LOCPANELS_H_

#include "lbmain_cui.h"
#include "lbstate/lbstate_cui.h"

extern lbmain_locbif_pu_objects    *Lbmain_locbif_pu;
extern struct Lbmain_Ds                 lbmain_ds;
extern struct Lbdisplay_Ds              lbdisplay_ds;
extern struct Lbsolver_Ds               lbsolver_ds;
extern struct Lbcont_Ds                 lbcont_ds;
extern struct Lbstate_Ds                lbstate_ds;
extern lcstate_locstatepu_objects       *Lcstate_locstatepu;

extern void lb_install (void);  
extern void lb_reset (void);  
extern void lbmain_open (int use_default, int left, int top, int width, int height);  
extern void lbmain_field_manager (void);  
extern void lbmain_init (void);  
extern void lbmain_panel_refresh (void);  
extern void lbmain_data_refresh (void);  
extern Menu_item lbmain_handler (Menu_item item, Menu_generate op);  
extern void lboption_build (int mode);  
extern int lbmain_sel_notify (Panel_item item, char *string, Xv_opaque client_data, Panel_list_op op, Event *event, int row);  
extern void lbmain_cont (Panel_item item, Event *event);  
extern void lbmain_solvr_notify (Panel_item item, Event *event);  
extern void lbmain_dsply_notify (Panel_item item, Event *event);  
extern Panel_setting lbmain_dir_notify (Panel_item item, Event *event);  
extern void lbrdfile_notify (Panel_item item, Event *event);  
extern Panel_setting lbfname_notify (Panel_item item, Event *event);  
extern void lbforw_notify (Panel_item item, Event *event);  
extern void lbcontinue_notify (Panel_item item, Event *event);  
extern void lbback_notify (Panel_item item, Event *event);  
extern void lbmode_notify (Panel_item item, int value, Event *event);  
extern void lbmain_locbif_pu_lbpause_notify_callback (Panel_item item, int value, Event *event);  
extern void lbcurst_notify (Panel_item item, Event *event);  
extern void lbmain_done_proc (Frame frame);  
extern void locbif_mem_go (void);  
extern void locbif_proc (void);  
extern void pack_parmcmn_locbif (void);  
extern void pack_statecmn_locbif (int dir);  
extern void update_state_locbif (void);  
extern void update_locbif (void);  
extern void pack_struct_locbif (void);  
extern void lb_rd_file (void);  
extern int getfv_ (double *x, double *t, double *f);  
extern int getufv_ (short int *ifn, double *x, double *t, double *f);  
extern void lbmem_ (double *x, short int *n, double *p, short int *m, double *t, short int *pointtype, short int *npt);  
extern int allocate_locbif (void);  
extern void release_locbif (void);  
extern void loclbf_halt_ (int *halt);  
extern void loclbf_halt__ (int *halt);  
extern void lbcont_open (int use_default, int left, int top, int width, int height);  
extern void lbcont_close (void);  
extern void lbcont_field_manager (void);  
extern void lbcont_init (void);
extern void lbcont_panel_refresh (void);  
extern void lbcont_data_refresh (void);  
extern Menu_item lbcont_batch_handler (Menu_item item, Menu_generate op);  
extern Panel_setting lbcont_rw_notify (Panel_item item, Event *event);  
extern void lbcalgcrv_notify (Panel_item item, int value, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbchmxcrv_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcangcrv_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcdhcrv_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcdhjac_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcmaxit_notify (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcepscrv_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcmodit_notify (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcepscrs_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcepszer_notify_callback (Panel_item item, Event *event);  
extern Panel_setting lbcipsrng_notify (Panel_item item, Event *event);  
extern Panel_setting lbcont_lbcontpu_lbcepsext_notify_callback (Panel_item item, Event *event);  
extern void lbcont_done_proc (Frame frame);  
extern void lbdisplay_open (int use_default, int left, int top, int width, int height);  
extern void lbdisplay_close (void);  
extern void lbdisplay_field_manager (void);  
extern void lbdisplay_init (void);  
extern void lbdisplay_panel_refresh (void);  
extern void lbdisplay_data_refresh (void);  
extern Menu_item lbdisplay_batch_handler (Menu_item item, Menu_generate op);  
extern Panel_setting lbd_notify (Panel_item item, Event *event);  
extern void lbdisplay_done_proc (Frame frame);  
extern void lbsolver_open (int use_default, int left, int top, int width, int height);  
extern void lbsolver_field_manager (void);  
extern void lbsolver_init (void);  
extern void lbsolver_panel_refresh (void);  
extern void lbsolver_data_refresh (void);  
extern Menu_item lbsolver_batch_handler (Menu_item item, Menu_generate op);  
extern Panel_setting lbs_notify (Panel_item item, Event *event);  
extern void lbsolver_done_proc (Frame frame);  
extern void lbstate_open (int use_default, int left, int top, int width, int height);  
extern void lbstate_field_manager (void);  
extern void lbc_destroy (void);  
extern int lbc_state_build (int *x);  
extern int lbc_param_build (int *x);  
extern int lbc_func_build (int *x);  
extern int lbc_char_build (int *x);  
extern void lbstate_init (void);  
extern void lbstate_panel_refresh (void);  
extern int update_mess_on_panel (void);  
extern void lbstate_data_refresh (void);  
extern Menu_item lbstate_batch_handler (Menu_item item, Menu_generate op);  
extern void lcstate_locstatepu_lcsel_notify_callback (Panel_item item, unsigned int value, Event *event);  
extern void ctype_notify (Panel_item item, unsigned int value, Event *event);  
extern void lcupdate_notify (Panel_item item, Event *event);  
extern void lbstate_done_proc (Frame frame);  
extern void lbmain_close(void);
extern void lbcont_init(void);
extern void lbsolver_close(void);
extern void lbstate_close(void);

#include "../cloclbf/loclbf.h"

#endif
